/*日期格式化*/
function convertDate(val, withWeek) {
    var year = Math.ceil(val / 10000) - 1;
    var day = val % 100;
    var month = (Math.ceil(val / 100) - 1) % 100;
    var d = new Date();
    d.setYear(year);
    d.setMonth(month - 1);
    d.setDate(day);
    if (month < 10) month = '0' + month;
    if (day < 10) day = '0' + day;
    if (withWeek) {
        var weekNames = ['日', '一', '二', '三', '四', '五', '六'];
        return year + '/' + month + '/' + day + '/' + weekNames[d.getDay()];
    }
    else {
        return year + '-' + month + '-' + day;
    }
}
//分钟数转换为时间
function formatFZS(val) {
    var hour = parseInt(val / 60);
    if (hour < 10) {
        hour = "0" + hour;
    }
    var minute = val - parseInt(val / 60) * 60;
    if (minute == 0) {
        minute = "00";
    }
    if (minute < 10 && minute > 0) {
        minute = "0" + minute;
    }
    return hour + ":" + minute;
}
function convertTime(val) {
    var hour = Math.ceil(val / 10000) - 1;
    var minter = (Math.ceil(val / 100) - 1) % 100;
    if (minter < 10) {
        minter = "0" + minter;
    }

    return hour + ':' + minter;
}
function getWidth(txt, font) {
    ctx.font = font;
    return ctx.measureText(txt).width;
}
/*画虚线方法*/
function dashedLine(x, y, x2, y2, dashArray) {
    if (!dashArray) dashArray = [2, 2];
    var dashCount = dashArray.length;
    ctx_bg.lineWidth = 2;
    ctx_bg.moveTo(x, y);
    var dx = (x2 - x), dy = (y2 - y);
    if (x == x2) {
        var slope = dx / dy;
    } else if (y == y2) {
        var slope = dy / dx;
    }
    var distRemaining = Math.sqrt(dx * dx + dy * dy);
    var dashIndex = 0, draw = true;
    while (distRemaining >= 0.1) {
        var dashLength = dashArray[dashIndex++ % dashCount];
        if (dashLength > distRemaining) dashLength = distRemaining;
        var xStep = Math.sqrt(dashLength * dashLength / (1 + slope * slope));
        if (x == x2) {
            var signal = (y2 > y ? 1 : -1);
            x += slope * xStep * signal;
            y += xStep * signal;
        } else if (y == y2) {
            var signal = (x2 > x ? 1 : -1);
            x += xStep * signal;
            y += slope * xStep * signal;
        }
        ctx_bg[draw ? 'lineTo' : 'moveTo'](x, y);
        distRemaining -= dashLength;
        draw = !draw;
    }
}


/*画虚线方法*/
function ctxdashedLine(x, y, x2, y2, dashArray) {
    if (!dashArray) dashArray = [2, 2];
    var dashCount = dashArray.length;
    ctx.lineWidth = 2;
    ctx.moveTo(x, y);
    var dx = (x2 - x), dy = (y2 - y);
    if (x == x2) {
        var slope = dx / dy;
    } else if (y == y2) {
        var slope = dy / dx;
    }
    var distRemaining = Math.sqrt(dx * dx + dy * dy);
    var dashIndex = 0, draw = true;
    while (distRemaining >= 0.1) {
        var dashLength = dashArray[dashIndex++ % dashCount];
        if (dashLength > distRemaining) dashLength = distRemaining;
        var xStep = Math.sqrt(dashLength * dashLength / (1 + slope * slope));
        if (x == x2) {
            var signal = (y2 > y ? 1 : -1);
            x += slope * xStep * signal;
            y += xStep * signal;
        } else if (y == y2) {
            var signal = (x2 > x ? 1 : -1);
            x += xStep * signal;
            y += slope * xStep * signal;
        }
        ctx[draw ? 'lineTo' : 'moveTo'](x, y);
        distRemaining -= dashLength;
        draw = !draw;
    }
}
/*画饼图*/
function drawCircle(x, y, radius, data, color) {
    var startPoint = 9.5;
    for (var i = 0; i < data.length; i++) {
        ctx.fillStyle = color[i];
        ctx.beginPath();
        ctx.moveTo(x, y);
        ctx.arc(x, y, radius, startPoint, startPoint + Math.PI * 2 * (data[i] / 100), false);
        ctx.fill();
        startPoint += Math.PI * 2 * (data[i] / 100);
    }
}
/*获n日均价*/
function MA(num, n, arr) {
    var sum = 0;
    var nums = 0;
    for (var i = n - num + 1; i <= n; i++) {
        if (i >= 0) {
            sum += arr[i];
            nums++;
        }
    }
    if (nums == 0) {
        nums = 1;
    }
    return sum / nums;
}
/*获n日最低*/
function LLV(num, n, arr) {
    var reArr = [];
    var nums = 0;
    for (var i = n - num + 1; i <= n; i++) {
        if (i < 0) {
            i = 0;
        }
        reArr.push(arr[i]);
        nums++;
    }
    return Math.min.apply(Math, reArr);
}
/*获n日最高*/
function HHV(num, n, arr) {
    var reArr = [];
    var nums = 0;
    for (var i = n - num + 1; i <= n; i++) {
        if (i < 0) {
            i = 0;
        }
        reArr.push(arr[i]);
        nums++;
    }
    return Math.max.apply(Math, reArr);
}
/*获n日累加*/
function SUM(num, n, arr) {
    var sum = 0;
    for (var i = n - num + 1; i <= n; i++) {
        if (i >= 0 && arr[i] != 0) {
            sum += arr[i];
        }
    }
    return sum;
}
/*M日平均绝对偏差*/
function AVEDEV(m, n, arr) {
    var sum = 0;
    for (var i = 0; i < n; i++) {
        if (m - i >= 0) {
            sum = sum + arr[m - i];
        }
    }
    var sum2 = 0;
    for (var i = 0; i < n; i++) {
        if (m - i >= 0) {
            sum2 = sum2 + arr[m - i] + sum / n;
        }
    }
    return sum2 / n;
}
/*统计n日中满足arr1>arr2*/
function COUNT(num, n, arr1, arr2) {
    var nums = 0;
    for (var i = n - num + 1; i <= n; i++) {
        if (i >= 0) {
            if (arr1[i] > arr2[i]) {
                nums++;
            }
        }
    }
    return nums;
}

function drawKBTN() {
    var Kbtn_ = ["指标切换", "放大", "缩小"];
      
    kbtn_y = height + sheight * 0.5 + theight - 57.5;

    ctx.clearRect(0, kbtn_y, width * 2, 65);
    ctx_bg.clearRect(0, kbtn_y, width * 2, 65);
    ctx_bs.clearRect(0, kbtn_y, width * 2, 65);
    ctx_tb.clearRect(0, kbtn_y, width * 2, 65);

    fontNum = parseInt(65 * 0.55);
    
    ctx_bg.font = fontNum + "px 黑体";
    kbtn_w = ctx_bg.measureText(" 指标切换 ").width;

    kbtn_x = width - kbtn_w * 1.5;

    ctx_bg.fillStyle = "#f9f9f9"; //"#f9f9f9"
    ctx_bg.fillRect(kbtn_x, kbtn_y, kbtn_w * Kbtn_.length, 65);

    if (ktouchID < Kbtn_.length) {
        ctx_bg.fillStyle = "#FF6000";
        ctx_bg.fillRect(kbtn_x + kbtn_w * ktouchID, kbtn_y, kbtn_w, 65);
    }

    ctx_bg.beginPath();
    ctx_bg.strokeStyle = white;
    ctx_bg.lineWidth = 4;
    for (var i = 1; i < Kbtn_.length + 1; i++) {
        ctx_bg.moveTo(kbtn_x + kbtn_w * i, kbtn_y);
        ctx_bg.lineTo(kbtn_x + kbtn_w * i, kbtn_y + 65);
    }

    //ctx_bg.strokeStyle = wBorder;
    //ctx_bg.rect(swidth, sheight + theight * 2, kbtn_w * Kbtn_.length, 65);

    ctx_bg.closePath();
    ctx_bg.stroke();

    ctx_bg.fillStyle = '#3C3C3C';

    for (var i = 0; i < Kbtn_.length; i++) {
        ctx_bg.fillText(Kbtn_[i], kbtn_x + kbtn_w / 2 + kbtn_w * i - ctx_bg.measureText(Kbtn_[i]).width / 2, kbtn_y + 65 - 23);
    }

}

function drawMBTN() {
    var Kbtn_ = ["买入", "卖出"];
    var stkType_ = getStkType(stkCode, market);
   
    if (stkType_ == "4" || stkType_ == "5" || stkType_ == "14" || stkType_ == "15") {
        Kbtn_ = ["购买", "赎回"];
    }

    kbtn_y = height + sheight * 0.5 + theight - 57.5;

    ctx.clearRect(0, kbtn_y, width * 2, 65);
    ctx_bg.clearRect(0, kbtn_y, width * 2, 65);
    ctx_bs.clearRect(0, kbtn_y, width * 2, 65);
    ctx_tb.clearRect(0, kbtn_y, width * 2, 65);

    fontNum = parseInt(65 * 0.55);

    ctx_bg.font = fontNum + "px 黑体";
    kbtn_w = ctx_bg.measureText(" 指标切换 ").width;

    kbtn_x = width - kbtn_w;

    ctx_bg.fillStyle = "#f9f9f9"; //"#f9f9f9"
    ctx_bg.fillRect(kbtn_x, kbtn_y, kbtn_w * Kbtn_.length, 65);

    if (ktouchID < Kbtn_.length) {
        ctx_bg.fillStyle = "#FF6000";
        ctx_bg.fillRect(kbtn_x + kbtn_w * ktouchID, kbtn_y, kbtn_w, 65);
    }

    ctx_bg.beginPath();
    ctx_bg.strokeStyle = white;
    ctx_bg.lineWidth = 4;
    for (var i = 1; i < Kbtn_.length + 1; i++) {
        ctx_bg.moveTo(kbtn_x + kbtn_w * i, kbtn_y);
        ctx_bg.lineTo(kbtn_x + kbtn_w * i, kbtn_y + 65);
    }

    //ctx_bg.strokeStyle = wBorder;
    //ctx_bg.rect(swidth, sheight + theight * 2, kbtn_w * Kbtn_.length, 65);

    ctx_bg.closePath();
    ctx_bg.stroke();

    ctx_bg.fillStyle = '#3C3C3C';

    for (var i = 0; i < Kbtn_.length; i++) {
        ctx_bg.fillText(Kbtn_[i], kbtn_x + kbtn_w / 2 + kbtn_w * i - ctx_bg.measureText(Kbtn_[i]).width / 2, kbtn_y + 65 - 23);
    }

}

function drawZXBTN() {
    var Kbtn_ = ["    搜索"];

    kbtn_y = height + sheight * 0.5 + theight - 57.5;

    ctx.clearRect(0, kbtn_y, width * 2, 65);
    ctx_bg.clearRect(0, kbtn_y, width * 2, 65);
    ctx_bs.clearRect(0, kbtn_y, width * 2, 65);
    ctx_tb.clearRect(0, kbtn_y, width * 2, 65);

    fontNum = parseInt(65 * 0.55);

    ctx_bg.font = fontNum + "px 黑体";
    kbtn_w = ctx_bg.measureText(" 指标切换 ").width;

    kbtn_x = width - kbtn_w * 0.5;

    ctx_bg.fillStyle = "#ADADAD"; //"#f9f9f9"
    ctx_bg.fillRect(kbtn_x, kbtn_y, kbtn_w * Kbtn_.length, 65);

    if (ktouchID < Kbtn_.length) {
        ctx_bg.fillStyle = "#FF6000";
        ctx_bg.fillRect(width + kbtn_w * ktouchID, kbtn_y, kbtn_w, 65);
    }

    ctx_bg.beginPath();
    ctx_bg.strokeStyle = white;
    ctx_bg.lineWidth = 4;
    for (var i = 1; i < Kbtn_.length + 1; i++) {
        ctx_bg.moveTo(kbtn_x + kbtn_w * i, kbtn_y);
        ctx_bg.lineTo(kbtn_x + kbtn_w * i, kbtn_y + 65);
    }

    //ctx_bg.strokeStyle = wBorder;
    //ctx_bg.rect(swidth, sheight + theight * 2, kbtn_w * Kbtn_.length, 65);

    ctx_bg.closePath();
    ctx_bg.stroke();

    ctx_bg.fillStyle = '#3C3C3C';
    for (var i = 0; i < Kbtn_.length; i++) {
        ctx_bg.fillText(Kbtn_[i], kbtn_x + kbtn_w / 2 + kbtn_w * i - ctx_bg.measureText(Kbtn_[i]).width / 2, kbtn_y + 65 - 22);
    }

    var search_ = new Image();
    search_.src = "img/search.png";
    ctx.drawImage(search_, kbtn_x + 5, kbtn_y + 65 - 26 - 34, 48, 48);
}


function drawBTN() {
	//if (lastTID == 0) {
	//    btn_ = ["添加", "分时", "K线", "资金流", "更多"];
    //}
    //else {
	//    btn_ = ["自选", "分时", "K线", "资金流", "更多"];
    //}
	
    ctx.clearRect(0, height * 2 - 75, width * 2, 75);
    ctx_bg.clearRect(0, height * 2 - 75, width * 2, 75);
    ctx_bs.clearRect(0, height * 2 - 75, width * 2, 75);
    ctx_tb.clearRect(0, height * 2 - 75, width * 2, 75);

    //var my_gradient_ = ctx_bg.createLinearGradient(0, height * 2 - 75, 0, height * 2);     /*莫认背景 渐变*/
    //my_gradient_.addColorStop(0, "gray");
    //my_gradient_.addColorStop(1, "black");

    //var mygradient_ = ctx_bg.createLinearGradient(0, height * 2 - 75, 0, height * 2);      /*点击背景 渐变*/
    //mygradient_.addColorStop(0, "RGB(60,71,76)");
    //mygradient_.addColorStop(0.3, "RGB(49,61,66)");
    //mygradient_.addColorStop(0.5, "RGB(37,46,50)");
    //mygradient_.addColorStop(1, "RGB(16,20,22)");

    ctx_bg.fillStyle = lightgray;
    ctx_bg.fillRect(0, height * 2 - 75, width * 2, 75);

 
    ctx_bg.fillStyle = orange;
    ctx_bg.fillRect(width * 0.4 * touchID, height * 2 - 75, width * 0.4, 75);


    ctx_bg.beginPath();
    ctx_bg.strokeStyle = white;
    ctx_bg.lineWidth = 2;
    ctx_bg.moveTo(width * 0.4, height * 2 - 2);
    ctx_bg.lineTo(width * 0.4, height * 2 - 72);

    ctx_bg.moveTo(width * 0.8, height * 2 - 2);
    ctx_bg.lineTo(width * 0.8, height * 2 - 72);

    ctx_bg.moveTo(width * 1.2, height * 2 - 2);
    ctx_bg.lineTo(width * 1.2, height * 2 - 72);

    ctx_bg.moveTo(width * 1.6, height * 2 - 2);
    ctx_bg.lineTo(width * 1.6, height * 2 - 72);

    ctx_bg.fillStyle = darkgrey;
    fontNum = parseInt(75 * 0.54);

    ctx_bg.font = "bolder " + fontNum + "px 黑体";

    if (browser.versions.android) {
        ctx_bg.font = fontNum + "px 黑体";
    }
   
    for (var i = 0; i < btn_.length; i++) {
        ctx_bg.fillText(btn_[i], width * 0.2 + width * 0.4 * i - ctx_bg.measureText(btn_[i]).width / 2, height * 2 - 26);
    }

    ctx_bg.closePath();
    ctx_bg.stroke();
}

function warning() {
    var warn = new Image();
    var src = "img/warning.png";    

    warn.src = src;
    if (browser.versions.android) {
        ctx.drawImage(warn, 10, sheight + theight * 2 + 50, 48, 48);    /*添加自选*/
    } else if (browser.versions.iPhone) {
        ctx.drawImage(warn, 10, sheight + theight * 2 + 50, 48, 48);    /*添加自选*/
    }
}

function drawMBG() {        /*分时背景*/
    if (high.length < parseInt(quote.vol / 100).length) {
        swidth = ctx.measureText(parseInt(quote.vol / 100)).width;
    }
    else {
        swidth = ctx.measureText(high + ".").width;
    }
    var stkType_ = getStkType(stkCode, market);
    if (stkType_ != "3" && stkType_ != "7" && stkType_ != "16") {
        if (swidth < 60) {
            swidth = 60;
        }
    }
   
    twidth = (width * 2 - swidth - swidth) / 2;

    ctx.clearRect(0, sheight - 1, width * 2, theight * 2 + 28);
    ctx_bg.clearRect(0, sheight - 1, width * 2, theight * 2 + 28);
    ctx_bs.clearRect(0, sheight - 1, width * 2, theight * 2 + 28);
    ctx_tb.clearRect(0, sheight - 1, width * 2, theight * 2 + 28);
    /*分时界面背景*/   
    ctx_bg.beginPath();
    ctx_bg.strokeStyle = wBorder;
    ctx_bg.lineWidth = 4;
    
    ctx_bg.moveTo(swidth, parseInt((theight) * 7 / 21) * 2 + sheight);
    ctx_bg.lineTo(swidth + twidth * 2, parseInt((theight) * 7 / 21) * 2 + sheight);
    ctx_bg.moveTo(swidth, parseInt((theight) * 14 / 21) * 2 + sheight);
    ctx_bg.lineTo(swidth + twidth * 2, parseInt((theight) * 14 / 21) * 2 + sheight);

    ctx_bg.closePath();
    ctx_bg.stroke();

    ctx_bg.beginPath();
    ctx_bg.lineWidth = 1;
    ctx_bg.rect(swidth, sheight, twidth * 2, theight * 2);
    for (var i = 1; i < 21; i++) {
        if (i != 7 || i != 14) {
            ctx_bg.moveTo(swidth, parseInt((theight) * i / 21) * 2 + sheight);
            ctx_bg.lineTo(swidth + twidth * 2, parseInt((theight) * i / 21) * 2 + sheight);
        }
        
        if (i < 8) {
            if (i == 4) {
                ctx_bg.moveTo(swidth + (twidth * 2) * i / 8, sheight);
                ctx_bg.lineTo(swidth + (twidth * 2) * i / 8, sheight + theight * 2);
            } else {
                dashedLine(swidth + (twidth * 2) * i / 8, sheight, swidth + (twidth * 2) * i / 8, sheight + theight * 2);
            }
        }
    }
    ctx_bg.closePath();
    ctx_bg.stroke();

    ctx_bg.font = font;
    //ctx_bg.fillStyle = black;
    var timeStr = ["9:30", "10:30", "11:30/13:00", "14:00", "15:00"];
    for (var i = 0; i < 5; i++) {
        x = swidth - 20 + (twidth * 2) * i / 4;
        if (i == 2) {
            x = x - 40;
        }
        drawText(ctx_bg, x, sheight + theight*2 + 26, 24, timeStr[i], black, "left");
    }
    
    if (stkType_ != "3" && stkType_ != "7" && stkType_ != "16") {
        drawMBTN();
    }
   
}

function inside() {
    var src = "img/add.png";    
    var gpys = black;              /*股票代码 名称 颜色*/
    ctx_bs.clearRect(0, 0, width * 2 , sheight - 10);
    ctx.clearRect(0, 0, width * 2, sheight - 10);
    ctx.textAlign = 'left';

    if (isZXG != -1) {   
        src = "img/del.png";
        gpys = blue;
    } else if (isZXG == -1) {
        src = "img/add.png";
        gpys = black;
    }

    for (var i = 0; i < zxg.length; i++) {
        src = "img/add.png";
        gpys = black;
        isZXG = -1;
        if (zxg[i].Stock == stkCode) {
            isZXG = 3;
            src = "img/del.png";
            gpys = zxgBlue;
            break;
        } 
    }
    var add = new Image();
    add.src = src;
    ctx.fillStyle = gpys;

    //ctx.fillStyle = gray;
    ctx.textAlign = 'left';

  
    zdf = ((price - preClose) * 100 / preClose).toFixed(num) + "%";
    zd = (price - preClose).toFixed(num);
    

    if (true) {  
        var as = 70;
        var fontS = 24;
        var pfontS = parseInt(width / 8);
        var textX = 5;
        
        ctx.font = fontS + "px 黑体";
        ctx.fillStyle = gpys;
        ctx.fillText(stkName, textX, fontS * 1.1);
        ctx.font = fontS * 1.2 + "px 黑体";
        ctx.fillText(stkCode, textX, fontS * 2.2);
        ctx.fillStyle = black;
        textX = ctx.measureText("股票名称").width;
        //ctx.font = fontS*2 + "px 黑体";
        //var pTxt = parseFloat(price).toFixed(num);
        //textX = textX + ctx.measureText("pTxt").width / 2;
        //if (!isNaN(pTxt)) {
        //    ctx.fillText(pTxt, textX, fontS * 1.8);
        //}
        //textX = textX + ctx.measureText("9999.99 ").width - ctx.measureText("pTxt").width / 2;

        ctx.font = fontS * 2 + "px 黑体";
        //textX = textX + ctx.measureText("pTxt").width / 2;
        var pTxt = parseFloat(price).toFixed(num);

        var stkType_ = getStkType(stkCode, market);
        if (stkType_ == "4" || stkType_ == "5" || stkType_ == "14" || stkType_ == "15") {
            if (preClose == 1) {
                zdf = "";
                zd = "";
                pTxt = "";
            }
        }

        //ctx.textAlign = "left";
        var txtW = ctx.measureText(pTxt).width;
        var spaceW = ctx.measureText("9999.99 ").width;

        //ctx.textAlign = "left";
        if (!isNaN(pTxt)) {
            ctx.fillText(pTxt, textX + (spaceW - txtW) * 0.5, fontS * 1.8);
        }
        textX = textX + ctx.measureText("9999.99 ").width;

        ctx.font = fontS + "px 黑体";
        ctx.fillText("涨幅", textX, fontS * 1.1);
        ctx.fillText("涨跌", textX, fontS * 2.2);

        textX = textX + ctx.measureText("涨幅 ").width;
        if (price > preClose) {
            ctx.fillStyle = red;
        } else if (price == preClose) {
            ctx.fillStyle = black;
        } else if (price < preClose) {
            ctx.fillStyle = green;
        }
        ctx.fillText(zdf, textX, fontS * 1.1);
        ctx.fillText(zd, textX, fontS * 2.2);
        ctx.fillStyle = black;

        textX = textX + ctx.measureText("-100.00% ").width;
        ctx.fillText("高", textX, fontS * 1.1);
        ctx.fillText("低", textX, fontS * 2.2);

        textX = textX + ctx.measureText("高 ").width ;
        //if (high > preClose) {
        //    ctx.fillStyle = red;
        //} else if (high == preClose) {
        //    ctx.fillStyle = white;
        //} else if (high < preClose) {
        //    ctx.fillStyle = green;
        //}
        ctx.fillText(high, textX, fontS * 1.1);
        //if (low > preClose) {
        //    ctx.fillStyle = red;
        //} else if (low == preClose) {
        //    ctx.fillStyle = white;
        //} else if (low < preClose) {
        //    ctx.fillStyle = green;
        //}
        ctx.fillText(low, textX, fontS * 2.2);

        textX = textX + ctx.measureText("9999.99 ").width;
        ctx.drawImage(add, textX, fontS * 1.1 - 24, 48, 48);    /*添加/删除自选图标*/
    }
}

function inside_() {   
    var gpys = yellow;              /*股票代码 名称 颜色*/
    ctx_bs.clearRect(0, 0, width * 2 - 51, sheight - 10);
    ctx.clearRect(0, 0, width * 2 - 51, sheight - 10);
    ctx.textAlign = 'left';
    ctx.fillStyle = gpys;
 
    if (browser.versions.iPhone) {
        ctx.font = fontSize * 1.3 + "px 黑体";
        ctx.fillText(stkCode, width / 4 - getWidth(stkCode, fontSize * 1.3) / 2 - 20, fontSize * 3);
        if (price > preClose) {
            ctx.fillStyle = red;
        } else if (price == preClose) {
            ctx.fillStyle = white;
        } else if (price < preClose) {
            ctx.fillStyle = green;
        }
        ctx.fillText(parseFloat(price).toFixed(num), width * 2 / 4, fontSize * 3);

        ctx.fillText(zdf, width * 6 /4, fontSize * 3);
        ctx.fillStyle = gray;
        ctx.fillText(parseFloat(preClose).toFixed(num), width, fontSize * 3);

        ctx.fillStyle = gpys;
        ctx.font = fontSize + "px 黑体";
        ctx.fillText(stkName, width / 4 - getWidth(stkName, fontSize) / 2 - 20, fontSize * 1.3);
        ctx.fillText("现价", width * 2 / 4, fontSize * 1.3);
        ctx.fillText("涨幅", width * 6 / 4, fontSize * 1.3);
        ctx.fillText("昨收", width, fontSize * 1.3);        
    }
    else if (browser.versions.android) {  /*安卓*/
        var as = 10;
        var fontS = parseInt(sheight / 2 * (2 / 3));
        ctx.font = fontS * 0.9 + "px 黑体";
        ctx.fillStyle = gpys;
        ctx.fillText(stkCode, width / 4 - getWidth(stkCode, fontS) / 2 - as, fontS * 2.2);
        if (price > preClose) {
            ctx.fillStyle = red;
        } else if (price == preClose) {
            ctx.fillStyle = white;
        } else if (price < preClose) {
            ctx.fillStyle = green;
        }
        ctx.fillText(parseFloat(price).toFixed(num), width * 2 / 4, fontS * 2.2);
        ctx.fillText(zdf, width * 6 / 4, fontS * 2.2);
        ctx.fillStyle = gray;
        ctx.fillText(parseFloat(preClose).toFixed(num), width, fontS * 2.2);

        ctx.fillStyle = gpys;
        ctx.font = fontS * 0.8 + "px 黑体";
        ctx.fillText(stkName, width / 4 - getWidth(stkName, fontS) / 2 - as, fontS * 1.1);

        ctx.fillText("现价", width * 2 / 4, fontS * 1.1);
        ctx.fillText("涨幅", width * 6 / 4, fontS * 1.1);
        ctx.fillText("昨收", width, fontS * 1.1);        
    }
}
/*画分时数据*/
function drawMInterface() {           /*画分时界面*/  
    drawMBG();  

    var stkType_ = getStkType(stkCode, market);
    if (stkType_ != "3" && stkType_ != "7" && stkType_ != "16") {
        if (preClose == 0) {
            preClose = 1;
        }
    }


    var limitP = [];
    
    for (var i = 0; i < mins.length; i++) {
        if (mins[i].price != 0) {
            limitP.push(mins[i].price);
        }
        if (mins[i].avgPrice != 0) {
            limitP.push(mins[i].avgPrice);
        }
    }

    Array.prototype.max = function(){   
        return Math.max.apply({}, this);
    }  
    Array.prototype.min = function(){   
        return Math.min.apply({}, this);
    }

    high = limitP.max().toFixed(num);
    low = limitP.min().toFixed(num);
    if (limitP.length == 0) {
        high = "";
        low = "";
        zdf = "";
        zd = "";
    }
   
    inside();

    if (limitP.length == 0) {
        high = preClose * 1.05;
        low = preClose * 0.95;
    }
    
    var maxDiff = Math.max(Math.abs(high - preClose), Math.abs(low - preClose));

    var min = preClose - maxDiff;

    var space = maxDiff / 7;

    if (space < 0.01) {
        space = 0.01;
    }

    priceSpace = theight / 21 / space;
    var val;
    var percen;
    var vol1 = [];
    for (var i = 0; i < mins.length; i++) {
        if (mins[i].vol != 0) {
            vol1.push(mins[i].vol / 100);
        }
    }

    var maxVol;

    if (vol1.length == 0) {
        maxVol = 33;
    } else {
        maxVol = Math.max.apply(Math, vol1);
    }
    var volVal;

    volSpace = theight / 3 / maxVol;
    ctx.beginPath();

    ctx.font = (fontSize - 2) + "px 黑体";
    ctx.textAlign = 'left';
    
    for (var i = 14; i >= 1; i--) {
        val = (min + i * space).toFixed(num);
        percent = Math.abs((val - preClose) * 100 / preClose).toFixed(2);
        
        if (preClose == 0) {
            percent = Math.abs((val - (min + 7 * space)) * 100 / (min + 7 * space)).toFixed(2);
        }

        if (i > 7) {
            ctx.fillStyle = red;
        } else if (i == 7) {
            ctx.fillStyle = black;
        } else if (i < 7) {
            ctx.fillStyle = green;
        }
        ctx.textAlign = 'right';
        ctx.fillText(" " + val, swidth - 4, sheight + parseInt(theight * (14 - i) / 21) * 2 + 15, width * 2 - twidth * 2 - 4);
        ctx.textAlign = 'left';
       
        ctx.fillText(" " + percent + "%", swidth + twidth * 2 - 2, sheight + parseInt(theight * (14 - i) / 21) * 2 + 15, width * 2 - twidth * 2 - 4);
    }

    if (mins.length != 0) {
        ctx.fillStyle = black;
        for (var i = 1; i <= 7; i++) {
            volVal = (i * maxVol / 7).toFixed(0);
            ctx.textAlign = 'right';
            ctx.fillText(" " + volVal, swidth - 4, sheight + parseInt(theight * (21 - i) / 21) * 2 + 15, width * 2 - twidth * 2 - 4);
            ctx.fillStyle = black;
            ctx.textAlign = 'left';
            ctx.fillText(" " + volVal, swidth + twidth * 2 - 2, sheight + parseInt(theight * (21 - i) / 21) * 2 + 15, width * 2 - twidth * 2 - 4);
        }
    } 
    ctx.font = fontSize + "px 黑体";
    function getY(val) {
        if (val == 0) {
            val = preClose;
        }
        
        var result = sheight + (parseInt(theight / 3) - (val - preClose) * priceSpace) * 2;

        if (result < sheight + 3) {
            result = sheight + 3;
        } else if (result > parseInt((theight) * 14 / 21) * 2 + sheight) {
            result = parseInt((theight) * 14 / 21) * 2 + sheight;
        }

        return result;
    }
    var mMin = getY(min);
    var mMax = getY(min + 14 * space);

    /*现价*/
    ctx.beginPath();
    ctx.lineWidth = 2;
    ctx.save();
    ctx.strokeStyle = pqColor_;
    var startSpace = 0;

    for (var i = 0; i < mins.length; i++) {
        x = swidth + parseInt((twidth * 2 - 4 - startSpace * 2) * i / 239) + 4;

        if (i == 0) {
            if (mins[i].price == 0) {
                priceY = getY(preClose);
            }

            else {
                priceY = getY(mins[i].price);
            }
            if (priceY > mMin) {
                priceY = mMin;
            }
            else if (priceY < mMax) {
                priceY = mMax;
            }
            ctx.moveTo(x, priceY);
        } else {
            if (mins[i].price == 0) {
                for (var n = 0; n < 10; n++) {
                    if (i >= n && mins[i - n].price != 0) {
                        priceY = getY(mins[i - n].price);
                        break;
                    }
                }
            } else {

                priceY = getY(mins[i].price);
            }
            if (priceY > mMin) {
                priceY = mMin;
            }
            else if (priceY < mMax) {
                priceY = mMax;
            }
            ctx.lineTo(x, priceY);
        }
    }
    ctx.stroke();
    ctx.restore();
    ctx.closePath();

    /*均价*/
    ctx.beginPath();
    ctx.lineWidth = 2;
    ctx.save();
    ctx.strokeStyle = black;
    for (var i = 0; i < mins.length; i++) {
        x = swidth + parseInt((twidth * 2 - 4 - startSpace * 2) * i / 239) + 4;
        if (i == 0) {
            if (mins[i].avgPrice == 0) {
                priceY = getY(preClose);
            } else {
                priceY = getY(mins[i].avgPrice);
            }
            if (priceY > mMin) {
                priceY = mMin;
            }
            else if (priceY < mMax) {
                priceY = mMax;
            }
            ctx.moveTo(x, priceY);
        } else {
            if (mins[i].avgPrice == 0) {
                for (var n = 0; n < 10; n++) {
                    if (i >= n && mins[i - n].avgPrice != 0) {
                        priceY = getY(mins[i - n].avgPrice);
                        break;
                    }
                }
            } else {
                priceY = getY(mins[i].avgPrice);
            }
            if (priceY > mMin) {
                priceY = mMin;
            }
            else if (priceY < mMax) {
                priceY = mMax;
            }
            ctx.lineTo(x, priceY);
        }
    }
    ctx.stroke();
    ctx.restore();
    ctx.closePath();

    /*成交量*/
    ctx.fillStyle = pqColor_;
    ctx.lineWidth = 2;
    for (var i = 0; i < mins.length; i++) {
        x = swidth + parseInt((twidth * 2 - 4 - startSpace * 2) * i / 239) + 4;

        voly1 = sheight / 2 + parseInt(theight) - (mins[i].vol / 100) * volSpace + 1;
        voly2 = sheight / 2 + parseInt(theight);

        //if (i == 0) {
        //    if (mins[i].price > preClose) {
        //        ctx.fillStyle = red;
        //    } else if (mins[i].price < preClose) {
        //        ctx.fillStyle = green;
        //    } else {
        //        ctx.fillStyle = white;
        //    }
        //} else {
        //    if (mins[i].price > mins[i - 1].price) {
        //        ctx.fillStyle = red;
        //    } else if (mins[i].price < mins[i - 1].price) {
        //        ctx.fillStyle = green;
        //    } else {
        //        ctx.fillStyle = white;
        //    }
        //}
        ctx.fillRect(x, voly1 * 2, 2, (voly2 - voly1)*2);
    }
}

/*画分时数据*/
function drawMInterface_() {           /*画分时界面*/  
    
    twidth = width * 1.4;
    theight = height * 2 - 100;

    //swidth = width * 0.4;
    //sheight = 49;

    var num = 2;

    var limitP = [];
    
    for (var i = 0; i < mins.length; i++) {
        if (mins[i].price!=0) {
            limitP.push(mins[i].price);
        }
        if (mins[i].avgPrice != 0) {
            limitP.push(mins[i].avgPrice);
        }
      
    }

    Array.prototype.max = function(){   
        return Math.max.apply({}, this);
    }  
    Array.prototype.min = function(){   
        return Math.min.apply({}, this);
    }

    high = limitP.max().toFixed(num);
    low = limitP.min().toFixed(num);

    if (limitP.length == 0) {
        high = preClose * 1.005;
        low = preClose * 1.005;
    }

    var maxDiff = Math.max(Math.abs(high - preClose), Math.abs(low - preClose));
    var min = preClose - maxDiff;

    var space = maxDiff / 4;

    if (space < 0.01) {
        space = 0.01;
    }

    priceSpace = (theight / 8) / space;
    var val;
    var percen;
   
    ctx.beginPath();
     if (browser.versions.iPhone) {
        ctx.font = parseInt((width * 0.3) / (parseFloat(price).toFixed(num).toString().length)) + 'px 黑体';
    }
    else {
        ctx.font = parseInt((width * 0.2) / (parseFloat(price).toFixed(num).toString().length)) + 'px 黑体';
    } 
      

    fontNum = 24;
    ctx.font = fontNum + "px 黑体";
    ctx.textAlign = 'right';
  
    for (var i = 0; i < 9; i++) {
        val = (min + i * space).toFixed(num);
        percent = Math.abs((val - preClose) * 100 / preClose).toFixed(2);
        if (i > 4) {
            ctx.fillStyle = red;
        } else if (i == 4) {
            ctx.fillStyle = black;
        } else if (i < 4) {
            ctx.fillStyle = green;
        }
        ctx.textAlign = 'right';
        ctx.fillText(val, width * 0.19, sheight + parseInt(theight * (8 - i) / 8) + 2);
        ctx.textAlign = 'left';
        ctx.fillText(percent + "%", width * 1.81, sheight + parseInt(theight * (8 - i) / 8) + 2);
    }

    

    
    function getY(val) {
        if (val == 0) {
            val = preClose;
        }
        
        var result = sheight + (parseInt(theight / 2) - (val - preClose) * priceSpace);

        if (result < sheight + 3) {
            result = sheight + 3;
        } else if (result > parseInt(theight  + sheight)) {
            result = theight + sheight;
        }

        return result;
    }
    var mMin = getY(min);
    var mMax = getY(min + 14 * space);

    /*现价*/
    ctx.beginPath();
    ctx.lineWidth = 1;
    ctx.save();
    ctx.strokeStyle = pqColor_;
    var startSpace = 0;

    for (var i = 0; i < mins.length; i++) {
        x = parseInt((twidth - 4 - startSpace) * i / 239) + swidth;

        if (i == 0) {
            if (mins[i].price == 0) {
                priceY = getY(preClose);
            }

            else {
                priceY = getY(mins[i].price);
            }
            if (priceY > mMin) {
                priceY = mMin;
            }
            else if (priceY < mMax) {
                priceY = mMax;
            }
            ctx.moveTo(x, priceY);
        } else {
            if (mins[i].price == 0) {
                for (var n = 0; n < 10; n++) {
                    if (i >= n && mins[i - n].price != 0) {
                        priceY = getY(mins[i - n].price);
                        break;
                    }
                }
            } else {

                priceY = getY(mins[i].price);
            }
            if (priceY > mMin) {
                priceY = mMin;
            }
            else if (priceY < mMax) {
                priceY = mMax;
            }
            ctx.lineTo(x, priceY);
        }
    }
    ctx.stroke();
    ctx.restore();
    ctx.closePath();
    /*均价*/
    ctx.beginPath();
    ctx.lineWidth = 1;
    ctx.save();
    ctx.strokeStyle = aColor;
    for (var i = 0; i < mins.length; i++) {
        x = parseInt((twidth - 4 - startSpace) * i / 239) + swidth;
        if (i == 0) {
            if (mins[i].avgPrice == 0) {
                priceY = getY(preClose);
            } else {
                priceY = getY(mins[i].avgPrice);
            }
            if (priceY > mMin) {
                priceY = mMin;
            }
            else if (priceY < mMax) {
                priceY = mMax;
            }
            ctx.moveTo(x, priceY);
        } else {
            if (mins[i].avgPrice == 0) {
                for (var n = 0; n < 10; n++) {
                    if (i >= n && mins[i - n].avgPrice != 0) {
                        priceY = getY(mins[i - n].avgPrice);
                        break;
                    }
                }
            } else {
                priceY = getY(mins[i].avgPrice);
            }
            if (priceY > mMin) {
                priceY = mMin;
            }
            else if (priceY < mMax) {
                priceY = mMax;
            }
            ctx.lineTo(x, priceY);
        }
    }
    ctx.stroke();
    ctx.restore();
    ctx.closePath();
}


function drawKBG() {
    swidth = 2;
   
    ctx.font = (fontSize - 1) + "px 黑体";
    twidth = width - swidth - ctx.measureText(" 999999 ").width / 2;
    ctx.clearRect(swidth, sheight, width * 2, theight * 2);
    ctx_bg.clearRect(swidth, sheight, width * 2, theight * 2);
    ctx_bs.clearRect(swidth, sheight, width * 2, theight * 2);
    ctx_tb.clearRect(swidth, sheight, width * 2, theight * 2);

    ctx_bg.beginPath();
    ctx_bg.lineWidth = 1;
    ctx_bg.strokeStyle = wBorder;
    ctx_bg.rect(swidth, sheight, twidth * 2, theight * 2);
    var y;
    for (var i = 0; i < 7; i++) {
        y = parseInt(theight * 2 * i / 10) + sheight;
        if (i != 6) {
            dashedLine(swidth, y, twidth * 2, y);
        } else {
            ctx_bg.moveTo(swidth, y);
            ctx_bg.lineTo(twidth * 2, y);
        }
    }

    y = parseInt(theight * 2 * 7.2 / 10) + sheight;
    dashedLine(swidth, y, twidth * 2, y);

    y = parseInt(theight * 2 * 7.2 / 10) + sheight + (theight * 2 + sheight - y) / 3;
    dashedLine(swidth, y, twidth * 2, y);
    y = parseInt(theight * 2 * 7.2 / 10) + sheight + (theight * 2 + sheight - y);
    dashedLine(swidth, y, twidth * 2, y);

    ctx_bg.closePath();
    ctx_bg.stroke();


    drawKBTN();

    
    //var zoomOut = new Image();
    //zoomOut.src = "img/zoom_out.png";

    //var zoomIn = new Image();
    //zoomIn.src = "img/zoom_in.png";
    //try {
    //    /*缩小*/
    //    zoomOut.onload = function () { ctx_tb.drawImage(zoomOut, swidth + twidth * 2 - 70, parseInt(theight * 6 / 5) + sheight - 70, 64, 64); }
    //    /*放大*/
    //    zoomIn.onload = function () { ctx_tb.drawImage(zoomIn, swidth + twidth * 2 - 170, parseInt(theight * 6 / 5) + sheight - 70, 64, 64); }      
    //} catch (e) {

    //}

    //ctx_bg.fillStyle = yellow;
    //var cfont = 0;
    //if (browser.versions.iPhone) {
    //    cfont = fontSize * 1.3;
    //} else if (browser.versions.android) {  /*安卓*/
    //    cfont = (parseInt(sheight / 2 * (2 / 3)) - 3);
    //}
    //ctx_bg.font = cfont + "px 黑体";
    //ctx_bg.clearRect(5, height * 2 - 160 - cfont, width * 2, cfont*2);
    //ctx_bg.fillText("点击上方VOL指标区域,可以查看其它指标!", 5, height * 2 - 160);
}

function tagTxt(n) {
    if (browser.versions.android) {
        ctx_bs.font = fontSize * 0.9 + 'px 黑体';
        if (target == "DMI") {
            ctx_bs.font = fontSize * 0.7 + 'px 黑体';
        } else if (target == "CR") {
            ctx_bs.font = fontSize * 0.6 + 'px 黑体';
        }
    } else if (browser.versions.iPhone) {
        ctx_bs.font = fontSize + 'px 黑体';
        if (target == "DMI") {
            ctx_bs.font = fontSize * 0.7 + 'px 黑体';
        } else if (target == "CR") {
            ctx_bs.font = fontSize * 0.6 + 'px 黑体';
        }
    }

    ctx_bs.fillStyle = black;
    var targetTxt = "";

    if (value.length != 0) {
        targetTxt = target + "(" + value + ")";
    } else {
        targetTxt = target;
    }

    ctx_bs.clearRect(swidth + 10, sheight + 5, twidth * 2 - 12, 50);
    var tagTip1 = "MA5:" + parseFloat(avg5[n - start]).toFixed(2);
    var tagTip2 = "MA10:" + parseFloat(avg10[n - start]).toFixed(2);
    var tagTip3 = "MA20:" + parseFloat(avg20[n - start]).toFixed(2);
    var tagTip4 = "MA60:" + parseFloat(avg60[n - start]).toFixed(2);
    ctx_bs.fillStyle = M5Color;
    ctx_bs.fillText(tagTip1, swidth + 8, sheight + 18 + fontSize * 0.5);
    ctx_bs.fillStyle = M10Color;
    ctx_bs.fillText(tagTip2, swidth + 16 + ctx_bs.measureText(tagTip1).width, sheight + 18 + fontSize * 0.5);
    ctx_bs.fillStyle = M20Color;
    ctx_bs.fillText(tagTip3, swidth + 24 + ctx_bs.measureText(tagTip1).width + ctx_bs.measureText(tagTip2).width, sheight + 18 + fontSize * 0.5);
    ctx_bs.fillStyle = M60Color;
    ctx_bs.fillText(tagTip4, swidth + 32 + ctx_bs.measureText(tagTip1).width + ctx_bs.measureText(tagTip2).width + ctx_bs.measureText(tagTip3).width, sheight + 18 + fontSize * 0.5);

    ctx_bs.clearRect(swidth + 10, parseInt(theight * 6 / 5) + sheight + 8, twidth * 2 - 12, 52);

    if (browser.versions.android) {
        
    } else if (browser.versions.iPhone) {
        ctx_bs.clearRect(swidth + 10, parseInt(theight * 6 / 5) + sheight + 10, twidth * 2 - 12, 50);
    }
    ctx_bs.fillStyle = black;
    ctx_bs.fillText(targetTxt, swidth + 10, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);

    switch (target) {
        case "VOL":
            ctx_bs.fillStyle = M5Color;
            var tagTip1 = "MA5:" + parseFloat(vol5[n - start]).toFixed(2);
            ctx_bs.fillText(tagTip1, swidth + 20 + ctx_bs.measureText(targetTxt).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            ctx_bs.fillStyle = M10Color;
            var tagTip2 = "MA10:" + parseFloat(vol10[n - start]).toFixed(2)
            ctx_bs.fillText(tagTip2, swidth + 30 + ctx_bs.measureText(targetTxt).width + ctx_bs.measureText(tagTip1).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            break;
        case "MACD":
            var tagTip1 = "DIF:" + parseFloat(Dif[n]).toFixed(2);
            var tagTip2 = "DEA:" + parseFloat(Dea[n]).toFixed(2);
            var tagTip3 = "MACD:" + parseFloat(Macd[n]).toFixed(2);
            ctx_bs.fillStyle = M5Color;
            ctx_bs.fillText(tagTip1, swidth + 20 + ctx_bs.measureText(targetTxt).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            ctx_bs.fillStyle = M10Color;
            ctx_bs.fillText(tagTip2, swidth + 30 + ctx_bs.measureText(targetTxt).width + ctx_bs.measureText(tagTip1).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            ctx_bs.fillStyle = M20Color;
            ctx_bs.fillText(tagTip3, swidth + 40 + ctx_bs.measureText(targetTxt).width + ctx_bs.measureText(tagTip1).width + ctx_bs.measureText(tagTip2).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            break;
        case "DMI":

            var tagTip1 = "PDI:" + parseFloat(PDI[n]).toFixed(2);
            var tagTip2 = "MDI:" + parseFloat(MDI[n]).toFixed(2);
            var tagTip3 = "ADX:" + parseFloat(ADX[n]).toFixed(2);
            var tagTip4 = "ADXR:" + parseFloat(ADXR[n]).toFixed(2);
            ctx_bs.fillStyle = M5Color;
            ctx_bs.fillText(tagTip1, swidth + 20 + ctx_bs.measureText(targetTxt).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            ctx_bs.fillStyle = M10Color;
            ctx_bs.fillText(tagTip2, swidth + 30 + ctx_bs.measureText(targetTxt).width + ctx_bs.measureText(tagTip1).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            ctx_bs.fillStyle = M20Color;
            ctx_bs.fillText(tagTip3, swidth + 40 + ctx_bs.measureText(targetTxt).width + ctx_bs.measureText(tagTip1).width + ctx_bs.measureText(tagTip2).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            ctx_bs.fillStyle = M60Color;
            ctx_bs.fillText(tagTip4, swidth + 50 + ctx_bs.measureText(targetTxt).width + ctx_bs.measureText(tagTip1).width + ctx_bs.measureText(tagTip2).width + ctx_bs.measureText(tagTip3).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            break;
        case "DMA":
            var tagTip1 = "DIF:" + parseFloat(tDIF[n]).toFixed(2);
            var tagTip2 = "AMA:" + parseFloat(AMA[n]).toFixed(2);

            ctx_bs.fillStyle = M5Color;
            ctx_bs.fillText(tagTip1, swidth + 20 + ctx_bs.measureText(targetTxt).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            ctx_bs.fillStyle = M10Color;
            ctx_bs.fillText(tagTip2, swidth + 30 + ctx_bs.measureText(targetTxt).width + ctx_bs.measureText(tagTip1).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            break;
        case "FSL":
            var tagTip1 = "SWL:" + parseFloat(SWL[n]).toFixed(2);
            var tagTip2 = "SWS:" + parseFloat(SWS[n]).toFixed(2);

            ctx_bs.fillStyle = M5Color;
            ctx_bs.fillText(tagTip1, swidth + 20 + ctx_bs.measureText(targetTxt).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            ctx_bs.fillStyle = M10Color;
            ctx_bs.fillText(tagTip2, swidth + 30 + ctx_bs.measureText(targetTxt).width + ctx_bs.measureText(tagTip1).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            break;
        case "TRIX":
            var tagTip1 = "TRIX:" + parseFloat(TRIX[n]).toFixed(2);
            var tagTip2 = "MATRIX:" + parseFloat(MATRIX[n]).toFixed(2);

            ctx_bs.fillStyle = M5Color;
            ctx_bs.fillText(tagTip1, swidth + 20 + ctx_bs.measureText(targetTxt).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            ctx_bs.fillStyle = M10Color;
            ctx_bs.fillText(tagTip2, swidth + 30 + ctx_bs.measureText(targetTxt).width + ctx_bs.measureText(tagTip1).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            break;
        case "BRAR":
            var tagTip1 = "BR:" + parseFloat(BR[n]).toFixed(2);
            var tagTip2 = "AR:" + parseFloat(AR[n]).toFixed(2);

            ctx_bs.fillStyle = M5Color;
            ctx_bs.fillText(tagTip1, swidth + 20 + ctx_bs.measureText(targetTxt).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            ctx_bs.fillStyle = M10Color;
            ctx_bs.fillText(tagTip2, swidth + 30 + ctx_bs.measureText(targetTxt).width + ctx_bs.measureText(tagTip1).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            break;
        case "CR":

            var tagTip1 = "CR:" + parseFloat(CR[n]).toFixed(2);
            var tagTip2 = "MA1:" + parseFloat(MA1[n]).toFixed(2);
            var tagTip3 = "MA2:" + parseFloat(MA2[n]).toFixed(2);
            var tagTip4 = "MA3:" + parseFloat(MA3[n]).toFixed(2);
            var tagTip5 = "MA4:" + parseFloat(MA4[n]).toFixed(2);
            ctx_bs.fillStyle = M5Color;
            ctx_bs.fillText(tagTip1, swidth + 20 + ctx_bs.measureText(targetTxt).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            ctx_bs.fillStyle = M10Color;
            ctx_bs.fillText(tagTip2, swidth + 30 + ctx_bs.measureText(targetTxt).width + ctx_bs.measureText(tagTip1).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            ctx_bs.fillStyle = M20Color;
            ctx_bs.fillText(tagTip3, swidth + 40 + ctx_bs.measureText(targetTxt).width + ctx_bs.measureText(tagTip1).width + ctx_bs.measureText(tagTip2).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            ctx_bs.fillStyle = M60Color;
            ctx_bs.fillText(tagTip4, swidth + 50 + ctx_bs.measureText(targetTxt).width + ctx_bs.measureText(tagTip1).width + ctx_bs.measureText(tagTip2).width + ctx_bs.measureText(tagTip3).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            ctx_bs.fillStyle = M70Color;
            ctx_bs.fillText(tagTip5, swidth + 60 + ctx_bs.measureText(targetTxt).width + ctx_bs.measureText(tagTip1).width + ctx_bs.measureText(tagTip2).width + ctx_bs.measureText(tagTip3).width + ctx_bs.measureText(tagTip4).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            break;
        case "VR":
            var tagTip1 = "VR:" + parseFloat(VR[n]).toFixed(2);
            var tagTip2 = "MAVR:" + parseFloat(MAVR[n]).toFixed(2);

            ctx_bs.fillStyle = M5Color;
            ctx_bs.fillText(tagTip1, swidth + 20 + ctx_bs.measureText(targetTxt).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            ctx_bs.fillStyle = M10Color;
            ctx_bs.fillText(tagTip2, swidth + 30 + ctx_bs.measureText(targetTxt).width + ctx_bs.measureText(tagTip1).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            break;
        case "OBV":
            var tagTip1 = "OBV:" + parseFloat(OBV[n]).toFixed(2);
            var tagTip2 = "MAOBV:" + parseFloat(MAOBV[n]).toFixed(2);

            ctx_bs.fillStyle = M5Color;
            ctx_bs.fillText(tagTip1, swidth + 20 + ctx_bs.measureText(targetTxt).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            ctx_bs.fillStyle = M10Color;
            ctx_bs.fillText(tagTip2, swidth + 30 + ctx_bs.measureText(targetTxt).width + ctx_bs.measureText(tagTip1).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            break;
        case "EMV":
            var tagTip1 = "EMV:" + parseFloat(EMV[n]).toFixed(2);
            var tagTip2 = "MAEMV:" + parseFloat(MAEMV[n]).toFixed(2);

            ctx_bs.fillStyle = M5Color;
            ctx_bs.fillText(tagTip1, swidth + 20 + ctx_bs.measureText(targetTxt).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            ctx_bs.fillStyle = M10Color;
            ctx_bs.fillText(tagTip2, swidth + 30 + ctx_bs.measureText(targetTxt).width + ctx_bs.measureText(tagTip1).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            break;
        case "RSI":
            var tagTip1 = "RSI1:" + parseFloat(RSI1[n]).toFixed(2);
            var tagTip2 = "RSI2:" + parseFloat(RSI2[n]).toFixed(2);
            var tagTip3 = "RSI3:" + parseFloat(RSI3[n]).toFixed(2);
            ctx_bs.fillStyle = M5Color;
            ctx_bs.fillText(tagTip1, swidth + 20 + ctx_bs.measureText(targetTxt).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            ctx_bs.fillStyle = M10Color;
            ctx_bs.fillText(tagTip2, swidth + 30 + ctx_bs.measureText(targetTxt).width + ctx_bs.measureText(tagTip1).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            ctx_bs.fillStyle = M20Color;
            ctx_bs.fillText(tagTip3, swidth + 40 + ctx_bs.measureText(targetTxt).width + ctx_bs.measureText(tagTip1).width + ctx_bs.measureText(tagTip2).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            break;
        case "WR":
            var tagTip1 = "WR1:" + parseFloat(WR1[n]).toFixed(2);
            var tagTip2 = "WR2:" + parseFloat(WR2[n]).toFixed(2);

            ctx_bs.fillStyle = M5Color;
            ctx_bs.fillText(tagTip1, swidth + 20 + ctx_bs.measureText(targetTxt).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            ctx_bs.fillStyle = M10Color;
            ctx_bs.fillText(tagTip2, swidth + 30 + ctx_bs.measureText(targetTxt).width + ctx_bs.measureText(tagTip1).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);

            break;
        case "KDJ":
            var tagTip1 = "K:" + parseFloat(k[n]).toFixed(2);
            var tagTip2 = "D:" + parseFloat(d[n]).toFixed(2);
            var tagTip3 = "J:" + parseFloat(j[n]).toFixed(2);
            ctx_bs.fillStyle = M5Color;
            ctx_bs.fillText(tagTip1, swidth + 20 + ctx_bs.measureText(targetTxt).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            ctx_bs.fillStyle = M10Color;
            ctx_bs.fillText(tagTip2, swidth + 30 + ctx_bs.measureText(targetTxt).width + ctx_bs.measureText(tagTip1).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            ctx_bs.fillStyle = M20Color;
            ctx_bs.fillText(tagTip3, swidth + 40 + ctx_bs.measureText(targetTxt).width + ctx_bs.measureText(tagTip1).width + ctx_bs.measureText(tagTip2).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            break;
        case "CCI":
            var tagTip1 = "CCI:" + parseFloat(CCI[n]).toFixed(2);

            ctx_bs.fillStyle = M5Color;
            ctx_bs.fillText(tagTip1, swidth + 20 + ctx_bs.measureText(targetTxt).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);

            break;
        case "ROC":
            var tagTip1 = "ROC:" + parseFloat(ROC[n]).toFixed(2);
            var tagTip2 = "MAROC:" + parseFloat(MAROC[n]).toFixed(2);

            ctx_bs.fillStyle = M5Color;
            ctx_bs.fillText(tagTip1, swidth + 20 + ctx_bs.measureText(targetTxt).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            ctx_bs.fillStyle = M10Color;
            ctx_bs.fillText(tagTip2, swidth + 30 + ctx_bs.measureText(targetTxt).width + ctx_bs.measureText(tagTip1).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);

            break;
        case "MTM":
            var tagTip1 = "MTM:" + parseFloat(MTM[n]).toFixed(2);
            var tagTip2 = "MAMTM:" + parseFloat(MAMTM[n]).toFixed(2);

            ctx_bs.fillStyle = M5Color;
            ctx_bs.fillText(tagTip1, swidth + 20 + ctx_bs.measureText(targetTxt).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            ctx_bs.fillStyle = M10Color;
            ctx_bs.fillText(tagTip2, swidth + 30 + ctx_bs.measureText(targetTxt).width + ctx_bs.measureText(tagTip1).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);

            break;
        case "BOLL":
            var tagTip1 = "BOLL:" + parseFloat(BOLL[n]).toFixed(2);
            var tagTip2 = "UB:" + parseFloat(UB[n]).toFixed(2);
            var tagTip3 = "LB:" + parseFloat(LB[n]).toFixed(2);
            ctx_bs.fillStyle = M5Color;
            ctx_bs.fillText(tagTip1, swidth + 20 + ctx_bs.measureText(targetTxt).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            ctx_bs.fillStyle = M10Color;
            ctx_bs.fillText(tagTip2, swidth + 30 + ctx_bs.measureText(targetTxt).width + ctx_bs.measureText(tagTip1).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            ctx_bs.fillStyle = M20Color;
            ctx_bs.fillText(tagTip3, swidth + 40 + ctx_bs.measureText(targetTxt).width + ctx_bs.measureText(tagTip1).width + ctx_bs.measureText(tagTip2).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);

            break;
        case "PSY":
            var tagTip1 = "PSY:" + parseFloat(PSY[n]).toFixed(2);
            var tagTip2 = "MAPSY:" + parseFloat(MAPSY[n]).toFixed(2);

            ctx_bs.fillStyle = M5Color;
            ctx_bs.fillText(tagTip1, swidth + 20 + ctx_bs.measureText(targetTxt).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            ctx_bs.fillStyle = M10Color;
            ctx_bs.fillText(tagTip2, swidth + 30 + ctx_bs.measureText(targetTxt).width + ctx_bs.measureText(tagTip1).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);

            break;
        case "MCST":
            var tagTip1 = "MCST:" + parseFloat(MCST[n]).toFixed(2);

            ctx_bs.fillStyle = M5Color;
            ctx_bs.fillText(tagTip1, swidth + 20 + ctx_bs.measureText(targetTxt).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);

            break;
        case "ZL":
            var tagTip1 = "ZL:" + parseFloat(ZL[n]).toFixed(2);
            var tagTip2 = "BL:" + parseFloat(ZL1[n]).toFixed(2);
            var tagTip3 = "SL:" + parseFloat(ZL2[n]).toFixed(2);
            ctx_bs.fillStyle = M5Color;
            ctx_bs.fillText(tagTip1, swidth + 20 + ctx_bs.measureText(targetTxt).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            ctx_bs.fillStyle = M10Color;
            ctx_bs.fillText(tagTip2, swidth + 30 + ctx_bs.measureText(targetTxt).width + ctx_bs.measureText(tagTip1).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);
            ctx_bs.fillStyle = M20Color;
            ctx_bs.fillText(tagTip3, swidth + 40 + ctx_bs.measureText(targetTxt).width + ctx_bs.measureText(tagTip1).width + ctx_bs.measureText(tagTip2).width, parseInt(theight * 6 / 5) + sheight + 20 + fontSize * 0.5);

            break;
        default:
            break;
    }
}

function paintTag() {         /*当按方向键时单独调用*/
    var tmax = 0;
    var tmin = 0;
    var y;

    function getTagY(val) {
        var n = (tmax - val) / ((tmax - tmin) / 3);
        return parseInt(theight * 2 * 7.2 / 10) + sheight + (theight * 2 - parseInt(theight * 2 * 7.2 / 10)) * n / 3;
    }

    function drawCurve(arr, color, lineWidth) {/*画曲线方法*/
        ctx.beginPath();
        ctx.lineWidth = 2;
        ctx.save();
        ctx.strokeStyle = color;

        for (var i = 0; i < arr.length; i++) {
            x = swidth + (barW + space) * i + parseInt(barW / 2);

            y = getTagY(arr[i]);

            if (i == 0) {
                ctx.moveTo(x, y);
            } else {
                ctx.lineTo(x, y);
            }
        }
        ctx.stroke();
        ctx.restore();
    }
    ctx.clearRect(swidth, parseInt(theight * 2 * 6 / 10) + sheight, twidth * 2, parseInt(theight * 2 * 4 / 10));

    ctx.clearRect(swidth + twidth * 2, parseInt(theight * 2 * 6 / 10) + sheight + 30, width * 2 - swidth - twidth * 2, sheight + theight * 2 - parseInt(theight * 2 * 6 / 10) - sheight - 10);

    ctx.font = (fontSize - 1) + "px 黑体";
    ctx.fillStyle = black;
    ctx.textAlign = 'left';

    switch (target) {
        case "VOL":
            drawKInterface();
            drawBTN();
            break;
        case "MACD":
            var DIF = [];
            var DEA = [];
            var MACD = [];
            allArr = [];
            for (var i = start; i < end; i++) {
                DIF.push(Dif[i]);
                DEA.push(Dea[i]);
                MACD.push(Macd[i]);

                allArr.push(Dif[i]);
                allArr.push(Dea[i]);
                allArr.push(Macd[i]);
            }
            tmax = Math.max.apply(Math, allArr);
            tmin = Math.min.apply(Math, allArr);

            for (var i = 0; i < 3; i++) {
                y = parseInt(theight * 2 * 7.2 / 10) + sheight + (theight * 2 - parseInt(theight * 2 * 7.2 / 10)) * i / 3;
                ctx.fillText((tmax - i * (tmax - tmin) / 3).toFixed(2), swidth + twidth * 2 + 5, y + 5, width * 2 + 2 - swidth - twidth * 2);
                
            }

            if (tmin < 0 && tmax > 0) {
                ctx.beginPath();
                ctx.strokeStyle = black;
                ctxdashedLine(swidth + 1.5, getTagY(0), swidth + twidth * 2, getTagY(0));
                ctx.stroke();
                ctx.closePath();

                ctx.fillStyle = black;
                //ctx.fillText("0.00", swidth + twidth * 2 + 10, getTagY(0) + 5);
            }

            for (var i = 0; i < MACD.length; i++) {
                x = 1.5 + parseInt(swidth + (barW + space) * i + parseInt(barW / 2));
                if (MACD[i] > 0) {
                    color = red;
                } else if (MACD[i] < 0) {
                    color = green;
                } else {
                    color = black;
                }
                ctx.beginPath();
                ctx.strokeStyle = color;
                ctx.lineWidth = 1;
                ctx.moveTo(x, getTagY(MACD[i]));
                if (tmin < 0 && tmax > 0) {
                    ctx.lineTo(x, getTagY(0));
                } else if (tmin > 0) {
                    ctx.lineTo(x, getTagY(tmin));
                } else if (tmax < 0) {
                    ctx.lineTo(x, getTagY(tmax));
                }

                ctx.stroke();
            }

            drawCurve(DIF, M5Color);
            drawCurve(DEA, M10Color);
            break;
        case "DMI":
            var Pdi = [];
            var Mdi = [];
            var Adx = [];
            var Adxr = [];
            allArr = [];

            for (var i = start; i < end; i++) {
                Pdi.push(PDI[i]);
                Mdi.push(MDI[i]);
                Adx.push(ADX[i]);
                Adxr.push(ADXR[i]);

                allArr.push(PDI[i]);
                allArr.push(MDI[i]);
                allArr.push(ADX[i]);
                allArr.push(ADXR[i]);
            }

            tmax = Math.max.apply(Math, allArr);
            tmin = Math.min.apply(Math, allArr);

            for (var i = 0; i < 3; i++) {
                y = parseInt(theight * 2 * 7.2 / 10) + sheight + (theight * 2 - parseInt(theight * 2 * 7.2 / 10)) * i / 3;
                ctx.fillText((tmax - i * (tmax - tmin) / 3).toFixed(2), swidth + twidth * 2 + 5, y + 5, width * 2 + 2 - swidth - twidth * 2);
                
            }
            drawCurve(Pdi, M5Color);
            drawCurve(Mdi, M10Color);
            drawCurve(Adx, M20Color);
            drawCurve(Adxr, M60Color);
            break;
        case "DMA":
            var tDif = [];
            var Ama = [];
            allArr = [];
            for (var i = start; i < end; i++) {
                tDif.push(tDIF[i]);
                Ama.push(AMA[i]);

                allArr.push(tDIF[i]);
                allArr.push(AMA[i]);
            }
            tmax = Math.max.apply(Math, allArr);
            tmin = Math.min.apply(Math, allArr);

            for (var i = 0; i < 3; i++) {
                y = parseInt(theight * 2 * 7.2 / 10) + sheight + (theight * 2 - parseInt(theight * 2 * 7.2 / 10)) * i / 3;
                ctx.fillText((tmax - i * (tmax - tmin) / 3).toFixed(2), swidth + twidth * 2 + 5, y + 5, width * 2 + 2 - swidth - twidth * 2);
                
            }
            
            drawCurve(tDif, M5Color);
            drawCurve(Ama, M10Color);
            break;
        case "FSL":
            var Swl = [];
            var Sws = [];
            allArr = [];
            for (var i = start; i < end; i++) {
                Swl.push(SWL[i]);
                Sws.push(SWS[i]);

                allArr.push(SWL[i]);
                allArr.push(SWS[i]);
            }

            tmax = Math.max.apply(Math, allArr);
            tmin = Math.min.apply(Math, allArr);

            for (var i = 0; i < 3; i++) {
                y = parseInt(theight * 2 * 7.2 / 10) + sheight + (theight * 2 - parseInt(theight * 2 * 7.2 / 10)) * i / 3;
                ctx.fillText((tmax - i * (tmax - tmin) / 3).toFixed(2), swidth + twidth * 2 + 5, y + 5, width * 2 + 2 - swidth - twidth * 2);
                
            }

            drawCurve(Swl, M5Color);
            drawCurve(Sws, M10Color);
            break;
        case "TRIX":
            var Trix = [];
            var Matrix = [];
            allArr = [];
            for (var i = start; i < end; i++) {
                Trix.push(TRIX[i]);
                Matrix.push(MATRIX[i]);

                allArr.push(TRIX[i]);
                allArr.push(MATRIX[i]);
            }

            tmax = Math.max.apply(Math, allArr);
            tmin = Math.min.apply(Math, allArr);


            for (var i = 0; i < 3; i++) {
                y = parseInt(theight * 2 * 7.2 / 10) + sheight + (theight * 2 - parseInt(theight * 2 * 7.2 / 10)) * i / 3;
                ctx.fillText((tmax - i * (tmax - tmin) / 3).toFixed(2), swidth + twidth * 2 + 5, y + 5, width * 2 + 2 - swidth - twidth * 2);
                
            }

            drawCurve(Trix, M5Color);
            drawCurve(Matrix, M10Color);
            break;
        case "BRAR":
            var Br = [];
            var Ar = [];
            allArr = [];
            for (var i = start; i < end; i++) {
                Br.push(BR[i]);
                Ar.push(AR[i]);

                allArr.push(BR[i]);
                allArr.push(AR[i]);
            }

            tmax = Math.max.apply(Math, allArr);
            tmin = Math.min.apply(Math, allArr);


         
            for (var i = 0; i < 3; i++) {
                y = parseInt(theight * 2 * 7.2 / 10) + sheight + (theight * 2 - parseInt(theight * 2 * 7.2 / 10)) * i / 3;
                ctx.fillText((tmax - i * (tmax - tmin) / 3).toFixed(2), swidth + twidth * 2 + 5, y + 5, width * 2 + 2 - swidth - twidth * 2);
                
            }

            drawCurve(Br, M5Color);
            drawCurve(Ar, M10Color);
            break;
        case "CR":
            var Cr = [];
            var Ma1 = [];
            var Ma2 = [];
            var Ma3 = [];
            var Ma4 = [];

            allArr = [];

            for (var i = start; i < end; i++) {
                Cr.push(CR[i]);
                Ma1.push(MA1[i]);
                Ma2.push(MA2[i]);
                Ma3.push(MA3[i]);
                Ma4.push(MA4[i]);

                allArr.push(CR[i]);
                allArr.push(MA1[i]);
                allArr.push(MA2[i]);
                allArr.push(MA3[i]);
                allArr.push(MA4[i]);
            }

            tmax = Math.max.apply(Math, allArr);
            tmin = Math.min.apply(Math, allArr);

            for (var i = 0; i < 3; i++) {
                y = parseInt(theight * 2 * 7.2 / 10) + sheight + (theight * 2 - parseInt(theight * 2 * 7.2 / 10)) * i / 3;
                ctx.fillText((tmax - i * (tmax - tmin) / 3).toFixed(2), swidth + twidth * 2 + 5, y + 5, width * 2 + 2 - swidth - twidth * 2);
               
            }

            drawCurve(Cr, M5Color);
            drawCurve(Ma1, M10Color);
            drawCurve(Ma2, M20Color);
            drawCurve(Ma3, M60Color);
            drawCurve(Ma4, M70Color);
            break;
        case "VR":
            var Vr = [];
            var Mavr = [];
            allArr = [];
            for (var i = start; i < end; i++) {
                Vr.push(VR[i]);
                Mavr.push(MAVR[i]);
                if (!isNaN(VR[i])) {
                    allArr.push(VR[i]);
                }
                if (!isNaN(MAVR[i])) {
                    allArr.push(MAVR[i]);
                }
            }

            tmax = Math.max.apply(Math, allArr);
            tmin = Math.min.apply(Math, allArr);
        
            for (var i = 0; i < 3; i++) {
                y = parseInt(theight * 2 * 7.2 / 10) + sheight + (theight * 2 - parseInt(theight * 2 * 7.2 / 10)) * i / 3;
                ctx.fillText((tmax - i * (tmax - tmin) / 3).toFixed(2), swidth + twidth * 2 + 5, y + 5, width * 2 + 2 - swidth - twidth * 2);
                
            }

            drawCurve(Vr, M5Color);
            drawCurve(Mavr, M10Color);
            break;
        case "OBV":
            var Obv = [];
            var Maobv = [];

            allArr = [];
            for (var i = start; i < end; i++) {
                Obv.push(OBV[i]);
                Maobv.push(MAOBV[i]);

                allArr.push(OBV[i]);
                allArr.push(MAOBV[i]);
            }

            tmax = Math.max.apply(Math, allArr).toFixed(0);
            tmin = Math.min.apply(Math, allArr).toFixed(0);
        
            for (var i = 0; i < 3; i++) {
                y = parseInt(theight * 2 * 7.2 / 10) + sheight + (theight * 2 - parseInt(theight * 2 * 7.2 / 10)) * i / 3;
                ctx.fillText((tmax - i * tmax / 3).toFixed(0), swidth + twidth * 2 + 5, y + 5, width * 2 + 2 - swidth - twidth * 2);
                
            }

            drawCurve(Obv, M5Color);
            drawCurve(Maobv, M10Color);
            break;
        case "EMV":
            var Emv = [];
            var Maemv = [];
            allArr = [];
            for (var i = start; i < end; i++) {
                Emv.push(EMV[i]);
                Maemv.push(MAEMV[i]);

                allArr.push(EMV[i]);
                allArr.push(MAEMV[i]);
            }

            tmax = Math.max.apply(Math, allArr);
            tmin = Math.min.apply(Math, allArr);

            for (var i = 0; i < 3; i++) {
                y = parseInt(theight * 2 * 7.2 / 10) + sheight + (theight * 2 - parseInt(theight * 2 * 7.2 / 10)) * i / 3;
                ctx.fillText((tmax - i * (tmax - tmin) / 3).toFixed(2), swidth + twidth * 2 + 5, y + 5, width * 2 + 2 - swidth - twidth * 2);
                
            }

            drawCurve(Emv, M5Color);
            drawCurve(Maemv, M10Color);
            break;
        case "RSI":
            var Rsi1 = [];
            var Rsi2 = [];
            var Rsi3 = [];
            allArr = [];
            for (var i = start; i < end; i++) {
                Rsi1.push(RSI1[i]);
                Rsi2.push(RSI2[i]);
                Rsi3.push(RSI3[i]);

                allArr.push(RSI1[i]);
                allArr.push(RSI2[i]);
                allArr.push(RSI3[i]);
            }

            tmax = Math.max.apply(Math, allArr);
            tmin = Math.min.apply(Math, allArr);

            for (var i = 0; i < 3; i++) {
                y = parseInt(theight * 2 * 7.2 / 10) + sheight + (theight * 2 - parseInt(theight * 2 * 7.2 / 10)) * i / 3;
                ctx.fillText((tmax - i * (tmax - tmin) / 3).toFixed(2), swidth + twidth * 2 + 5, y + 5, width * 2 + 2 - swidth - twidth * 2);
               
            }
            drawCurve(Rsi1, M5Color);
            drawCurve(Rsi2, M10Color);
            drawCurve(Rsi3, M20Color);
            break;
        case "WR":
            var Wr1 = [];
            var Wr2 = [];

            allArr = [];
            for (var i = start; i < end; i++) {
                Wr1.push(WR1[i]);
                Wr2.push(WR2[i]);
                if (!isNaN(WR1[i])) {
                    allArr.push(WR1[i]);
                }
                if (!isNaN(WR2[i])) {
                    allArr.push(WR2[i]);
                }

            }

            tmax = Math.max.apply(Math, allArr);
            tmin = Math.min.apply(Math, allArr);

            for (var i = 0; i < 3; i++) {
                y = parseInt(theight * 2 * 7.2 / 10) + sheight + (theight * 2 - parseInt(theight * 2 * 7.2 / 10)) * i / 3;
                ctx.fillText((tmax - i * (tmax - tmin) / 3).toFixed(2), swidth + twidth * 2 + 5, y + 5, width * 2 + 2 - swidth - twidth * 2);
                
            }

            drawCurve(Wr1, M5Color);
            drawCurve(Wr2, M10Color);
            break;
        case "KDJ":
            var K = [];
            var D = [];
            var J = [];
            allArr = [];
            for (var i = start; i < end; i++) {
                K.push(k[i]);
                D.push(d[i]);
                J.push(j[i]);

                allArr.push(k[i]);
                allArr.push(d[i]);
                allArr.push(j[i]);
            }

            tmax = Math.max.apply(Math, allArr);
            tmin = Math.min.apply(Math, allArr);
          
            for (var i = 0; i < 3; i++) {
                y = parseInt(theight * 2 * 7.2 / 10) + sheight + (theight * 2 - parseInt(theight * 2 * 7.2 / 10)) * i / 3;
                ctx.fillText((tmax - i * (tmax - tmin) / 3).toFixed(2), swidth + twidth * 2 + 5, y + 5, width * 2 + 2 - swidth - twidth * 2);
                
            }

            drawCurve(K, M5Color);
            drawCurve(D, M10Color);
            drawCurve(J, M20Color);
            break;
        case "CCI":
            var Cci = [];
            allArr = [];
            for (var i = start; i < end; i++) {
                Cci.push(CCI[i]);
                if (!isNaN(CCI[i])) {
                    allArr.push(CCI[i]);
                }
            }

            tmax = Math.max.apply(Math, allArr);
            tmin = Math.min.apply(Math, allArr);

            for (var i = 0; i < 3; i++) {
                y = parseInt(theight * 2 * 7.2 / 10) + sheight + (theight * 2 - parseInt(theight * 2 * 7.2 / 10)) * i / 3;
                ctx.fillText((tmax - i * (tmax - tmin) / 3).toFixed(2), swidth + twidth * 2 + 5, y + 5, width * 2 + 2 - swidth - twidth * 2);
            }

            drawCurve(Cci, M5Color);
            break;
        case "ROC":
            var Roc = [];
            var Maroc = [];

            allArr = [];
            for (var i = start; i < end; i++) {
                Roc.push(ROC[i]);
                Maroc.push(MAROC[i]);

                allArr.push(ROC[i]);
                allArr.push(MAROC[i]);
            }

            tmax = Math.max.apply(Math, allArr);
            tmin = Math.min.apply(Math, allArr);

            for (var i = 0; i < 3; i++) {
                y = parseInt(theight * 2 * 7.2 / 10) + sheight + (theight * 2 - parseInt(theight * 2 * 7.2 / 10)) * i / 3;
                ctx.fillText((tmax - i * (tmax - tmin) / 3).toFixed(2), swidth + twidth * 2 + 5, y + 5, width * 2 + 2 - swidth - twidth * 2);
                
            }

            drawCurve(Roc, M5Color);
            drawCurve(Maroc, M10Color);
            break;
        case "MTM":
            var Mtm = [];
            var Mamtm = [];
            allArr = [];
            for (var i = start; i < end; i++) {
                Mtm.push(MTM[i]);
                Mamtm.push(MAMTM[i]);

                allArr.push(MTM[i]);
                allArr.push(MAMTM[i]);
            }

            tmax = Math.max.apply(Math, allArr);
            tmin = Math.min.apply(Math, allArr);

            for (var i = 0; i < 3; i++) {
                y = parseInt(theight * 2 * 7.2 / 10) + sheight + (theight * 2 - parseInt(theight * 2 * 7.2 / 10)) * i / 3;
                ctx.fillText((tmax - i * (tmax - tmin) / 3).toFixed(2), swidth + twidth * 2 + 5, y + 5, width * 2 + 2 - swidth - twidth * 2);
               
            }

            drawCurve(Mtm, M5Color);
            drawCurve(Mamtm, M10Color);
            break;
        case "BOLL":
            var Boll = [];
            var Ub = [];
            var Lb = [];
            allArr = [];
            for (var i = start; i < end; i++) {
                Boll.push(BOLL[i]);
                Ub.push(UB[i]);
                Lb.push(LB[i]);
               
                allArr.push(BOLL[i]);
                allArr.push(UB[i]);
                allArr.push(LB[i]);
            }

            for (var i = 0; i < open.length; i++) {
                allArr.push(h[i]);
                allArr.push(l[i]);
            }
            tmax = Math.max.apply(Math, allArr);
            tmin = Math.min.apply(Math, allArr);
       
            for (var i = 0; i < 3; i++) {
                y = parseInt(theight * 2 * 7.2 / 10) + sheight + (theight * 2 - parseInt(theight * 2 * 7.2 / 10)) * i / 3;
                ctx.fillText((tmax - i * (tmax - tmin) / 3).toFixed(2), swidth + twidth * 2 + 5, y + 5, width * 2 + 2 - swidth - twidth * 2);
                
            }

            for (var i = 0; i < open.length; i++) {
                x = 1.5 + swidth + (barW + space) * i;

                if (parseFloat(open[i]) < parseFloat(close[i])) {
                    color = red;
                } else if (parseFloat(open[i]) > parseFloat(close[i])) {
                    color = lightBlue;
                } else {
                    color = white;
                }
                ctx.beginPath();
                ctx.lineWidth = 1;
                ctx.strokeStyle = color;

                if (open[i] != close[i]) {
                    ctx.moveTo(x, getTagY(open[i]));
                    ctx.lineTo(x + barW / 2, getTagY(open[i]));

                    ctx.moveTo(x + barW / 2, getTagY(close[i]));
                    ctx.lineTo(x + barW, getTagY(close[i]));

                    ctx.moveTo(x + barW / 2, getTagY(open[i]));
                    ctx.lineTo(x + barW / 2, getTagY(close[i]));

                    if (parseFloat(open[i]) < parseFloat(close[i])) {
                        ctx.moveTo(x + parseInt(barW / 2), getTagY(h[i]));
                        ctx.lineTo(x + parseInt(barW / 2), getTagY(close[i]));

                        ctx.moveTo(x + parseInt(barW / 2), getTagY(l[i]));
                        ctx.lineTo(x + parseInt(barW / 2), getTagY(open[i]));
                    } else {
                        ctx.moveTo(x + parseInt(barW / 2), getTagY(h[i]));
                        ctx.lineTo(x + parseInt(barW / 2), getTagY(l[i]));
                    }
                } else {
                    ctx.moveTo(x, getTagY(close[i - 1]));
                    ctx.lineTo(x + barW, getTagY(close[i - 1]));
                }
                ctx.stroke();
            }

            drawCurve(Boll, M5Color, 1.5);
            drawCurve(Ub, M10Color, 1.5);
            drawCurve(Lb, M20Color, 1.5);
            break;
        case "PSY":
            var Psy = [];
            var Mapsy = [];
            allArr = [];
            for (var i = start; i < end; i++) {
                Psy.push(PSY[i]);
                Mapsy.push(MAPSY[i]);

                allArr.push(PSY[i]);
                allArr.push(MAPSY[i]);
            }

            tmax = Math.max.apply(Math, allArr);
            tmin = Math.min.apply(Math, allArr);

            for (var i = 0; i < 3; i++) {
                y = parseInt(theight * 2 * 7.2 / 10) + sheight + (theight * 2 - parseInt(theight * 2 * 7.2 / 10)) * i / 3;
                ctx.fillText((tmax - i * (tmax - tmin) / 3).toFixed(2), swidth + twidth * 2 + 5, y + 5, width * 2 + 2 - swidth - twidth * 2);
                
            }

            drawCurve(Psy, M5Color);
            drawCurve(Mapsy, M10Color);
            break;
        case "MCST":
            var Mcst = [];
            allArr = [];
            for (var i = start; i < end; i++) {
                Mcst.push(MCST[i]);
                allArr.push(MCST[i]);
            }
           
            tmax = Math.max.apply(Math, allArr);
            tmin = Math.min.apply(Math, allArr);

            for (var i = 0; i < 3; i++) {
                y = parseInt(theight * 2 * 7.2 / 10) + sheight + (theight * 2 - parseInt(theight * 2 * 7.2 / 10)) * i / 3;
                ctx.fillText((tmax - i * (tmax - tmin) / 3).toFixed(2), swidth + twidth * 2 + 5, y + 5, width * 2 + 2 - swidth - twidth * 2);
                
            }

            drawCurve(Mcst, M5Color);
            break;
        case "ZL":
            var zl = [];
            var zl1 = [];
            var zl2 = [];
            allArr = [];

            for (var i = start; i < end; i++) {
                zl.push(ZL[i]);
                zl1.push(ZL1[i]);
                zl2.push(ZL2[i]);

                allArr.push(ZL[i]);
                allArr.push(ZL1[i]);
                allArr.push(ZL2[i]);
            }
            for (var i = 0; i < open.length; i++) {
                allArr.push(h[i]);
                allArr.push(l[i]);
            }
            tmax = Math.max.apply(Math, allArr);
            tmin = Math.min.apply(Math, allArr);

            for (var i = 0; i < 3; i++) {
                y = parseInt(theight * 2 * 7.2 / 10) + sheight + (theight * 2 - parseInt(theight * 2 * 7.2 / 10)) * i / 3;
                ctx.fillText((tmax - i * (tmax - tmin) / 3).toFixed(2), swidth + twidth * 2 + 5, y + 5, width * 2 + 2 - swidth - twidth * 2);
                
            }

            for (var i = 0; i < open.length; i++) {
                x = 1.5 + swidth + (barW + space) * i;

                if (parseFloat(open[i]) < parseFloat(close[i])) {
                    color = red;
                } else if (parseFloat(open[i]) > parseFloat(close[i])) {
                    color = green;
                } else {
                    color = black;
                }
                ctx.beginPath();
                ctx.lineWidth = 1;
                ctx.strokeStyle = color;

                if (open[i] != close[i]) {
                    ctx.moveTo(x, getTagY(open[i]));
                    ctx.lineTo(x + barW / 2, getTagY(open[i]));

                    ctx.moveTo(x + barW / 2, getTagY(close[i]));
                    ctx.lineTo(x + barW, getTagY(close[i]));

                    ctx.moveTo(x + barW / 2, getTagY(open[i]));
                    ctx.lineTo(x + barW / 2, getTagY(close[i]));

                    if (parseFloat(open[i]) < parseFloat(close[i])) {
                        ctx.moveTo(x + parseInt(barW / 2), getTagY(h[i]));
                        ctx.lineTo(x + parseInt(barW / 2), getTagY(close[i]));

                        ctx.moveTo(x + parseInt(barW / 2), getTagY(l[i]));
                        ctx.lineTo(x + parseInt(barW / 2), getTagY(open[i]));
                    } else {
                        ctx.moveTo(x + parseInt(barW / 2), getTagY(h[i]));
                        ctx.lineTo(x + parseInt(barW / 2), getTagY(l[i]));
                    }
                } else {
                    ctx.moveTo(x, getTagY(close[i - 1]));
                    ctx.lineTo(x + barW, getTagY(close[i - 1]));
                }
                ctx.stroke();
            }

            drawCurve(zl, M5Color, 1.5);
            drawCurve(zl1, M10Color, 1.5);
            drawCurve(zl2, M20Color, 1.5);
            break;
        default:
            break;
    }
}

function getTarget() {
    
    var open1 = [];
    var close1 = [];
    var preClose1 = [];
    var high1 = [];
    var low1 = [];
    var vol1 = [];
    var amount = [];
    var CmC = [];
    var Ema5 = [];
    var Ema10 = [];
    var Ema12 = [];
    var Ema26 = [];
    var rsv = [];
    var arr = [];
    var MTR = [];
    var DMP = [];
    var DMM = [];
    var HD = [];
    var LD = [];
    var TMTR1 = [];
    var TMTR = [];
    var LM = [];
    var HM = [];
    var LO = [];
    var HO = [];
    var MID = [];
    var CRu = [];
    var CRd = [];
    var TH = [];
    var TL = [];
    var TQ = [];
    var TH1 = [];
    var TL1 = [];
    var TQ1 = [];
    var VA = [];
    var VB = [];
    var volUME = [];
    var tMID = [];
    var HsL = [];
    var MAHsL = [];
    var UEMV = [];
    var CsC = [];
    var ABSCsC = [];
    var RSI1U = [];
    var RSI1D = [];
    var RSI2U = [];
    var RSI2D = [];
    var RSI3U = [];
    var RSI3D = [];
    var CmC = [];
    var CT = [];

    value = [];
    valText = [];
    switch (target) {
        case "VOL":
           value[0] = 5;
           value[1] = 10;
            break;
        case "MACD":
           value[0] = 12;
           value[1] = 26;
           value[2] = 9;

            valText[0] = "日快线移动平均";
            valText[1] = "日慢线移动平均";
            valText[2] = "日移动平均";

            minvalue[0] = 2;
            minvalue[1] = 2;
            minvalue[2] = 2;

            maxvalue[0] = 200;
            maxvalue[1] = 200;
            maxvalue[2] = 200;

            quantity = 3;
            break;
        case "DMI":
           value[0] = 14;
           value[1] = 6;

            valText[0] = "日DMI";
            valText[1] = "日移动平均";

            minvalue[0] = 2;
            minvalue[1] = 2;

            maxvalue[0] = 90;
            maxvalue[1] = 60;

            quantity = 2;
            break;
        case "DMA":
           value[0] = 10;
           value[1] = 50;
           value[2] = 10;

            valText[0] = "日快线移动平均";
            valText[1] = "日慢线移动平均";
            valText[2] = "日移动平均";

            minvalue[0] = 2;
            minvalue[1] = 2;
            minvalue[2] = 2;

            maxvalue[0] = 60;
            maxvalue[1] = 250;
            maxvalue[2] = 100;

            quantity = 3;
            break;
        case "FSL":
            quantity = 0;
            break;
        case "TRIX":
           value[0] = 12;
           value[1] = 9;

            valText[0] = "日TRIX";
            valText[1] = "日移动平均";

            minvalue[0] = 2;
            minvalue[1] = 2;

            maxvalue[0] = 100;
            maxvalue[1] = 100;

            quantity = 2;
            break;
        case "BRAR":
           value[0] = 26;

            minvalue[0] = 2;
            maxvalue[0] = 120;

            valText[0] = "日情绪指标";

            quantity = 1;
            break;
        case "CR":
           value[0] = 26;
           value[1] = 10;
           value[2] = 20;
           value[3] = 40;
           value[4] = 62;

            valText[0] = "日带状能量线";
            valText[1] = "日移动平均";
            valText[2] = "日移动平均";
            valText[3] = "日移动平均";
            valText[4] = "日移动平均";

            minvalue[0] = 2;
            minvalue[1] = 0;
            minvalue[2] = 0;
            minvalue[3] = 0;
            minvalue[4] = 0;

            maxvalue[0] = 100;
            maxvalue[1] = 100;
            maxvalue[2] = 100;
            maxvalue[3] = 100;
            maxvalue[4] = 100;

            quantity = 5;
            break;
        case "VR":
           value[0] = 26;
           value[1] = 10;

            valText[0] = "日成交量变异率";
            valText[1] = "日移动平均";

            minvalue[0] = 2;
            minvalue[1] = 2;

            maxvalue[0] = 100;
            maxvalue[1] = 100;

            quantity = 2;
            break;
        case "OBV":
           value[0] = 30;

            valText[0] = "日移动平均";

            minvalue[0] = 2;
            maxvalue[0] = 100;

            quantity = 1;
            break;
        case "EMV":
           value[0] = 14;
           value[1] = 9;

            valText[0] = "日EMV";
            valText[1] = "日移动平均";

            minvalue[0] = 2;
            minvalue[1] = 2;

            maxvalue[0] = 90;
            maxvalue[1] = 60;

            quantity = 2;
            break;
        case "RSI":
           value[0] = 6;
           value[1] = 12;
           value[2] = 24;

            valText[0] = "日RSI[相对强弱]";
            valText[1] = "日RSI[相对强弱]";
            valText[2] = "日RSI[相对强弱]";

            minvalue[0] = 2;
            minvalue[1] = 2;
            minvalue[2] = 2;

            maxvalue[0] = 120;
            maxvalue[1] = 250;
            maxvalue[2] = 500;

            quantity = 3;
            break;
        case "WR":
           value[0] = 10;
           value[1] = 6;

            valText[0] = "日威廉指标";
            valText[1] = "日威廉指标";

            minvalue[0] = 2;
            minvalue[1] = 2;

            maxvalue[0] = 100;
            maxvalue[1] = 100;

            quantity = 2;
            break;
        case "KDJ":
           value[0] = 9;
           value[1] = 3;
           value[2] = 3;

            valText[0] = "天";
            valText[1] = "天";
            valText[2] = "天";

            minvalue[0] = 2;
            minvalue[1] = 2;
            minvalue[2] = 2;

            maxvalue[0] = 90;
            maxvalue[1] = 30;
            maxvalue[2] = 30;

            quantity = 3;
            break;
        case "CCI":
           value[0] = 14;

            valText[0] = "天";

            minvalue[0] = 2;
            maxvalue[0] = 100;

            quantity = 1;
            break;
        case "ROC":
           value[0] = 12;
           value[1] = 6;

            valText[0] = "日变动率";
            valText[1] = "日移动平均";

            minvalue[0] = 2;
            minvalue[1] = 2;

            maxvalue[0] = 120;
            maxvalue[1] = 60;
            quantity = 2;
            break;
        case "MTM":
           value[0] = 12;
           value[1] = 6;

            valText[0] = "日动量线";
            valText[1] = "日移动平均";

            minvalue[0] = 2;
            minvalue[1] = 2;

            maxvalue[0] = 120;
            maxvalue[1] = 60;
            quantity = 2;
            break;
        case "BOLL":
           value[0] = 20;

            valText[0] = "日布林线";

            minvalue[0] = 2;
            maxvalue[0] = 120;
            break;
        case "PSY":
           value[0] = 12;
           value[1] = 6;

            valText[0] = "日心理线";
            valText[1] = "日移动平均";

            minvalue[0] = 2;
            minvalue[1] = 2;

            maxvalue[0] = 100;
            maxvalue[1] = 100;
            quantity = 2;
            break;
        case "MCST":
            quantity = 0;
            break;
        case "ZL":
            quantity = 0;
            break;
        default:
            break;
    }

    var ema1 = [], ema2 = [], ema3 = [];
    for (var i = 0; i < kl.length; i++) {
        open1.push(parseFloat(kl[i].open));
        close1.push(parseFloat(kl[i].close));
        CmC.push(parseFloat(kl[i].close) * parseFloat(kl[i].close));
        preClose1.push(parseFloat(kl[i].preClose));
        high1.push(parseFloat(kl[i].high));
        low1.push(parseFloat(kl[i].low));
        amount.push(parseFloat(kl[i].turnover));
        vol1.push(parseFloat(kl[i].vol));

        switch (target) {
            case "MACD":
                if (i == 0) {
                    ema1[i] = close1[i];
                    ema2[i] = close1[i];
                } else {
                    ema1[i] = (2 * close1[i] + (value[0] - 1) * ema1[i - 1]) / (value[0] + 1);
                    ema2[i] = (2 * close1[i] + (value[1] - 1) * ema2[i - 1]) / (value[1] + 1);
                }

                if (i == 0) {
                    Dif[i] = 0;
                    Dea[i] = 0;
                } else {
                    Dif[i] = ema1[i] - ema2[i];
                    Dea[i] = (2 * Dif[i] + (value[2] - 1) * Dea[i - 1]) / (value[2] + 1);
                }
                Macd[i] = 2 * (Dif[i] - Dea[i]);
                break;
            case "DMI":
                arr = [];
                arr.push(high1[i] - low1[i]);
                arr.push(Math.abs(high1[i] - preClose1[i]));
                arr.push(Math.abs(preClose1[i] - low1[i]));
                var DMPVal, DMMVal;
                if (i == 0) {
                    MTR[i] = (2 * Math.max.apply(Math, arr) / 1000 + (value[0] - 1) * 50) / (value[0] + 1);
                    HD[i] = 0;
                    LD[i] = 0;
                    if (HD[i] > 0 && HD[i] > LD[i]) {
                        DMPVal = HD[i];
                    } else {
                        DMPVal = 0;
                    }
                    DMP[i] = (2 * DMPVal / 1000 + (value[0] - 1) * 50) / (value[0] + 1);
                    if (LD[i] > 0 && LD[i] > HD[i]) {
                        DMMVal = LD[i];
                    } else {
                        DMMVal = 0;
                    }
                    DMM[i] = (2 * DMMVal / 1000 + (value[0] - 1) * 50) / (value[0] + 1);
                    PDI[i] = DMP[i] * 100 / MTR[i];
                    MDI[i] = DMM[i] * 100 / MTR[i];
                    ADX[i] = (2 * Math.abs(MDI[i] - PDI[i]) / (MDI[i] + PDI[i]) * 100 + (value[1] - 1) * 50) / (value[1] + 1);
                    ADXR[i] = (2 * ADX[i] + (value[1] - 1) * 50) / (value[1] + 1);
                } else {
                    MTR[i] = (2 * Math.max.apply(Math, arr) / 1000 + (value[0] - 1) * MTR[i - 1]) / (value[0] + 1);
                    HD[i] = high1[i] - high1[i - 1];
                    LD[i] = low1[i - 1] - low1[i];
                    if (HD[i] > 0 && HD[i] > LD[i]) {
                        DMPVal = HD[i];
                    } else {
                        DMPVal = 0;
                    }
                    DMP[i] = (2 * DMPVal / 1000 + (value[0] - 1) * DMP[i - 1]) / (value[0] + 1);
                    if (LD[i] > 0 && LD[i] > HD[i]) {
                        DMMVal = LD[i];
                    } else {
                        DMMVal = 0;
                    }
                    DMM[i] = (2 * DMMVal / 1000 + (value[0] - 1) * DMM[i - 1]) / (value[0] + 1);
                    PDI[i] = DMP[i] * 100 / MTR[i];
                    MDI[i] = DMM[i] * 100 / MTR[i];
                    ADX[i] = (2 * Math.abs(MDI[i] - PDI[i]) / (MDI[i] + PDI[i]) * 100 + (value[1] - 1) * ADX[i - 1]) / (value[1] + 1);
                    ADXR[i] = (2 * ADX[i] + (value[1] - 1) * ADXR[i - 1]) / (value[1] + 1);
                }
                break;
            case "DMA":
                tDIF[i] = MA(value[0], i, close1) - MA(value[1], i, close1);
                AMA[i] = MA(value[2], i, tDIF);
                break;
            case "FSL":
                if (i == 0) {
                    ema1[i] = close1[i];
                    ema2[i] = close1[i];
                    ema3[i] = close1[i];
                } else {
                    ema1[i] = (2 * close1[i] + (5 - 1) * ema1[i - 1]) / (5 + 1);
                    ema2[i] = (2 * close1[i] + (10 - 1) * ema2[i - 1]) / (10 + 1);
                    ema3[i] = (2 * close1[i] + (12 - 1) * ema3[i - 1]) / (12 + 1);
                }
                var a = Math.min(1, 100 * SUM(5, i, vol1) / (3 * ltag));        /*之前是max*/
                SWL[i] = (ema1[i] * 7 + ema2[i] * 3) / 10;
                if (i == 0) { /*DMA方法不好用 暂用EMA代替*/
                    SWS[i] = (2 * ema3[i] + (5 - 1) * 50) / (5 + 1);
                } else {
                    SWS[i] = (2 * ema3[i] + (5 - 1) * SWS[i - 1]) / (5 + 1);
                }
                break;
            case "TRIX":
                if (i == 0) {
                    ema1[i] = close1[i];

                } else {
                    ema1[i] = (2 * close1[i] + (value[0] - 1) * ema1[i - 1]) / (value[0] + 1);
                }
                if (i == 0) {
                    TMTR1[i] = (2 * ema1[i] + (value[0] - 1) * 50) / (value[0] + 1);
                    TMTR[i] = (2 * TMTR1[i] + (value[0] - 1) * 50) / (value[0] + 1);
                    TRIX[i] = 0;

                } else {
                    TMTR1[i] = (2 * ema1[i] + (value[0] - 1) * TMTR1[i - 1]) / (value[0] + 1);
                    TMTR[i] = (2 * TMTR1[i] + (value[0] - 1) * TMTR[i - 1]) / (value[0] + 1);
                    TRIX[i] = (TMTR[i] - TMTR[i - 1]) / TMTR[i - 1] * 100;
                }
                MATRIX[i] = MA(value[1], i, TRIX);
                break;
            case "BRAR":
                HM[i] = Math.max(0, high1[i] - preClose1[i]);
                LM[i] = Math.max(0, preClose1[i] - low1[i]);

                HO[i] = Math.max(0, high1[i] - open1[i]);
                LO[i] = Math.max(0, open1[i] - low1[i]);

                BR[i] = (SUM(value[0], i, HM)) / (SUM(value[0], i, LM)) * 100;
                AR[i] = (SUM(value[0], i, HO)) / (SUM(value[0], i, LO)) * 100;
                break;
            case "CR":
                if (i == 0) {
                    MID[i] = 0;
                } else {
                    MID[i] = (high1[i - 1] + low1[i - 1]) / 2;
                }
                CRu[i] = Math.max(0, (high1[i]) - MID[i]);
                CRd[i] = Math.max(0, MID[i] - (low1[i]));
                if (i == 0) {
                    CR[i] = 0;
                } else {
                    CR[i] = SUM(value[0], i, CRu) / SUM(value[0], i, CRd) * 100;
                }

                MA1[i] = MA(value[1], parseInt(i - (1 + 10 / 2.5)), CR);
                MA2[i] = MA(value[2], parseInt(i - (1 + 20 / 2.5)), CR);
                MA3[i] = MA(value[3], parseInt(i - (1 + 40 / 2.5)), CR);
                MA4[i] = MA(value[4], parseInt(i - (1 + 62 / 2.5)), CR);
                break;
            case "VR":
                if (i == 0) {
                    TH1[i] = 0;
                } else {
                    if (close1[i] > preClose1[i]) {
                        TH1[i] = vol1[i];
                    }
                    else {
                        TH1[i] = 0;
                    }
                }
                TH[i] = SUM(value[0], i, TH1);

                if (i == 0) {
                    TL1[i] = 0;
                } else {
                    if (close1[i] < preClose1[i]) {
                        TL1[i] = vol1[i];
                    }
                    else {
                        TL1[i] = 0;
                    }
                }
                TL[i] = SUM(value[0], i, TL1);

                if (i == 0) {
                    TQ1[i] = 0;
                } else {
                    if (close1[i] == preClose1[i]) {
                        TQ1[i] = vol1[i];
                    }
                    else {
                        TQ1[i] = 0;
                    }
                }
                TQ[i] = SUM(value[0], i, TQ1);

                VR[i] = 100 * (TH[i] * 2 + TQ[i]) / (TL[i] * 2 + TQ[i]);
                MAVR[i] = MA(value[1], i, VR);

                break;
            case "OBV":

                if (i == 0) {
                    VA[i] = vol1[i];
                } else {
                    if (close1[i] > preClose1[i])
                    { VA[i] = vol1[i]; }
                    else
                    { VA[i] = -1 * vol1[i]; }
                }

                if (i == 0) {
                    VB[i] = VA[i];
                } else {
                    if (close1[i] == preClose1[i])
                    { VB[i] = 0; }
                    else
                    { VB[i] = VA[i]; }
                }
                OBV[i] = SUM(i + 1, i, VB);
               
                MAOBV[i] = MA(value[0], i, OBV);
                break;
            case "EMV":
               
                volUME[i] = MA(value[0], i, vol1) / vol1[i];
               
                if (i == 0) {
                    tMID[i] = 100;
                } else {
                    tMID[i] = 100 * (high1[i] + low1[i] - high1[i - 1] - low1[i - 1]) / (high1[i] + low1[i]);
                }
             
                HsL[i] = (high1[i] - low1[i]) / 1000;
                MAHsL[i] = MA(value[0], i, HsL);
                UEMV[i] = tMID[i] * volUME[i] * HsL[i] / MAHsL[i];
                EMV[i] = MA(value[0], i, UEMV);
               
                MAEMV[i] = MA(value[1], i, EMV);

                break;
            case "RSI":
                if (close1[i] > preClose1[i]) {
                    CsC[i] = close1[i] - preClose1[i];
                } else {
                    CsC[i] = 0;
                }
                if (close1[i] > preClose1[i]) {
                    ABSCsC[i] = close1[i] - preClose1[i];
                } else if (close1[i] < preClose1[i]) {
                    ABSCsC[i] = preClose1[i] - close1[i];
                } else {
                    ABSCsC[i] = 0;
                }
               
                if (i == 0) {
                    RSI1U[i] = (CsC[i] + (value[0] - 1) * 50) / value[0];
                    RSI1D[i] = (ABSCsC[i] + (value[0] - 1) * 50) / value[0];
                } else {
                    RSI1U[i] = (CsC[i] + (value[0] - 1) * RSI1U[i - 1]) / value[0];
                    RSI1D[i] = (ABSCsC[i] + (value[0] - 1) * RSI1D[i - 1]) / value[0];
                }
                RSI1[i] = RSI1U[i] / RSI1D[i] * 100;
              
                if (i == 0) {
                    RSI2U[i] = (CsC[i] + (value[1] - 1) * 50) / value[1];
                    RSI2D[i] = (ABSCsC[i] + (value[1] - 1) * 50) / value[1];
                } else {
                    RSI2U[i] = (CsC[i] + (value[1] - 1) * RSI2U[i - 1]) / value[1];
                    RSI2D[i] = (ABSCsC[i] + (value[1] - 1) * RSI2D[i - 1]) / value[1];
                }
                RSI2[i] = RSI2U[i] / RSI2D[i] * 100;
               
                if (i == 0) {
                    RSI3U[i] = (CsC[i] + (value[2] - 1) * 50) / value[2];
                    RSI3D[i] = (ABSCsC[i] + (value[2] - 1) * 50) / value[2];
                } else {
                    RSI3U[i] = (CsC[i] + (value[2] - 1) * RSI3U[i - 1]) / value[2];
                    RSI3D[i] = (ABSCsC[i] + (value[2] - 1) * RSI3D[i - 1]) / value[2];
                }
                RSI3[i] = RSI3U[i] / RSI3D[i] * 100;
                break;
            case "WR":
                WR1[i] = 100 * (HHV(value[0], i, high1) - close1[i]) / (HHV(value[0], i, high1) - HHV(value[0], i, low1));     
                WR2[i] = 100 * (HHV(value[1], i, high1) - close1[i]) / (HHV(value[1], i, high1) - HHV(value[1], i, low1));
                break;
            case "KDJ":
                rsv = ((close1[i]) - LLV(value[0], i, low1)) / (HHV(value[0], i, high1) - LLV(value[0], i, low1)) * 100;
                if (i == 0) 
                {
                    k[i] = (rsv + (value[1] - 1) * 50) / value[1];
                    d[i] = (k[i] + (value[2] - 1) * 50) / value[2];

                } else {
                    k[i] = (rsv + (value[1] - 1) * k[i - 1]) / value[1];
                    d[i] = (k[i] + (value[2] - 1) * d[i - 1]) / value[2];
                }

                j[i] = 3 * k[i] - 2 * d[i];
                break;
            case "CCI":
                TYP[i] = (high1[i] + low1[i] + close1[i]) / 3;
                CCI[i] = (TYP[i] - MA(value[0], i, TYP)) / (0.015 * AVEDEV(value[0], i, TYP));
                break;
            case "ROC":
                if (i < value[0]) {
                    ROC[i] = 100 * (close1[i] - close1[0]) / close1[0];
                } else {
                    ROC[i] = 100 * (close1[i] - close1[i - value[0]]) / close1[i - value[0]];
                }
                MAROC[i] = MA(value[1], i, ROC);
                break;
            case "MTM":
                if (i < value[0]) {
                    MTM[i] = close1[i] - close1[0];
                } else {
                    MTM[i] = close1[i] - close1[i - value[0]];
                }
                MAMTM[i] = MA(value[1], i, MTM);
                break;
            case "BOLL":
                BOLL[i] = MA(value[0], i, close1);
                var sqrt = Math.sqrt(MA(value[0], i, CmC) - MA(value[0], i, close1) * MA(value[0], i, close1)) * value[0] / (value[0] - 1);
                UB[i] = BOLL[i] + 2 * sqrt;
                LB[i] = BOLL[i] - 2 * sqrt;
                break;
            case "PSY":
                PSY[i] = COUNT(value[0], i, close1, preClose1) / value[0] * 100;
                MAPSY[i] = MA(value[1], i, PSY);
                break;
            case "MCST":
                CT[i] = amount[i] / (100 * vol1[i]);
                if (i == 0) {
                    MCST[i] = vol1[i] / (ltag) * CT[i];
                } else {
                    MCST[i] = vol1[i] / (ltag) * CT[i] + (1 - vol1[i] / (ltag)) * MCST[i - 1];
                }
                break;
            case "ZL":
                ZL[i] = parseFloat(kl[i].zl);
                if (stkCode.substring(0, 3) == '399' && market == 'SZ' || stkCode.substring(0, 3) == '000' && market == 'SH') {
                    ZL1[i] = parseFloat(kl[i].zl) * 0.9;
                    ZL2[i] = parseFloat(kl[i].zl) * 1.1;
                } else {
                    ZL1[i] = parseFloat(kl[i].zl) * 0.8;
                    ZL2[i] = parseFloat(kl[i].zl) * 1.2;
                }
                break;
            default:
                break;
        }
    }
    var color = '';

    paintTag();
}

function drawKInterface() {

    drawKBG();
    inside();

    HL = [];
    vol = [];
    turnover = [];
    h = [];
    l = [];
    open = [];
    close = [];
    lastClose = [];
    tradingDate = [];
    avg5 = [];
    avg10 = [];
    avg20 = [];
    avg60 = [];
    vol5 = [];
    vol10 = [];
    xxdlN = [];

    var count = parseInt((twidth * 2 + space - barW - space) / (barW + space));

    start = kl.length - count;
    end = start + count;

    for (var i = start; i < end; i++) {
        if (i < kl.length) {
            if (kl[i].high != 0) {
                HL.push(kl[i].high);
            }
            if (kl[i].low != 0) {
                HL.push(kl[i].low);

            }
            if (kl[i].avg5 != 0) {
                HL.push(kl[i].avg5);

            }
            if (kl[i].avg10 != 0) {
                HL.push(kl[i].avg10);

            }
            if (kl[i].avg20 != 0) {
                HL.push(kl[i].avg20);

            }
            if (kl[i].avg60 != 0) {
                HL.push(kl[i].avg60);

            }
            if (kl[i].open != 0) {
                HL.push(kl[i].open);

            }
            if (kl[i].close != 0) {
                HL.push(kl[i].close);

            }
            h.push(parseFloat(kl[i].high).toFixed(num));
            l.push(parseFloat(kl[i].low).toFixed(num));
            open.push(parseFloat(kl[i].open).toFixed(num));
            close.push(parseFloat(kl[i].close).toFixed(num));
            lastClose.push(parseFloat(kl[i].preClose).toFixed(num));
            xxdlN.push(kl[i].xxdl)

            tradingDate.push(convertDate(kl[i].data, false));
            
            avg5.push(kl[i].avg5);
            avg10.push(kl[i].avg10);
            avg20.push(kl[i].avg20);
            avg60.push(kl[i].avg60);
            turnover.push(kl[i].turnover);
            vol.push(kl[i].vol);
            vol5.push(kl[i].vol5);
            vol10.push(kl[i].vol10);
        }
    }
    var maxVol = Math.max.apply(Math, vol);
    var max = Math.max.apply(Math, HL);
    var min = Math.min.apply(Math, HL);

    if (max == min) {
        max = max * 1.05;
        min = min * 0.95;
    }


    var ll = 0.3;
    if (price > 100) {
        ll = 0.4;
    }
    
    var fontNum = 0;

    ctx.fillStyle = black;
    ctx.textAlign = 'left';
    ctx.font = (fontSize - 1) + "px 黑体";

    for (var i = 0; i < 7; i++) {
        y = parseInt(theight * 2 * i / 10) + sheight + parseInt((width * 0.3) / (price.toFixed(num).toString().length)) / 2;
        ctx.fillText((max - i * (max - min) / 6).toFixed(num), swidth + twidth * 2 + 5, y + fontSize * 0.1, width * 2 + 2 - swidth - twidth * 2);
    }
    for (var i = 0; i < 3; i++) {
        if (i == 0) {
            y = parseInt(theight * 2 * 7.2 / 10) + sheight;
        } else if (i == 1) {
            y = parseInt(theight * 2 * 7.2 / 10) + sheight + (theight * 2 + sheight - y) / 3;
        } else if (i == 2) {
            y = parseInt(theight * 2 * 7.2 / 10) + sheight + (theight * 2 + sheight - y);
        }
        ctx.fillText((maxVol - i * maxVol / 3).toFixed(0), swidth + twidth * 2 + 5, y + fontSize * 0.1, width * 2 + 2 - swidth - twidth * 2);
    }
    ctx.font = font;
    ctx.fillStyle = black;
    function getY(val) {
        if (val < min) {
            val = min;
        }
        var n = (max - val) / ((max - min) / 6);
        return sheight + parseInt(parseInt((theight * 2 + sheight) * 0.45 * 0.12) + 0.5 + n * (parseInt((theight * 2 + sheight) * 0.45 * 0.92) - parseInt((theight * 2 + sheight) * 0.45 * 0.12)) / 6) + 0.5;
    }

    function getVolY(val) {
        var n = (maxVol - val) / (maxVol / 3);
        var yzb = parseInt(theight * 2 * 7.2 / 10) + sheight + n * (theight * 2 - parseInt(theight * 2 * 7.2 / 10)) / 3;
        
        if(yzb <  parseInt(theight * 2 * 6 / 10) + sheight){
        	yzb =  parseInt(theight * 2 * 6 / 10) + sheight + 10;
        }
        
        return yzb;
    }

    var color = white;
    
    for (var i = 0; i < count; i++) {
        x = (barW + space) * i + 4;
       
        if (parseFloat(open[i]) < parseFloat(close[i])) {
            color = red;
        } else if (parseFloat(open[i]) > parseFloat(close[i])) {
            color = green;
        } else {
            color = black;
        }

        ctx.beginPath();
        ctx.strokeStyle = color;
        ctx.lineWidth = 2;
    
        //if (parseFloat(open[i]) != parseFloat(close[i])) {
            ctx.moveTo(x, getY(open[i]));
            ctx.lineTo(x + barW, getY(open[i]));

            ctx.moveTo(x, getY(close[i]));
            ctx.lineTo(x + barW, getY(close[i]));

            ctx.moveTo(x, getY(open[i]));
            ctx.lineTo(x, getY(close[i]));

            ctx.moveTo(x + barW, getY(open[i]));
            ctx.lineTo(x + barW, getY(close[i]));

            if (parseFloat(open[i]) < parseFloat(close[i])) {
                ctx.moveTo(x + parseInt(barW / 2), getY(h[i]));
                ctx.lineTo(x + parseInt(barW / 2), getY(close[i]));

                ctx.moveTo(x + parseInt(barW / 2), getY(l[i]));
                ctx.lineTo(x + parseInt(barW / 2), getY(open[i]));
            } else {
                ctx.moveTo(x + parseInt(barW / 2), getY(h[i]));
                ctx.lineTo(x + parseInt(barW / 2), getY(l[i]));
            }
            for (var n = 0; n <= barW; n++) { 

                //if (parseFloat(open[i]) > parseFloat(close[i])) {
                    ctx.moveTo(x + n, getY(close[i]));
                    ctx.lineTo(x + n, getY(open[i]));
                //}
            }
        //} else {
        //    ctx.moveTo(x, getY(close[i - 1]));
        //    ctx.lineTo(x + barW, getY(close[i - 1]));
        //}
        
        ctx.stroke();
        ctx.closePath();

        /*成交量*/
        if (target == "VOL") {
            ctx.beginPath();
            if (parseFloat(open[i]) <= parseFloat(close[i])) {
                color = red;
            } else if (parseFloat(open[i]) > parseFloat(close[i])) {
                color = green;
            }
            ctx.strokeStyle = color;
            ctx.lineWidth = 2;
            //if (parseFloat(open[i]) > parseFloat(close[i])) {
                for (var n = 0; n <= barW; n++) {
                    ctx.moveTo(x + n, getVolY(vol[i]));
                    ctx.lineTo(x + n, getVolY(0));
                }
            //}
            ctx.moveTo(x, getVolY(vol[i]));
            ctx.lineTo(x + barW, getVolY(vol[i]));
            ctx.moveTo(x, getVolY(vol[i]));
            ctx.lineTo(x, getVolY(0));
            ctx.moveTo(x + barW, getVolY(vol[i]));
            ctx.lineTo(x + barW, getVolY(0));

            ctx.stroke();
            ctx.closePath();
        }
    }
    try {
        if (target != "VOL") {
            getTarget();
        }
    } catch (e) {

    }
    /*画曲线方法*/
    function drawCurve(arr, color, n, ns) {
        ctx.beginPath();
        ctx.lineWidth = 2;
        ctx.save();
        ctx.strokeStyle = color;


        for (var i = 0; i < arr.length; i++) {
            x = (barW + space) * i + parseInt(barW / 2) + 4;

            if (n == 1) {
                y = getY(arr[i]);
            } else if (n == 2) {
                y = getVolY(arr[i]);
            }

            if (i + start == ns) {
                ctx.moveTo(x, y);
            } else if (i + start > ns) {
                ctx.lineTo(x, y);
            }
        }
        ctx.stroke();
        ctx.restore();
    }

    drawCurve(avg5, M5Color, 1, 4);
    drawCurve(avg10, M10Color, 1, 9);
    drawCurve(avg20, M20Color, 1, 19);
    drawCurve(avg60, M60Color, 1, 59);
   
    
    if (target == "VOL") {
       value[0] = 5;
       value[1] = 10;
       drawCurve(vol5, M5Color, 2, 4);
       drawCurve(vol10, M10Color, 2, 9);
    }
    var tn = kl.length - 1;
    tagTxt(tn);

    ctx.clearRect(swidth, sheight + theight * 2 + 2, twidth * 2, 30);
    ctx.textAlign = 'right';
    ctx.fillText(tradingDate[tradingDate.length - 1], swidth + twidth * 2, sheight + theight * 2 + 24);
    ctx.textAlign = 'left';
    ctx.fillText(tradingDate[0], swidth, sheight + theight * 2 + 24);
   
    ctx.fillText(tradingDate[parseInt(tradingDate.length / 2)], swidth + twidth - ctx.measureText("yyyy-mm-dd").width / 2, sheight + theight * 2 + 24);
}

function zjlBG() {
    swidth = 2;
    twidth = width - swidth;
    ctx.clearRect(swidth, sheight, twidth * 2, theight * 2);
    ctx_bg.clearRect(swidth, sheight, twidth * 2, theight * 2);
    ctx_bs.clearRect(swidth, sheight, twidth * 2, theight * 2);
    ctx_tb.clearRect(swidth, sheight, width * 2, theight * 2);
    ctx_bg.beginPath();
    ctx_bg.lineWidth = 2;
    ctx_bg.strokeStyle = wBorder;
    //theight * 0.5 + twidth * 2 * 0.245
    //theight * 1.04
    ctx_bg.moveTo(swidth + theight * 0.5 + twidth * 2 * 0.245, sheight);
    ctx_bg.lineTo(swidth + theight * 0.5 + twidth * 2 * 0.245, sheight + theight * 1.04);

    ctx_bg.moveTo(swidth + theight * 0.5 + twidth * 2 * 0.245, sheight + theight * 1.04 / 3);
    ctx_bg.lineTo(width * 2 - 2, sheight + theight * 1.04 / 3);

    ctx_bg.moveTo(swidth + theight * 0.5 + twidth * 2 * 0.245, sheight + theight * 1.04 * 2 / 3);
    ctx_bg.lineTo(width * 2 - 2, sheight + theight * 1.04 * 2 / 3);
    
    ctx_bg.moveTo(swidth, sheight + theight * 1.04);
    ctx_bg.lineTo(swidth + (width * 2 - 4), sheight + theight * 1.04);

    ctx_bg.rect(swidth, sheight, width * 2 - 4, theight * 2);

    ctx_bg.closePath();
    ctx_bg.stroke();
}

function zjl() {
    //alert(stkCode + "" + market);
    //判断指数
    if ((stkCode.indexOf("000") == 0 && market == "SH") || (stkCode.indexOf("399") == 0 && market == "SZ") || (stkCode.indexOf("395") == 0 && market == "SZ")) {
        ctx.clearRect(0, 0, width * 2, sheight);
        ctx.textAlign = 'left';
        ctx.fillStyle = black;

        ctx.clearRect(0, 0, width * 2, sheight);
        ctx.font = fontSize * 1.3 + "px 黑体";
        ctx.fillText("指数不支持此操作", width / 4 - getWidth(stkCode, fontSize * 1.3) / 2, fontSize * 3);
        ctx.font = font
    } else {  
        zjlBG();
        inside();
        if (zb.length != 0) {

            var inZJ = 0;
            var outZJ = 0;

            var c = Math.abs(quote.amount / quote.vol - quote.open);

            if (c == 0) {
                c = 1;
            }

            var lr = c * quote.outside;
            var lc = c * quote.inside;

            var inHourArr = [0, 0, 0, 0];
            var outHourArr = [0, 0, 0, 0];

            for (var i = 0; i < zb.length; i++) {
                if (zb[i].bOs == 'B') {
                    inZJ += zb[i].price * zb[i].nowVol / 10000000;
                    if (zb[i].time > "09:00" && zb[i].time <= "10:30") {
                        inHourArr[0] += zb[i].price * zb[i].nowVol / 10000000;
                    }
                    if (zb[i].time > "10:30" && zb[i].time < "11:30") {
                        inHourArr[1] += zb[i].price * zb[i].nowVol / 10000000;
                    }
                    if (zb[i].time >= "13:00" && zb[i].time <= "14:00") {
                        inHourArr[2] += zb[i].price * zb[i].nowVol / 10000000;
                    }
                    if (zb[i].time > "14:00" && zb[i].time < "15:30") {
                        inHourArr[3] += zb[i].price * zb[i].nowVol / 10000000;
                    }
                }
                if (zb[i].bOs == 'S') {
                    outZJ += zb[i].price * zb[i].nowVol / 1000000;
                    if (zb[i].time > "09:20" && zb[i].time <= "10:30") {
                        outHourArr[0] += zb[i].price * zb[i].nowVol / 10000000;
                    }
                    if (zb[i].time > "10:30" && zb[i].time < "11:30") {
                        outHourArr[1] += zb[i].price * zb[i].nowVol / 10000000;
                    }
                    if (zb[i].time >= "13:00" && zb[i].time <= "14:00") {
                        outHourArr[2] += zb[i].price * zb[i].nowVol / 10000000;
                    }
                    if (zb[i].time > "14:00" && zb[i].time < "15:10") {
                        outHourArr[3] += zb[i].price * zb[i].nowVol / 10000000;
                    }
                }
            }

            ctx.font = font;
            ctx.textAlign = 'left';
            ctx.fillStyle = black;

            var txx = swidth + theight * 0.5 + twidth * 2 * 0.245 + fontSize / 2;

            //ctx.font = (fontSize * 2 - 4) + 'px 黑体';
            ctx.fillText("流入(万元)", txx, sheight + fontSize * 2);
            ctx.fillText("流出(万元)", txx, sheight + theight * 1.04 / 3 + fontSize * 2);
            ctx.fillText("每小时大单(万元)", swidth + fontSize * 0.5, sheight + theight * 1.04 + fontSize * 2);

            ctx.textAlign = 'right';
            //ctx.font = (fontSize * 2 - 4) + 'px 黑体';
            //ctx.fillStyle = red;
            ctx.fillText((lr / 10000).toFixed(2), width * 2 - fontSize * 0.5, sheight + theight * 1.04 / 3 - fontSize * 0.5);
            //ctx.fillStyle = green;
            ctx.fillText((lc / 10000).toFixed(2), width * 2 - fontSize * 0.5, sheight + theight * 1.04 * 2 / 3 - fontSize * 0.5);
            var zjlx = '';
            if (lr > lc) {
              
                zjlx = "净流入(万元)  ";
            } else if (lr < lc) {
                
                zjlx = "净流出(万元)  ";
            }
            ctx.textAlign = 'left';
           
            ctx.fillText(zjlx, txx, sheight + theight * 1.04 * 2 / 3 + fontSize * 2);

           
            ctx.textAlign = 'right';
            ctx.fillText((Math.floor((lr - lc)) / 10000).toFixed(2), width * 2 - fontSize * 0.5, sheight + theight * 1.04 - fontSize * 0.5);
            /*画饼图*/
            /*均价差C=收盘B -开盘A  流入=外盘*C  流出 = 内盘 * C */


            var bl = [(lr * 100 / (lr + lc)).toFixed(0), (lc * 100 / (lr + lc)).toFixed(0)];
           
            var color = [darkRed, darkGreen];

            var x = swidth + (theight * 0.5 + twidth * 2 * 0.245 - 4) / 2 + 2;
            var y = sheight + theight * 0.52;

            var kuan = theight * 0.5 + twidth * 2 * 0.245;
            var gao = theight * 1.04;
            var bj;
            if (kuan > gao) {
                bj = gao / 2 - 3;
            } else {
                bj = kuan / 2 - 3;
            }
            drawCircle(x, y, bj, bl, color);
            ctx.font = font;
            ctx.textAlign = 'left';
            var timeArr = ["09:30-10:30", "10:30-11:30", "13:00-14:00", "14:00-15:00"];

            var textX;
            var barW = twidth * 2 - ctx.measureText("  10:30-11:30  ").width  - ctx.measureText(" 999999.99 ").width;

            var barTARR = [];

            for (var n = 0; n < inHourArr.length; n++) {
                barTARR.push(inHourArr[n] + outHourArr[n]);
            }

            var barT = Math.max.apply(null, barTARR);


            //theight*0.96 - fontSize*2
            if (quote.time > 93000) {
                for (var i = 0; i < timeArr.length; i++) {
                    textX = swidth + 20;
                    textY = sheight + gao + (theight * 0.96 - fontSize * 3) * (i + 1) / 4 + fontSize * 2;
                    ctx.fillStyle = black;
                    ctx.fillText(timeArr[i], textX, textY);

                    textX += ctx.measureText("10:30-11:30  ").width + 10;
                    

                    ctx.fillStyle = red;  //* inHourArr[i] / (inHourArr[i] + outHourArr[i])   
                    ctx.fillRect(textX, textY - fontSize * 0.8, barW * inHourArr[i] / barT, 12);

                    ctx.fillStyle = green; //* outHourArr[i] / (inHourArr[i] + outHourArr[i])
                    ctx.fillRect(textX, textY - fontSize * 0.3, barW * outHourArr[i] / barT, 12);

                    textX += barW + 10;
                    ctx.fillStyle = black;
                    ctx.textAlign = 'right';
                    if (inHourArr[i] != 0) {
                        ctx.fillText(inHourArr[i].toFixed(2), swidth + width*2 - 10, textY - fontSize * 0.5);
                    }
                    if (outHourArr[i] != 0) {
                        ctx.fillText(outHourArr[i].toFixed(2), swidth + width * 2 - 10, textY + fontSize * 0.5);
                    }
                   
                    ctx.textAlign = 'left';
                }
            }
        }
    }  
}

function weituo() {
    ctx.clearRect(0, 0, width * 2, sheight);
    ctx.textAlign = 'left';
    ctx.fillStyle = yellow;
    if (browser.versions.iPhone) {
        ctx.font = fontSize * 1.3 + "px 黑体";
        ctx.fillText("该功能模块尚未安装", width / 4 - getWidth(stkCode, fontSize * 1.3) / 2 - 20, fontSize * 3);
    } else if (browser.versions.android) {  /*安卓*/
        var fontS = parseInt(sheight / 2 * (2 / 3));
        ctx.font = fontS + "px 黑体";
        ctx.fillStyle = yellow;
        ctx.fillText("该功能模块尚未安装", width / 4 - getWidth(stkCode, fontS) / 2, fontS * 1.1);
          
        var fontWidth = width * 3 / 2 + ctx.measureText("低 ").width + ctx.measureText(low).width;

        if (fontWidth > width * 2) {
            ctx.clearRect(0, 0, width * 2, sheight);
            ctx.fillStyle = yellow;
            ctx.font = fontSize * 1.3 + "px 黑体";
            ctx.fillText("该功能模块尚未安装", width / 4 - getWidth(stkCode, fontSize * 1.3) / 2, fontSize * 3);
        }
    }
}

function ZXGInfo(n) {
   
    ctx.textAlign = 'left';
    //if (n % 2 == 0) {
    //    ctx.fillStyle = darkGray;

    //    if (browser.versions.iPhone) {
    //        ctx.fillRect(0, (sheight * 1.2 - 1) * (n - sNum - 1), width * 2, sheight);
    //    } else {
    //        ctx.fillRect(0, (sheight * 1.2 - 1) * (n - sNum - 1), width * 2, sheight - 10);
    //    }
    //}
    //ctx.fillStyle = red;
    //ctx.fillRect(width / 2 + 2 - 40, (sheight * 1.2 - 1) * (n - sNum - 1) + 20, width / 2 - 4, sheight - 40);

    var deleteImg = new Image();
    deleteImg.src = "img/del.png";
    ctx.drawImage(deleteImg, width * 2 - 51, (sheight * 1.2 - 1) * 0.5 - 24 + (sheight * 1.2 - 1) * (n - sNum - 1), 48, 48);

    ctx.fillStyle = black;
  
    //var sd = getWidth(decodeURI(zxg[n - 1].stkName), font) + 20;

    //ctx.fillStyle = gray;
    ctx.textAlign = 'left';

    tprice = parseFloat(zxg[n - 1].price);
    if (tprice == 0) {
        tprice = parseFloat(zxg[n - 1].preClose);
    }
    tpreClose = parseFloat(zxg[n - 1].preClose);

    dzjg = parseFloat(zxg[n - 1].high).toFixed(2);
    zzf = parseFloat(zxg[n - 1].low).toFixed(2);
    

    //if (tprice > tpreClose) {
    //    ctx.fillStyle = red;
    //} else if (tprice == tpreClose) {
    //    ctx.fillStyle = black;
    //} else if (tprice < tpreClose) {
    //    ctx.fillStyle = green;
    //}

    tzdf = ((tprice - tpreClose) * 100 / tpreClose).toFixed(num);
    if (isNaN(tzdf)) {
        tzdf = 0;
    }
    tzdf = ((tprice - tpreClose) * 100 / tpreClose).toFixed(num) + "%";

    tzd = (tprice - tpreClose).toFixed(num);

    var as = 30;
    var textX = 5;
    var fontS = 24;
    ctx.font = fontSize * 1.2 + "px 黑体";
    ctx.fillStyle = black;
    ctx.fillText(zxg[n - 1].Stock, textX, fontSize * 2.2 + (sheight * 1.2 - 1) * (n - sNum - 1));
    ctx.font = fontSize  + "px 黑体";
    ctx.fillText(decodeURI(zxg[n - 1].stkName), textX, fontSize * 1.1 + (sheight * 1.2 - 1) * (n - sNum - 1));
    textX = textX + ctx.measureText("股票名称 ").width;
    ctx.font = fontSize * 2 + "px 黑体";
    var pTxt = parseFloat(tprice).toFixed(num);
    var txtW = ctx.measureText(pTxt).width;
    var spaceW = ctx.measureText("9999.99 ").width;
    if (!isNaN(pTxt)) {
        ctx.fillText(pTxt, textX + (spaceW - txtW) * 0.5, fontS * 1.8 + (sheight * 1.2 - 1) * (n - sNum - 1));
    }
    textX = textX + ctx.measureText("9999.99 ").width;
    ctx.font = font;
    ctx.fillText("涨幅", textX, fontSize * 1.1 + (sheight * 1.2 - 1) * (n - sNum - 1));
    ctx.fillText("涨跌", textX, fontSize * 2.2 + (sheight * 1.2 - 1) * (n - sNum - 1));
    textX = textX + ctx.measureText("涨幅 ").width;
    if (tzd > 0) {
        ctx.fillStyle = red;
    } else if (tzd == 0) {
        ctx.fillStyle = black;
    } else if (tzd < 0) {
        ctx.fillStyle = green;
    }
    ctx.fillText(tzdf, textX, fontSize * 1.1 + (sheight * 1.2 - 1) * (n - sNum - 1));
    ctx.fillText(tzd, textX, fontSize * 2.2 + (sheight * 1.2 - 1) * (n - sNum - 1));
    ctx.fillStyle = black;

    textX = textX + ctx.measureText("-99.99% ").width;
    ctx.fillText("最高", textX, fontSize * 1.1 + (sheight * 1.2 - 1) * (n - sNum - 1));
    ctx.fillText("最低", textX, fontSize * 2.2 + (sheight * 1.2 - 1) * (n - sNum - 1));
    textX = textX + ctx.measureText("最低 ").width;

    //if (dzjg > tpreClose) {
    //    ctx.fillStyle = red;
    //} else if (dzjg == tpreClose) {
    //    ctx.fillStyle = black;
    //} else if (dzjg < tpreClose) {
    //    ctx.fillStyle = green;
    //}
    ctx.fillText(dzjg, textX, fontSize * 1.1 + (sheight * 1.2 - 1) * (n - sNum - 1));

    //if (zzf > tpreClose) {
    //    ctx.fillStyle = red;
    //} else if (zzf == tpreClose) {
    //    ctx.fillStyle = black;
    //} else if (zzf < tpreClose) {
    //    ctx.fillStyle = green;
    //}
    ctx.fillText(zzf, textX, fontSize * 2.2 + (sheight * 1.2 - 1) * (n - sNum - 1));
    
    ctx.beginPath();
    ctx.strokeStyle = wBorder;
    ctx.lineWidth = 2;
    ctx.moveTo(5, fontSize * 2.2 + (sheight * 1.2 - 1) * (n - sNum - 1) + 8);
    ctx.lineTo(width * 2 - 24, fontSize * 2.2 + (sheight * 1.2 - 1) * (n - sNum - 1) + 8);
    ctx.closePath();
    ctx.stroke();
}

function drawZXG() {
   
    touchID = 0;

    ctx.clearRect(0, 0, width * 2, height * 2 - 75);
    ctx_bg.clearRect(0, 0, width * 2, height * 2 - 75);
    ctx_bs.clearRect(0, 0, width * 2, height * 2 - 75);
    ctx_tb.clearRect(0, 0, width * 2, height * 2 - 75);

    ctx.textAlign = 'left';
    ctx.fillStyle = black;

    var nums = parseInt((height * 2 - 75) / sheight) - 3;
    if (nums > zxg.length) {
        nums = zxg.length;
    }
    
    for (var i = sNum; i < nums + sNum; i++) {
        if (i < zxg.length) {
            n = i + 1;
            ZXGInfo(n);
        }
    }
    
    var pageinfo = "共" + zxg.length + "条,第" + (sNum + 1) + "条到第" + (nums + sNum) + "条";
    if (zxg.length == 0) {
        pageinfo = "当前没有自选股!";
    }
    ctx.textAlign = 'right';
    ctx.fillStyle = black;
    ctx.font = fontSize + "px 黑体";
 
    ctx.fillText(pageinfo, width * 2 - 10, height * 2 - 85);
    ctx.textAlign = 'left';

    drawZXBTN();
}

function roundRect(x, y, w, h, r) {
    if (w < 2 * r) r = w / 2;
    if (h < 2 * r) r = h / 2;
    ctx_m.beginPath();

    var n = lbtn.length;
    //选中部分颜色RGB(16,20,22)
    ctx_m.fillStyle = lightgray;

    ctx_m.strokeStyle = orange;
    ctx_m.moveTo(x + r, y);
    ctx_m.arcTo(x + w, y, x + w, y + h, r);
    ctx_m.arcTo(x + w, y + h, x, y + h, r);
    ctx_m.arcTo(x, y + h, x, y, r);
    ctx_m.arcTo(x, y, x + w, y, r);

    ctx_m.strokeStyle = black;
    for (var i = 0; i < n; i++) {
        ctx_m.moveTo(x + 4, y + h * i / n);
        ctx_m.lineTo(x + w - 4, y + h * i / n);
    }


    ctx_m.fill();
    ctx_m.closePath();
    ctx_m.stroke();


    for (var i = 0; i < 160; i++) {
        fontNum = i;
        ctx_m.font = i + "px 黑体";
        if (ctx_m.measureText("涨幅排名").width > width * 0.5 * 0.93) {
            break;
        }
    }
    fontNum--;
    fontNum--;

    ctx_m.font = fontNum + "px 黑体";
    for (var i = 0; i < n; i++) {
  
        if (clbtnid == i || touchID == 9) {
            ctx_m.fillStyle = orange;
        } else {
            ctx_m.fillStyle = darkgrey;
        }

        ctx_m.fillText(lbtn[i], x + (w - ctx_m.measureText(lbtn[i]).width)/2, y + h * (i + 1) / n - 4 - (110 - fontNum) * 0.5);
    }
}

function roundRectZX(x, y, w, h, r) {
    if (w < 2 * r) r = w / 2;
    if (h < 2 * r) r = h / 2;
    ctx_m.beginPath();

    var n = btnZX.length;
  
    //选中部分颜色RGB(16,20,22)
    ctx_m.fillStyle = darkerGray;

    ctx_m.strokeStyle = gray;
    ctx_m.moveTo(x + r, y);
    ctx_m.arcTo(x + w, y, x + w, y + h, r);
    ctx_m.arcTo(x + w, y + h, x, y + h, r);
    ctx_m.arcTo(x, y + h, x, y, r);
    ctx_m.arcTo(x, y, x + w, y, r);

    ctx_m.strokeStyle = black;
    for (var i = 0; i < n; i++) {
        ctx_m.moveTo(x + 4, y + h * i / n);
        ctx_m.lineTo(x + w - 4, y + h * i / n);
    }


    ctx_m.fill();
    ctx_m.closePath();
    ctx_m.stroke();


    for (var i = 0; i < 160; i++) {
        fontNum = i;
        ctx_m.font = i + "px 黑体";
        if (ctx_m.measureText("添加自选股").width > width * 0.5 * 0.93) {
            break;
        }
    }
    fontNum--;
    fontNum--;
    ctx_m.fillStyle = white;
    ctx_m.font = fontNum + "px 黑体";
    for (var i = 0; i < n; i++) {

        if (clbtnid == i) {
            ctx_m.fillStyle = yellow;
        } else {
            ctx_m.fillStyle = white;
        }

        ctx_m.fillText(btnZX[i], x + (w - ctx_m.measureText(btnZX[i]).width) / 2, y + h * (i + 1) / n - 4 - (110 - fontNum) * 0.5);
    }
}

function sort() {
    try {
        var w = width * 0.8;
        var h = lbtn.length * 110;
  
        if (islbtn) {
            roundRect(width * 2 - 2 - w, height * 2 - 78 - h, w, h, 5);
        } else {
            ctx_m.clearRect(0, 0, width * 2, height * 2);
            touchID = lastTID;
            drawBTN();
        }
    } catch (e) {
        alert(e.message);
    }
}

function sort_zxg() {
   
    var w = width * 0.8;
    var h = btnZX.length * 110;
    roundRectZX(width * 1.6 - 2 - w, height * 2 - 78 - h, w, h, 5);
//    if (islbtn) {
//        
//    } else {
//        ctx_m.clearRect(0, 0, width * 2, height * 2);
//        touchID = lastTID;
//        drawBTN();
//    }
}

function sortInfo(n) {
    ctx.textAlign = 'left';
    
    //if (n % 2 == 0) {
    //    ctx.fillStyle = wBorder;

    //    ctx.fillRect(0, (sheight * 1.2 - 1) * (n - sNum - 1), width * 2, sheight - 10);
    //}

   

    var gpys = black;
    var src = "img/add.png";
    
    for (var i = 0; i < zxg.length; i++) {
        src = "img/add.png";
        gpys = black;
        isZXG = -1;
        if (zxg[i].Stock == sortarr[n - 1].c) {
            isZXG = 3;
            src = "img/del.png";
            gpys = zxgBlue;
            break;
        }
    }

    var deleteImg = new Image();
    deleteImg.src = src;
    ctx.drawImage(deleteImg, width * 2 - 51, (sheight - 1) * 0.5 - 24 + (sheight * 1.2  - 1) * (n - sNum - 1), 48, 48);

    var sd = getWidth(decodeURI(sortarr[n - 1].n), font) + 20;

    ctx.fillStyle = black;
    ctx.textAlign = 'left';

    tprice = parseFloat(sortarr[n - 1].p);
    tpreClose = parseFloat(sortarr[n - 1].pc);

    dzjg = parseFloat(sortarr[n - 1].h).toFixed(2);
    zzf = parseFloat(sortarr[n - 1].l).toFixed(2);

    tzdf = (parseFloat(sortarr[n - 1].zf) * 100).toFixed(num) + "%"; ;
    tzd = parseFloat(sortarr[n - 1].zd).toFixed(num);

    //if (tzd > 0) {
    //    ctx.fillStyle = red;
    //} else if (tzd == 0) {
    //    ctx.fillStyle = white;
    //} else if (tzd < 0) {
    //    ctx.fillStyle = green;
    //}

    var as = 30;

    var fontS = 24;
  
    ctx.fillStyle = gpys;
    var textX = 5;
    ctx.font = fontS * 1.2 + "px 黑体";
    ctx.fillText(sortarr[n - 1].c, textX, fontS * 1.1 + (sheight * 1.2 - 1) * (n - sNum - 1));
    ctx.font = fontS  + "px 黑体";
    ctx.fillText(decodeURI(sortarr[n - 1].n), textX, fontS * 2.2 + (sheight * 1.2 - 1) * (n - sNum - 1));

    ctx.fillStyle = black;
    textX = textX + ctx.measureText("股票名称 ").width;

    ctx.font = fontS * 2 + "px 黑体";
    //textX = textX + ctx.measureText("pTxt").width / 2;
    var pTxt = parseFloat(tprice).toFixed(num);

    var txtW = ctx.measureText(pTxt).width;
    var spaceW = ctx.measureText("9999.99 ").width;

    //ctx.textAlign = "left";
    if (!isNaN(pTxt)) {
        ctx.fillText(pTxt, textX + (spaceW - txtW) * 0.5, fontS * 1.8 + (sheight * 1.2 - 1) * (n - sNum - 1));
    }

    
    textX = textX + ctx.measureText("9999.99 ").width;

    ctx.font = font;
    //ctx.fillStyle = gray;
    ctx.fillText("涨幅", textX, fontS * 1.1 + (sheight * 1.2 - 1) * (n - sNum - 1));
    ctx.fillText("涨跌", textX, fontS * 2.2 + (sheight * 1.2 - 1) * (n - sNum - 1));
    textX = textX + ctx.measureText("涨幅 ").width;
    //ctx.font = fontS * 0.7 + "px 黑体";
    if (tzd > 0) {
        ctx.fillStyle = red;
    } else if (tzd == 0) {
        ctx.fillStyle = black;
    } else if (tzd < 0) {
        ctx.fillStyle = green;
    }
    ctx.fillText(tzdf, textX, fontS * 1.1 + (sheight * 1.2 - 1) * (n - sNum - 1));
    ctx.fillText(tzd, textX, fontS * 2.2 + (sheight * 1.2 - 1) * (n - sNum - 1));
    ctx.fillStyle = black;
    textX = textX + ctx.measureText("-100.00% ").width;
    ctx.fillText("最高", textX, fontS * 1.1 + (sheight * 1.2 - 1) * (n - sNum - 1));
    ctx.fillText("最低", textX, fontS * 2.2 + (sheight * 1.2 - 1) * (n - sNum - 1));
    textX = textX + ctx.measureText("最高 ").width;
    //if (dzjg > tpreClose) {
    //    ctx.fillStyle = red;
    //} else if (dzjg == tpreClose) {
    //    ctx.fillStyle = white;
    //} else if (dzjg < tpreClose) {
    //    ctx.fillStyle = green;
    //}
    ctx.fillText(dzjg, textX, fontS * 1.1 + (sheight * 1.2 - 1) * (n - sNum - 1));
    
    //if (zzf > tpreClose) {
    //    ctx.fillStyle = red;
    //} else if (zzf == tpreClose) {
    //    ctx.fillStyle = white;
    //} else if (zzf < tpreClose) {
    //    ctx.fillStyle = green;
    //}
    ctx.fillText(zzf, textX, fontS * 2.2 + (sheight * 1.2 - 1) * (n - sNum - 1));

    ctx.beginPath();
    ctx.strokeStyle = wBorder;
    ctx.lineWidth = 2;
    ctx.moveTo(5, fontS * 2.2 + (sheight * 1.2 - 1) * (n - sNum - 1) + 8);
    ctx.lineTo(width * 2 - 24, fontS * 2.2 + (sheight * 1.2 - 1) * (n - sNum - 1) + 8);
    ctx.closePath();
    ctx.stroke();
    
}

function drawSort() {
    ctx.clearRect(0, 0, width * 2, height * 2 - 75);
    ctx_bg.clearRect(0, 0, width * 2, height * 2 - 75);
    ctx_bs.clearRect(0, 0, width * 2, height * 2 - 75);
    ctx_tb.clearRect(0, 0, width * 2, height * 2 - 75);

    ctx.textAlign = 'left';
    ctx.fillStyle = black;

    var nums = parseInt((height * 2 - 80) / (sheight * 1.2));
    //alert(nums);
    if (nums > sortarr.length) {
        nums = sortarr.length;
    }

    for (var i = sNum; i < nums + sNum; i++) {
        if (i < sortarr.length) {
            n = i + 1;
            sortInfo(n);
        }
    }
    var pageinfo = "共" + sortarr.length + "条,第" + (sNum + 1) + "条到第" + (nums + sNum) + "条";

    ctx.textAlign = 'right';
    ctx.fillStyle = black;
    ctx.font = font;
  
    ctx.fillText(pageinfo, width * 2 - 10, height * 2 - 85);
    ctx.textAlign = 'left';
}

function pkBG() {
    swidth = 2;
    twidth = width - swidth;
    ctx.clearRect(0, 0, width * 2, height * 2);
    ctx_bg.clearRect(0, 0, width * 2, height * 2);
    ctx_bs.clearRect(0, 0, width * 2, height * 2);
    ctx_tb.clearRect(0, 0, width * 2, height * 2);
    //判断指数
    if ((stkCode.indexOf("000") == 0 && market == "SH") || (stkCode.indexOf("399") == 0 && market == "SZ") || (stkCode.indexOf("395") == 0 && market == "SZ")) {         
        ctx.clearRect(0, 0, width * 2, sheight);
        ctx.textAlign = 'left';
        ctx.fillStyle = black;
        ctx.font = fontSize * 1.3 + "px 黑体";
        ctx.fillText("指数不支持此操作", width / 4 - getWidth(stkCode, fontSize * 1.3) / 2 - 20, fontSize * 3);
        ctx.font = font;
    } else {
        inside();
        /*盘口界面背景*/
        ctx_bg.beginPath();
        ctx_bg.lineWidth = 2;
        ctx_bg.strokeStyle = wBorder;

        var sdj = 10;

    
        ctx.font = font;
        if (stkCode.substring(0, 3) == '399' && market == 'SZ' || stkCode.substring(0, 3) == '000' && market == 'SH') {

            ctx_bg.rect(swidth, sheight, width * 2 - 4, theight * 2);
            ctx_bg.moveTo(swidth + width - 2, sheight);
            ctx_bg.lineTo(swidth + width - 2, sheight + theight * 2);
            ctx_bg.closePath();
            ctx_bg.stroke();

            var lArr = ["A股成交", "国债成交", "权证成交", "最新指数", "昨日收盘", "指数涨幅", "总成交量", "最高指数"];
            var rArr = ["B股成交", "基金成交", "债券成交", "今日开盘", "指数涨跌", "指数振幅", "总成交额", "最低指数"];
            var lval = [
                            indeCJ[3].amount,
                            indeCJ[2].amount,
                            0,
                            parseFloat(quote.price).toFixed(2),
                            parseFloat(quote.preClose).toFixed(2),
                            (quote.zd * 100 / quote.preClose).toFixed(2),
                            quote.vol,
                            parseFloat(quote.high).toFixed(2)
            ];
            var rval = [
                            indeCJ[4].amount,
                            indeCJ[1].amount,
                            indeCJ[0].amount,
                            parseFloat(quote.open).toFixed(2),
                            parseFloat(quote.zd).toFixed(2),
                            ((quote.high - quote.low) * 100 / quote.preClose).toFixed(2),
                            quote.amount,
                            parseFloat(quote.low).toFixed(2)
            ];
            if (touchID == 10) {

                for (var i = 0; i < lArr.length; i++) {
                    ctx.fillStyle = gray;
                    ctx.textAlign = 'left';
                    ctx.fillText(lArr[i], swidth + 4, sheight - 1 + (fontSize + sdj) * (i + 1));
                    ctx.fillText(rArr[i], width + 4, sheight - 1 + (fontSize + sdj) * (i + 1));

                    ctx.textAlign = 'right';
                    if (i < 3 || i == 6) {
                        ctx.fillStyle = yellow;
                        lval[i] = (lval[i] / 10000).toFixed(0) + "万";
                    }
                    else if (i == 3 || i == 4 || i == 7 || i == 8) {
                        if (lval[i] > quote.preClose) {
                            ctx.fillStyle = red;
                        } else if (lval[i] < quote.preClose) {
                            ctx.fillStyle = green;
                        } else if (lval[i] == quote.preClose) {
                            ctx.fillStyle = white;
                        }
                    }
                    else if (i == 5) {
                        if (lval[i] > 0) {
                            ctx.fillStyle = red;
                        }
                        else if (lval[i] < 0) {
                            ctx.fillStyle = green;
                        }
                        else {
                            ctx.fillStyle = white;
                        }
                        lval[i] += "%";
                        rval[i] += "%";
                    }

                    ctx.fillText(lval[i], width - 4, sheight - 1 + (fontSize + sdj) * (i + 1));
                    if (i == 3 || i == 4 || i == 7 || i == 8) {
                        if (rval[i] > quote.preClose) {
                            ctx.fillStyle = red;
                        } else if (rval[i] < quote.preClose) {
                            ctx.fillStyle = green;
                        } else if (rval[i] == quote.preClose) {
                            ctx.fillStyle = white;
                        }
                    }
                    else if (i == 6) {
                        if (rval[i] > 1000000000) {
                            rval[i] = (rval[i] / 100000000).toFixed(2) + "亿";
                        } else {
                            rval[i] = (rval[i] / 10000).toFixed(0) + "万";
                        }
                    }

                    ctx.fillText(rval[i], width * 2 - 4, sheight - 1 + (fontSize + sdj) * (i + 1));
                }
            }
        }
        else {
            ctx_bg.rect(swidth, sheight, width * 2 - 4, theight * 2);

            ctx_bg.moveTo(swidth, sheight + 16 + (fontSize + sdj) * 5);
            ctx_bg.lineTo(width * 2 - 3, sheight + 16 + (fontSize + sdj) * 5);

            ctx_bg.moveTo(swidth, sheight + 29 + (fontSize + sdj) * 10);
            ctx_bg.lineTo(width * 2 - 3, sheight + 29 + (fontSize + sdj) * 10);

            ctx_bg.moveTo(swidth + width - 2, sheight);
            ctx_bg.lineTo(swidth + width - 2, sheight + theight * 2);

            ctx_bg.closePath();
            ctx_bg.stroke();



            var buyTxt = ["买一", "买二", "买三", "买四", "买五"];
            var sellTxt = ["卖五", "卖四", "卖三", "卖二", "卖一"];
            var buy = [
                parseFloat(quote.buyPrice1).toFixed(2),
                parseFloat(quote.buyPrice2).toFixed(2),
                parseFloat(quote.buyPrice3).toFixed(2),
                parseFloat(quote.buyPrice4).toFixed(2),
                parseFloat(quote.buyPrice5).toFixed(2)
            ];
            var sell = [
                parseFloat(quote.sellPrice5).toFixed(2),
                parseFloat(quote.sellPrice4).toFixed(2),
                parseFloat(quote.sellPrice3).toFixed(2),
                parseFloat(quote.sellPrice2).toFixed(2),
                parseFloat(quote.sellPrice1).toFixed(2)
            ];
            var buyV = [
                parseFloat(quote.buyVol1),
                parseFloat(quote.buyVol2),
                parseFloat(quote.buyVol3),
                parseFloat(quote.buyVol4),
                parseFloat(quote.buyVol5)
            ];
            var sellV = [
                parseFloat(quote.sellVol5),
                parseFloat(quote.sellVol4),
                parseFloat(quote.sellVol3),
                parseFloat(quote.sellVol2),
                parseFloat(quote.sellVol1)
            ];
            for (var i = 0; i < 5; i++) {
                ctx.fillStyle = black;
                ctx.textAlign = 'left';
                ctx.fillText(sellTxt[i], swidth + 4, sheight - 1 + (fontSize + sdj) * (i + 1));

                //if (parseFloat(quote.preClose) > sell[i]) {
                //    ctx.fillStyle = green;
                //} else {
                //    ctx.fillStyle = red;
                //}
                ctx.fillText(sell[i], swidth + 2 + ctx.measureText("买一    ").width, sheight - 1 + (fontSize + sdj) * (i + 1));

                ctx.textAlign = 'right';
                ctx.fillStyle = black;
                ctx.fillText(sellV[i], swidth + width - 2 - ctx.measureText(" ").width, sheight - 1 + (fontSize + sdj) * (i + 1));
            }
            var sd = 13;
            for (var i = 0; i < 5; i++) {
                ctx.fillStyle = black;
                ctx.textAlign = 'left';
                ctx.fillText(buyTxt[i], swidth + 4, sheight + sd + (fontSize + sdj) * 5 + (fontSize + sdj) * (i + 1));

                //if (parseFloat(quote.preClose) > buy[i]) {
                //    ctx.fillStyle = green;
                //} else {
                //    ctx.fillStyle = red;
                //}
                ctx.fillText(buy[i], swidth + 2 + ctx.measureText("买一    ").width, sheight + sd + (fontSize + sdj) * 5 + (fontSize + sdj) * (i + 1));


                ctx.textAlign = 'right';
                ctx.fillStyle = black;
                ctx.fillText(buyV[i], swidth + width - 2 - ctx.measureText(" ").width, sheight + sd + (fontSize + sdj) * 5 + (fontSize + sdj) * (i + 1));

            }
            var lefttxt = [
                        "今开",
                        "昨收"
            ];
            var righttxt = [
                        "涨停",
                        "跌停",
                        "总量",
                        "量比",
                        "外盘",
                        "内盘",
                        "换手",
                        "PE(动)",
                        "净资",
                        "股本",
                        "收益",
                        "流通"
            ];

            var leftval = [
                    parseFloat(quote.open).toFixed(2),
                    parseFloat(quote.preClose).toFixed(2)
            ];


            ctx.textAlign = 'left';
            sd = 18;

            for (var i = 0; i < lefttxt.length; i++) {
                ctx.fillStyle = black;
                ctx.fillText(lefttxt[i], swidth + 4, sheight + sd + (fontSize + sdj) * 10 + (fontSize + sdj) * (i + 1));
                ctx.textAlign = 'right';
                //if (parseFloat(quote.preClose) > leftval[i]) {
                //    ctx.fillStyle = green;
                //} else if (parseFloat(quote.preClose) < leftval[i]) {
                //    ctx.fillStyle = red;
                //} else {
                //    ctx.fillStyle = white;
                //}
                ctx.fillText(leftval[i], swidth + width - 2 - ctx.measureText(" ").width, sheight + sd + (fontSize + sdj) * 10 + (fontSize + sdj) * (i + 1));
                ctx.textAlign = 'left';
            }



            var hsl = (quote.vol / (quote.ltag * 100)).toFixed(2);
            if (hsl == Infinity) {
                hsl = 0;
            }
            var sy = parseFloat(quote.jly) / parseFloat(quote.ltag);
            if (isNaN(sy) || quote.ltag == "0") {
                sy = 0;
            }
            var pe = (quote.price * quote.zbnb * quote.ltag * 5 / (6 * quote.jly)).toFixed(2);
            if (pe < 0 || isNaN(pe)) {
                pe = "-";
            }



            var rightval = [
                    (parseFloat(quote.preClose) * 1.1).toFixed(2),
                    (parseFloat(quote.preClose) * 0.9).toFixed(2),
                    (quote.vol / 100).toFixed(0),
                    parseFloat(quote.lb).toFixed(2),
                    ((quote.outside) / 100).toFixed(0),
                    (quote.inside / 100).toFixed(0),
                    (hsl) + '%',
                    pe,
                    (quote.jzc / quote.ltag * 10).toFixed(2),
                    (quote.zgb / 10000).toFixed(1),
                    (sy).toFixed(2),
                    (quote.ltag / 10000).toFixed(1) + "亿"
            ];

            ctx.fillStyle = black;
            for (var i = 0; i < righttxt.length; i++) {
                if (i < 5) {
                    sd = 0;
                }
                else if (i >= 5 && i < 10) {
                    sd = 13;
                }
                else {
                    sd = 18;
                }
                //ctx.fillStyle = gray;
                ctx.fillText(righttxt[i], swidth + 2 + width, sheight + sd + (fontSize + sdj) * (i + 1));
                ctx.textAlign = 'right';
                //if (i == 0 || i == 4) {
                //    ctx.fillStyle = red;
                //} else if (i == 1 || i == 5) {
                //    ctx.fillStyle = green;
                //} else if (i == 2) {
                //    ctx.fillStyle = yellow;
                //} else if (i == 3) {
                //    if (parseFloat(quote.preClose) > parseFloat(quote.price)) {
                //        ctx.fillStyle = green;
                //    } else if (parseFloat(quote.preClose) < parseFloat(quote.price)) {
                //        ctx.fillStyle = red;
                //    } else {
                //        ctx.fillStyle = white;
                //    }
                //} else {
                //    ctx.fillStyle = gray;
                //}
                ctx.fillText(rightval[i], width * 2 - ctx.measureText(" ").width, sheight + sd + (fontSize + sdj) * (i + 1));
                ctx.textAlign = 'left';
            }
        }
    }
}

function roundRect_(ctx_m, x, y, w, h, r, txt, bgColor, txtColor) {
    if (w < 2 * r) r = w / 2;
    if (h < 2 * r) r = h / 2;
    ctx_m.beginPath();

    //选中部分颜色RGB(16,btnR,22)
    ctx_m.fillStyle = bgColor;

    ctx_m.lineWidth = 2;

    ctx_m.strokeStyle = gray;
    ctx_m.moveTo(x + r, y);
    ctx_m.arcTo(x + w, y, x + w, y + h, r);
    ctx_m.arcTo(x + w, y + h, x, y + h, r);
    ctx_m.arcTo(x, y + h, x, y, r);
    ctx_m.arcTo(x, y, x + w, y, r);

    ctx_m.fill();
    ctx_m.closePath();
    ctx_m.stroke();

    ctx_m.beginPath();
    ctx_m.fillStyle = txtColor;
    var fontsize_ = parseInt(h * 0.5);

    ctx_m.font = fontsize_ + "px arial";

    //if (isNaN(txt)) {
    //    while (w * 0.98 < ctx_m.measureText(txt).width) {
    //        fontsize_--;
    //        ctx_m.font = fontsize_ + "px 宋体";
    //    }
    //}
    //else {
    //    while (w * 0.98 < ctx_m.measureText("ABC").width) {
    //        fontsize_--;
    //        ctx_m.font = fontsize_ + "px 宋体";
    //    }
    //}
    if (txt != "←") {
        ctx_m.fillText(txt, x + (w - ctx_m.measureText(txt).width) / 2, y + h / 2 + fontsize_ * 0.4);
    }
    else {
        var del = new Image();
        var src = "img/IMG_0140.PNG";

        del.src = src;
        
        ctx_m.drawImage(del, x + (w - ctx_m.measureText(txt).width) / 2, y + h / 4 , fontsize_, fontsize_);    /*添加自选*/
    }
    ctx_m.closePath();
    ctx_m.stroke();
}

function fillText_(ctx_m, x, y, w, h, r, txt,txtColor) {
    if (w < 2 * r) r = w / 2;
    if (h < 2 * r) r = h / 2;

    ctx_m.beginPath();
    ctx_m.fillStyle = txtColor;
    var fontsize_ = parseInt(h * 0.6);
    ctx_m.font = fontsize_ + "px 宋体";
    while (w * 0.96 < ctx_m.measureText("浦发银行").width) {
        fontsize_--;
        ctx_m.font = fontsize_ + "px 宋体";
    }
 
    ctx_m.font = fontsize_ + "px 宋体";
    ctx_m.fillText(txt, x + (w - ctx_m.measureText(txt).width) / 2, y + h / 2 + fontsize_ * 0.26);
    ctx_m.closePath();
    ctx_m.stroke();
}


function drawText(ctx_m, x, y, font_size, txt, txtColor, textAlign) {
    ctx_m.fillStyle = txtColor;
    ctx_m.textAlign = textAlign;
    ctx_m.font = font_size + "px 宋体";
    ctx_m.fillText(txt, x , y);
}

function validate_() {
    $('#login').css("display","none");
    $("#loading").css("display", "block");
}

function checklogin() {
    userid = document.getElementById("userid").value;
    userpwd = document.getElementById("userpwd").value;
    isCooker = document.getElementById('chkRememberPwd').checked;

	if(isCooker){
		window.localStorage.setItem("userid", userid);
	}
	else{
		window.localStorage.removeItem("userid");
	}

    $("#login").css("display", "none");
    $("#login1").css("display", "none");
    $("#login2").css("display", "none");
  
    if (userid == "" || userpwd == "") {
        $("#login").css("display", "block");
        $("#login1").css("display", "block");
        $("#login2").css("display", "block");

        $("#loading").css("display", "none");
        $("#logo").css("display", "none");
        document.getElementById("errHolder").innerText = "用户名或密码不能为空!";
        return false;
    } else {
        login(true);
    }
}

function addEventListener() {
    canvast.removeEventListener('touchstart', touchstart);
    canvast.removeEventListener('touchmove', touchmove);
    canvast.removeEventListener('touchend', touchend);

    canvast.addEventListener('touchstart', touchstart);
    canvast.addEventListener('touchmove', touchmove);
    canvast.addEventListener('touchend', touchend);
}





// 加载层
function showloading() {
    jQuery(".fullbg").css("display", "block");
    //setTimeout(hideloading, 5000);
}

// 隐藏层
function hideloading() {
    jQuery(".fullbg").css("display", "none");
}


//客户号 手机号码 传递
function setClientInfo(clientID, phoneNum) {
    userid = clientID;
    phoneNum = phoneNum;
    zxg = [];
    $.ajax({
        type: "post",
        url: "data/data.aspx?action=getStkList&userid=" + userid + "&phoneNum=" + phoneNum,
        async: true,
        dataType: "json",
        beforeSend: function (XMLHttpRequest) {

        },
        success: function (data, textStatus) {
            if (data.header.errorCode == "000000") {
                zxgStr = [];
                //此处按实际返回格式遍历数组
                for (var i = 0; i < data.body.length; i++) {
               
                    if (data.body[i].markettype == 0) {
                        if (data.body[i].stocktype == 30) {
                            zxgStr.push(data.body[i].stockcode + ".STB");
                        }
                        else {
                            zxgStr.push(data.body[i].stockcode + ".SZ");
                        }
                    }
                    else if (data.body[i].markettype == 1) {
                        zxgStr.push(data.body[i].stockcode + ".SH");
                    }
                    else if (data.body[i].markettype == 2) {
                        if ("4,5,6".indexOf(data.body[i].stocktype + ',') != -1) {
                            zxgStr.push(data.body[i].stockcode + ".SH");
                        }
                        else if ("14,15,17".indexOf(data.body[i].stocktype + ',') != -1) {
                            zxgStr.push(data.body[i].stockcode + ".SZ");
                        }
                    }
                }
                getZXGD(zxgStr);
            }
        },
        complete: function (XMLHttpRequest, textStatus) {

        },
        error: function (XMLHttpRequest, textStatus, errorThrown) {

        }
    });
}


//本地自选股
function setAllPro(ids) {
    ids = ids;
    if (phoneNum == "" && userid == "") {
        getZXGD(ids);
    }
}

function zxgcallback_add(errorCode) {
    if (errorCode == 0) {   //成功
        
    }
    else {
        database.addData("zxg", zxgStr, zxgcallback_add);
    }
};

function zxgcallback_update(errorCode) {
    if (errorCode == 0) {   //成功

    }
    else {
        database.update("zxg", zxgStr, zxgcallback_update);
    }
};

//判断证券类型
function getStkType(code, mar) {
    if (mar == "SH" || mar == "sh") {
        if (code.indexOf("600") == 0) {
            return "1";    //上证A
        } else if (code.indexOf("2") == 0 || code.indexOf("9") == 0) {
            return "2";    //上证B
        } else if (code.indexOf("500") == 0) {
            return "4";    //上证封闭式基金
        } else if (code.indexOf("510") == 0 || code.indexOf("519") == 0 || code.indexOf("521") == 0 || code.indexOf("522") == 0 || code.indexOf("523") == 0 || code.indexOf("524") == 0) {
            return "5";    //上证开放式基金
        }  else if (code.indexOf("000") == 0) {
            return "7";    //上证指数
        } else if (("010,019,020,090,091,103,104,105,107,110,113,130,121,122,124,126,130,190,191,201,202,203,204,700,704,733,738,743,744,751,752,788,799").indexOf(code.substr(0, 3)) == 0) {
            return "8";    //上证债券
        }
    }
    else if (mar == "SZ" || mar == "sz") {
        if (code.indexOf("000") == 0) {
            return "11";    //深证A
        } else if (code.indexOf("2") == 0 || code.indexOf("9") == 0) {
            return "12";    //深证B
        } else if (code.indexOf("184") == 0 || code.indexOf("150") == 0) {
            return "14";    //深证封闭式基金
        } else if (("160,161,162,163,164,165,166").indexOf(code.substr(0,3)) == 0) {   
            return "15";    //深证开放式基金 160,161,162,163,164,165,166
        } else if (code.indexOf("399") == 0) {
            return "16";    //深证指数
        } else if (("100,101,108,109,111,112,115,118,119,125,126,129,131,369").indexOf(code.substr(0, 3)) == 0) {
            return "18";    //深证债券
        } else if (code.indexOf("002") == 0) {
            return "31";    //中小板
        } 
    }
    else if (mar == "STB" || mar == "stb") {
        return "30";
    }
}

