
function hex_sha1(e) {
	return binb2hex(core_sha1(str2binb(e), e.length * chrsz));
}
function b64_sha1(e) {
	return binb2b64(core_sha1(str2binb(e), e.length * chrsz));
}
function str_sha1(e) {
	return binb2str(core_sha1(str2binb(e), e.length * chrsz));
}
function hex_hmac_sha1(e, t) {
	return binb2hex(core_hmac_sha1(e, t));
}
function b64_hmac_sha1(e, t) {
	return binb2b64(core_hmac_sha1(e, t));
}
function str_hmac_sha1(e, t) {
	return binb2str(core_hmac_sha1(e, t));
}
function sha1_vm_test() {
	return hex_sha1("abc") == "a9993e364706816aba3e25717850c26c9cd0d89d";
}
function core_sha1(e, t) {
	e[t >> 5] |= 128 << 24 - t % 32, e[(t + 64 >> 9 << 4) + 15] = t;
	var n = Array(80), r = 1732584193, i = -271733879, s = -1732584194, o = 271733878, u = -1009589776;
	for (var a = 0; a < e.length; a += 16) {
		var f = r, l = i, c = s, h = o, p = u;
		for (var d = 0; d < 80; d++) {
			d < 16 ? n[d] = e[a + d] : n[d] = rol(n[d - 3] ^ n[d - 8] ^ n[d - 14] ^ n[d - 16], 1);
			var v = safe_add(safe_add(rol(r, 5), sha1_ft(d, i, s, o)), safe_add(safe_add(u, n[d]), sha1_kt(d)));
			u = o, o = s, s = rol(i, 30), i = r, r = v;
		}
		r = safe_add(r, f), i = safe_add(i, l), s = safe_add(s, c), o = safe_add(o, h), u = safe_add(u, p);
	}
	return Array(r, i, s, o, u);
}
function sha1_ft(e, t, n, r) {
	return e < 20 ? t & n | ~t & r : e < 40 ? t ^ n ^ r : e < 60 ? t & n | t & r | n & r : t ^ n ^ r;
}
function sha1_kt(e) {
	return e < 20 ? 1518500249 : e < 40 ? 1859775393 : e < 60 ? -1894007588 : -899497514;
}
function core_hmac_sha1(e, t) {
	var n = str2binb(e);
	n.length > 16 && (n = core_sha1(n, e.length * chrsz));
	var r = Array(16), i = Array(16);
	for (var s = 0; s < 16; s++) {
		r[s] = n[s] ^ 909522486, i[s] = n[s] ^ 1549556828;
	}
	var o = core_sha1(r.concat(str2binb(t)), 512 + t.length * chrsz);
	return core_sha1(i.concat(o), 672);
}
function rol(e, t) {
	return e << t | e >>> 32 - t;
}
function str2binb(e) {
	var t = Array(), n = (1 << chrsz) - 1;
	for (var r = 0; r < e.length * chrsz; r += chrsz) {
		t[r >> 5] |= (e.charCodeAt(r / chrsz) & n) << 32 - chrsz - r % 32;
	}
	return t;
}
function binb2str(e) {
	var t = "", n = (1 << chrsz) - 1;
	for (var r = 0; r < e.length * 32; r += chrsz) {
		t += String.fromCharCode(e[r >> 5] >>> 32 - chrsz - r % 32 & n);
	}
	return t;
}
function binb2hex(e) {
	var t = hexcase ? "0123456789ABCDEF" : "0123456789abcdef", n = "";
	for (var r = 0; r < e.length * 4; r++) {
		n += t.charAt(e[r >> 2] >> (3 - r % 4) * 8 + 4 & 15) + t.charAt(e[r >> 2] >> (3 - r % 4) * 8 & 15);
	}
	return n;
}
function binb2b64(e) {
	var t = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/", n = "";
	for (var r = 0; r < e.length * 4; r += 3) {
		var i = (e[r >> 2] >> 8 * (3 - r % 4) & 255) << 16 | (e[r + 1 >> 2] >> 8 * (3 - (r + 1) % 4) & 255) << 8 | e[r + 2 >> 2] >> 8 * (3 - (r + 2) % 4) & 255;
		for (var s = 0; s < 4; s++) {
			r * 8 + s * 6 > e.length * 32 ? n += b64pad : n += t.charAt(i >> 6 * (3 - s) & 63);
		}
	}
	return n.replace(/AAA\=(\=*?)$/, "$1");
}
function hex_md5(e) {
	return binl2hex(core_md5(str2binl(e), e.length * chrsz));
}
function b64_md5(e) {
	return binl2b64(core_md5(str2binl(e), e.length * chrsz));
}
function str_md5(e) {
	return binl2str(core_md5(str2binl(e), e.length * chrsz));
}
function hex_hmac_md5(e, t) {
	return binl2hex(core_hmac_md5(e, t));
}
function b64_hmac_md5(e, t) {
	return binl2b64(core_hmac_md5(e, t));
}
function str_hmac_md5(e, t) {
	return binl2str(core_hmac_md5(e, t));
}
function md5_vm_test() {
	return hex_md5("abc") == "900150983cd24fb0d6963f7d28e17f72";
}
function core_md5(e, t) {
	e[t >> 5] |= 128 << t % 32, e[(t + 64 >>> 9 << 4) + 14] = t;
	var n = 1732584193, r = -271733879, i = -1732584194, s = 271733878;
	for (var o = 0; o < e.length; o += 16) {
		var u = n, a = r, f = i, l = s;
		n = md5_ff(n, r, i, s, e[o + 0], 7, -680876936), s = md5_ff(s, n, r, i, e[o + 1], 12, -389564586), i = md5_ff(i, s, n, r, e[o + 2], 17, 606105819), r = md5_ff(r, i, s, n, e[o + 3], 22, -1044525330), n = md5_ff(n, r, i, s, e[o + 4], 7, -176418897), s = md5_ff(s, n, r, i, e[o + 5], 12, 1200080426), i = md5_ff(i, s, n, r, e[o + 6], 17, -1473231341), r = md5_ff(r, i, s, n, e[o + 7], 22, -45705983), n = md5_ff(n, r, i, s, e[o + 8], 7, 1770035416), s = md5_ff(s, n, r, i, e[o + 9], 12, -1958414417), i = md5_ff(i, s, n, r, e[o + 10], 17, -42063), r = md5_ff(r, i, s, n, e[o + 11], 22, -1990404162), n = md5_ff(n, r, i, s, e[o + 12], 7, 1804603682), s = md5_ff(s, n, r, i, e[o + 13], 12, -40341101), i = md5_ff(i, s, n, r, e[o + 14], 17, -1502002290), r = md5_ff(r, i, s, n, e[o + 15], 22, 1236535329), n = md5_gg(n, r, i, s, e[o + 1], 5, -165796510), s = md5_gg(s, n, r, i, e[o + 6], 9, -1069501632), i = md5_gg(i, s, n, r, e[o + 11], 14, 643717713), r = md5_gg(r, i, s, n, e[o + 0], 20, -373897302), n = md5_gg(n, r, i, s, e[o + 5], 5, -701558691), s = md5_gg(s, n, r, i, e[o + 10], 9, 38016083), i = md5_gg(i, s, n, r, e[o + 15], 14, -660478335), r = md5_gg(r, i, s, n, e[o + 4], 20, -405537848), n = md5_gg(n, r, i, s, e[o + 9], 5, 568446438), s = md5_gg(s, n, r, i, e[o + 14], 9, -1019803690), i = md5_gg(i, s, n, r, e[o + 3], 14, -187363961), r = md5_gg(r, i, s, n, e[o + 8], 20, 1163531501), n = md5_gg(n, r, i, s, e[o + 13], 5, -1444681467), s = md5_gg(s, n, r, i, e[o + 2], 9, -51403784), i = md5_gg(i, s, n, r, e[o + 7], 14, 1735328473), r = md5_gg(r, i, s, n, e[o + 12], 20, -1926607734), n = md5_hh(n, r, i, s, e[o + 5], 4, -378558), s = md5_hh(s, n, r, i, e[o + 8], 11, -2022574463), i = md5_hh(i, s, n, r, e[o + 11], 16, 1839030562), r = md5_hh(r, i, s, n, e[o + 14], 23, -35309556), n = md5_hh(n, r, i, s, e[o + 1], 4, -1530992060), s = md5_hh(s, n, r, i, e[o + 4], 11, 1272893353), i = md5_hh(i, s, n, r, e[o + 7], 16, -155497632), r = md5_hh(r, i, s, n, e[o + 10], 23, -1094730640), n = md5_hh(n, r, i, s, e[o + 13], 4, 681279174), s = md5_hh(s, n, r, i, e[o + 0], 11, -358537222), i = md5_hh(i, s, n, r, e[o + 3], 16, -722521979), r = md5_hh(r, i, s, n, e[o + 6], 23, 76029189), n = md5_hh(n, r, i, s, e[o + 9], 4, -640364487), s = md5_hh(s, n, r, i, e[o + 12], 11, -421815835), i = md5_hh(i, s, n, r, e[o + 15], 16, 530742520), r = md5_hh(r, i, s, n, e[o + 2], 23, -995338651), n = md5_ii(n, r, i, s, e[o + 0], 6, -198630844), s = md5_ii(s, n, r, i, e[o + 7], 10, 1126891415), i = md5_ii(i, s, n, r, e[o + 14], 15, -1416354905), r = md5_ii(r, i, s, n, e[o + 5], 21, -57434055), n = md5_ii(n, r, i, s, e[o + 12], 6, 1700485571), s = md5_ii(s, n, r, i, e[o + 3], 10, -1894986606), i = md5_ii(i, s, n, r, e[o + 10], 15, -1051523), r = md5_ii(r, i, s, n, e[o + 1], 21, -2054922799), n = md5_ii(n, r, i, s, e[o + 8], 6, 1873313359), s = md5_ii(s, n, r, i, e[o + 15], 10, -30611744), i = md5_ii(i, s, n, r, e[o + 6], 15, -1560198380), r = md5_ii(r, i, s, n, e[o + 13], 21, 1309151649), n = md5_ii(n, r, i, s, e[o + 4], 6, -145523070), s = md5_ii(s, n, r, i, e[o + 11], 10, -1120210379), i = md5_ii(i, s, n, r, e[o + 2], 15, 718787259), r = md5_ii(r, i, s, n, e[o + 9], 21, -343485551), n = safe_add(n, u), r = safe_add(r, a), i = safe_add(i, f), s = safe_add(s, l);
	}
	return Array(n, r, i, s);
}
function md5_cmn(e, t, n, r, i, s) {
	return safe_add(bit_rol(safe_add(safe_add(t, e), safe_add(r, s)), i), n);
}
function md5_ff(e, t, n, r, i, s, o) {
	return md5_cmn(t & n | ~t & r, e, t, i, s, o);
}
function md5_gg(e, t, n, r, i, s, o) {
	return md5_cmn(t & r | n & ~r, e, t, i, s, o);
}
function md5_hh(e, t, n, r, i, s, o) {
	return md5_cmn(t ^ n ^ r, e, t, i, s, o);
}
function md5_ii(e, t, n, r, i, s, o) {
	return md5_cmn(n ^ (t | ~r), e, t, i, s, o);
}
function core_hmac_md5(e, t) {
	var n = str2binl(e);
	n.length > 16 && (n = core_md5(n, e.length * chrsz));
	var r = Array(16), i = Array(16);
	for (var s = 0; s < 16; s++) {
		r[s] = n[s] ^ 909522486, i[s] = n[s] ^ 1549556828;
	}
	var o = core_md5(r.concat(str2binl(t)), 512 + t.length * chrsz);
	return core_md5(i.concat(o), 640);
}
function safe_add(e, t) {
	var n = (e & 65535) + (t & 65535), r = (e >> 16) + (t >> 16) + (n >> 16);
	return r << 16 | n & 65535;
}
function bit_rol(e, t) {
	return e << t | e >>> 32 - t;
}
function str2binl(e) {
	var t = Array(), n = (1 << chrsz) - 1;
	for (var r = 0; r < e.length * chrsz; r += chrsz) {
		t[r >> 5] |= (e.charCodeAt(r / chrsz) & n) << r % 32;
	}
	return t;
}
function binl2str(e) {
	var t = "", n = (1 << chrsz) - 1;
	for (var r = 0; r < e.length * 32; r += chrsz) {
		t += String.fromCharCode(e[r >> 5] >>> r % 32 & n);
	}
	return t;
}
function binl2hex(e) {
	var t = hexcase ? "0123456789ABCDEF" : "0123456789abcdef", n = "";
	for (var r = 0; r < e.length * 4; r++) {
		n += t.charAt(e[r >> 2] >> r % 4 * 8 + 4 & 15) + t.charAt(e[r >> 2] >> r % 4 * 8 & 15);
	}
	return n;
}
function binl2b64(e) {
	var t = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/", n = "";
	for (var r = 0; r < e.length * 4; r += 3) {
		var i = (e[r >> 2] >> 8 * (r % 4) & 255) << 16 | (e[r + 1 >> 2] >> 8 * ((r + 1) % 4) & 255) << 8 | e[r + 2 >> 2] >> 8 * ((r + 2) % 4) & 255;
		for (var s = 0; s < 4; s++) {
			r * 8 + s * 6 > e.length * 32 ? n += b64pad : n += t.charAt(i >> 6 * (3 - s) & 63);
		}
	}
	return n;
}
function utf8t2d(e) {
	e = e.replace(/\r\n/g, "\n");
	var t = new Array, n = String.fromCharCode(237);
	if (n.charCodeAt(0) < 0) {
		for (var r = 0; r < e.length; r++) {
			var i = e.charCodeAt(r);
			i > 0 ? t[t.length] = i : (t[t.length] = 256 + i >> 6 | 192, t[t.length] = 256 + i & 63 | 128);
		}
	} else {
		for (var r = 0; r < e.length; r++) {
			var i = e.charCodeAt(r);
			i < 128 ? t[t.length] = i : i > 127 && i < 2048 ? (t[t.length] = i >> 6 | 192, t[t.length] = i & 63 | 128) : (t[t.length] = i >> 12 | 224, t[t.length] = i >> 6 & 63 | 128, t[t.length] = i & 63 | 128);
		}
	}
	return t;
}
function utf8d2t(e) {
	var t = new Array, n = 0;
	while (n < e.length) {
		e[n] < 128 ? (t[t.length] = String.fromCharCode(e[n]), n++) : e[n] > 191 && e[n] < 224 ? (t[t.length] = String.fromCharCode((e[n] & 31) << 6 | e[n + 1] & 63), n += 2) : (t[t.length] = String.fromCharCode((e[n] & 15) << 12 | (e[n + 1] & 63) << 6 | e[n + 2] & 63), n += 3);
	}
	return t.join("");
}
function b64arrays() {
	var e = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
	b64 = new Array, f64 = new Array;
	for (var t = 0; t < e.length; t++) {
		b64[t] = e.charAt(t), f64[e.charAt(t)] = t;
	}
}
function b64d2t(e) {
	var t = new Array, n = 0, r = e.length;
	r % 3 == 1 && (e[e.length] = 0, e[e.length] = 0), r % 3 == 2 && (e[e.length] = 0);
	while (n < e.length) {
		t[t.length] = b64[e[n] >> 2], t[t.length] = b64[(e[n] & 3) << 4 | e[n + 1] >> 4], t[t.length] = b64[(e[n + 1] & 15) << 2 | e[n + 2] >> 6], t[t.length] = b64[e[n + 2] & 63], n += 3;
	}
	r % 3 == 1 && (t[t.length - 1] = t[t.length - 2] = "="), r % 3 == 2 && (t[t.length - 1] = "=");
	var i = t.join("");
	return i;
}
function b64t2d(e) {
	var t = new Array, n = 0;
	e = e.replace(/\n|\r/g, ""), e = e.replace(/=/g, "");
	while (n < e.length) {
		t[t.length] = f64[e.charAt(n)] << 2 | f64[e.charAt(n + 1)] >> 4, t[t.length] = (f64[e.charAt(n + 1)] & 15) << 4 | f64[e.charAt(n + 2)] >> 2, t[t.length] = (f64[e.charAt(n + 2)] & 3) << 6 | f64[e.charAt(n + 3)], n += 4;
	}
	return e.length % 4 == 2 && (t = t.slice(0, t.length - 2)), e.length % 4 == 3 && (t = t.slice(0, t.length - 1)), t;
}
function cnonce(e) {
	var t = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789", n = "";
	for (var r = 0; r < e; r++) {
		n += t.charAt(Math.round(Math.random((new Date).getTime()) * (t.length - 1)));
	}
	return n;
}
function JSJaCJSON() {
}
function XmlDocument() {
}
function JSJaCConsoleLogger(e) {
	this.level = e || 4, this.start = function () {
	}, this.log = function (e, t) {
		t = t || 0;
		if (t > this.level) {
			return;
		}
		if (typeof console == "undefined") {
			return;
		}
		try {
			switch (t) {
			  case 0:
				console.warn(e);
				break;
			  case 1:
				console.error(e);
				break;
			  case 2:
				console.info(e);
				break;
			  case 4:
				console.debug(e);
				break;
			  default:
				console.log(e);
			}
		}
		catch (n) {
			try {
				console.log(e);
			}
			catch (n) {
			}
		}
	}, this.setLevel = function (e) {
		return this.level = e, this;
	}, this.getLevel = function () {
		return this.level;
	};
}
function JSJaCCookie(e, t, n) {
	if (window == this) {
		return new JSJaCCookie(e, t, n);
	}
	this.name = e, this.value = t, this.secs = n, this.write = function () {
		if (this.secs) {
			var e = new Date;
			e.setTime(e.getTime() + this.secs * 1000);
			var t = "; expires=" + e.toGMTString();
		} else {
			var t = "";
		}
		document.cookie = this.getName() + "=" + this.getValue() + t + "; path=/";
	}, this.erase = function () {
		var e = new JSJaCCookie(this.getName(), "", -1);
		e.write();
	}, this.getName = function () {
		return this.name;
	}, this.setName = function (e) {
		return this.name = e, this;
	}, this.getValue = function () {
		return this.value;
	}, this.setValue = function (e) {
		return this.value = e, this;
	};
}
function JSJaCCookieException(e) {
	this.message = e, this.name = "CookieException";
}
function JSJaCError(e, t, n, r) {
	r == undefined && (r = "");
	var i = XmlDocument.create("error", "jsjac");
	return i.documentElement.setAttribute("code", e), i.documentElement.setAttribute("type", t), i.documentElement.setAttribute("content", r), i.documentElement.appendChild(i.createElement(n)).setAttribute("xmlns", "urn:ietf:params:xml:ns:xmpp-stanzas"), i.documentElement;
}
function JSJaCConnection(e) {
	e && e.oDbg && e.oDbg.log ? this.oDbg = e.oDbg : (this.oDbg = new Object, this.oDbg.log = function () {
	}), e && e.httpbase && (this._httpbase = e.httpbase), e && e.allow_plain ? this.allow_plain = e.allow_plain : this.allow_plain = JSJAC_ALLOW_PLAIN, this._connected = !1, this._events = new Array, this._keys = null, this._ID = 0, this._inQ = new Array, this._pQueue = new Array, this._regIDs = new Array, this._req = new Array, this._status = "intialized", this._errcnt = 0, this._inactivity = JSJAC_INACTIVITY, this._sendRawCallbacks = new Array, e && e.timerval && this.setPollInterval(e.timerval);
}
function JSJaCHttpBindingConnection(e) {
	this.base = JSJaCConnection, this.base(e), this._hold = JSJACHBC_MAX_HOLD, this._inactivity = 0, this._last_requests = new Object, this._last_rid = 0, this._min_polling = 0, this._pause = 0, this._wait = JSJACHBC_MAX_WAIT;
}
function aaa() {
	remotecsswebroom.logout();
}
var JSJAC_HAVEKEYS = !0, JSJAC_NKEYS = 16, JSJAC_INACTIVITY = 60, JSJAC_ERR_COUNT = 10, JSJAC_ALLOW_PLAIN = !0, JSJAC_CHECKQUEUEINTERVAL = 1, JSJAC_CHECKINQUEUEINTERVAL = 1, JSJACHBC_BOSH_VERSION = "1.6", JSJACHBC_USE_BOSH_VER = !0, JSJACHBC_MAX_HOLD = 1, JSJACHBC_MAX_WAIT = 60, JSJACHBC_MAXPAUSE = 120;
String.prototype.htmlEnc = function () {
	var e = this.replace(/&/g, "&amp;");
	return e = e.replace(/</g, "&lt;"), e = e.replace(/>/g, "&gt;"), e = e.replace(/\"/g, "&quot;"), e = e.replace(/\n/g, "<br />"), e;
}, Date.jab2date = function (e) {
	var t = new Date(Date.UTC(e.substr(0, 4), e.substr(5, 2) - 1, e.substr(8, 2), e.substr(11, 2), e.substr(14, 2), e.substr(17, 2)));
	if (e.substr(e.length - 6, 1) != "Z") {
		var n = new Date;
		n.setTime(0), n.setUTCHours(e.substr(e.length - 5, 2)), n.setUTCMinutes(e.substr(e.length - 2, 2)), e.substr(e.length - 6, 1) == "+" ? t.setTime(t.getTime() - n.getTime()) : e.substr(e.length - 6, 1) == "-" && t.setTime(t.getTime() + n.getTime());
	}
	return t;
}, Date.hrTime = function (e) {
	return Date.jab2date(e).toLocaleString();
}, Date.prototype.jabberDate = function () {
	var e = function (e) {
		return e < 10 ? "0" + e : e;
	}, t = this.getUTCFullYear() + "-";
	return t += e(this.getUTCMonth() + 1) + "-", t += e(this.getUTCDate()) + "T", t += e(this.getUTCHours()) + ":", t += e(this.getUTCMinutes()) + ":", t += e(this.getUTCSeconds()) + "Z", t;
}, Number.max = function (e, t) {
	return e > t ? e : t;
};
var hexcase = 0, b64pad = "=", chrsz = 8;
(typeof atob == "undefined" || typeof btoa == "undefined") && b64arrays(), typeof atob == "undefined" && (atob = function (e) {
	return utf8d2t(b64t2d(e));
}), typeof btoa == "undefined" && (btoa = function (e) {
	return b64d2t(utf8t2d(e));
}), JSJaCJSON.toString = function (e) {
	var t = {"\b":"\\b", "\t":"\\t", "\n":"\\n", "\f":"\\f", "\r":"\\r", "\"":"\\\"", "\\":"\\\\"}, n = {array:function (e) {
		var t = ["["], r, i, s, o = e.length, u;
		for (s = 0; s < o; s += 1) {
			u = e[s], i = n[typeof u], i && (u = i(u), typeof u == "string" && (r && (t[t.length] = ","), t[t.length] = u, r = !0));
		}
		return t[t.length] = "]", t.join("");
	}, "boolean":function (e) {
		return String(e);
	}, "null":function (e) {
		return "null";
	}, number:function (e) {
		return isFinite(e) ? String(e) : "null";
	}, object:function (e) {
		if (e) {
			if (e instanceof Array) {
				return n.array(e);
			}
			var t = ["{"], r, i, s, o;
			for (s in e) {
				e.hasOwnProperty(s) && (o = e[s], i = n[typeof o], i && (o = i(o), typeof o == "string" && (r && (t[t.length] = ","), t.push(n.string(s), ":", o), r = !0)));
			}
			return t[t.length] = "}", t.join("");
		}
		return "null";
	}, string:function (e) {
		return /["\\\x00-\x1f]/.test(e) && (e = e.replace(/([\x00-\x1f\\"])/g, function (e, n) {
			var r = t[n];
			return r ? r : (r = n.charCodeAt(), "\\u00" + Math.floor(r / 16).toString(16) + (r % 16).toString(16));
		})), "\"" + e + "\"";
	}};
	switch (typeof e) {
	  case "object":
		return n.object(e);
	  case "array":
		return n.array(e);
	}
}, JSJaCJSON.parse = function (str) {
	try {
		return !/[^,:{}\[\]0-9.\-+Eaeflnr-u \n\r\t]/.test(str.replace(/"(\\.|[^"\\])*"/g, "")) && eval("(" + str + ")");
	}
	catch (e) {
		return !1;
	}
}, XmlDocument.create = function (e, t) {
	e = e || "foo", t = t || "";
	try {
		var n;
		document.implementation && document.implementation.createDocument ? (n = document.implementation.createDocument(t, e, null), n.readyState == null && (n.readyState = 1, n.addEventListener("load", function () {
			n.readyState = 4, typeof n.onreadystatechange == "function" && n.onreadystatechange();
		}, !1))) : window.ActiveXObject && (n = new ActiveXObject(XmlDocument.getPrefix() + ".DomDocument"));
		if (!n.documentElement || n.documentElement.tagName != e || n.documentElement.namespaceURI && n.documentElement.namespaceURI != t) {
			try {
				t != "" ? n.appendChild(n.createElement(e)).setAttribute("xmlns", t) : n.appendChild(n.createElement(e));
			}
			catch (r) {
				n = document.implementation.createDocument(t, e, null), n.documentElement == null && n.appendChild(n.createElement(e)), t != "" && n.documentElement.getAttribute("xmlns") != t && n.documentElement.setAttribute("xmlns", t);
			}
		}
		return n;
	}
	catch (i) {
		alert(i.name + ": " + i.message);
	}
	throw new Error("Your browser does not support XmlDocument objects");
}, XmlDocument.getPrefix = function () {
	if (XmlDocument.prefix) {
		return XmlDocument.prefix;
	}
	var e = ["MSXML2", "Microsoft", "MSXML", "MSXML3"], t;
	for (var n = 0; n < e.length; n++) {
		try {
			return t = new ActiveXObject(e[n] + ".DomDocument"), XmlDocument.prefix = e[n];
		}
		catch (r) {
		}
	}
	throw new Error("Could not find an installed XML parser");
}, JSJaCCookie.read = function (e) {
	var t = e + "=", n = document.cookie.split(";");
	for (var r = 0; r < n.length; r++) {
		var i = n[r];
		while (i.charAt(0) == " ") {
			i = i.substring(1, i.length);
		}
		if (i.indexOf(t) == 0) {
			return new JSJaCCookie(e, i.substring(t.length, i.length));
		}
	}
	throw new JSJaCCookieException("Cookie not found");
}, JSJaCCookie.get = function (e) {
	return JSJaCCookie.read(e).getValue();
}, JSJaCCookie.remove = function (e) {
	JSJaCCookie.read(e).erase();
}, JSJaCConnection.prototype.connect = function (e) {
	this._setStatus("connecting"), this.domain = e.domain || "localhost", this.authzid = e.authzid, this.username = e.username, this.resource = e.resource, this.pass = e.pass, this.register = e.register, this._custId = e.custId, this._custType = e.custType, this._roomId = e.roomId, this._MD5Pass = e.MD5Pass, this._ettoken = e.ettoken, this.authhost = e.authhost || this.domain, this.authtype = e.authtype || "sasl", e.xmllang && e.xmllang != "" && (this._xmllang = e.xmllang), this.host = e.host || this.domain, this.port = e.port || 5222, e.secure ? this.secure = "true" : this.secure = "false", e.wait && (this._wait = e.wait), this.jid = this.username + "@" + this.domain, this.fulljid = this.jid + "/" + this.resource, this._rid = Math.round(100000.5 + 799999.99999 * Math.random());
	var t = this._getFreeSlot();
	this._req[t] = this._setupRequest(!0, t);
	var n = this._getInitialRequestString();
	this._req[t].r.onreadystatechange = JSJaC.bind(function () {
		this._req[t].r.status == "success" && this._handleInitialResponse(t);
	}, this), this._req[t].r.error = JSJaC.bind(function (e, t, n) {
		return this._handleEvent("onerror", JSJaCError("500", "cancel", "service-unavailable")), !1;
	}, this), this._req[t].r.send(n);
}, JSJaCConnection.prototype.connected = function () {
	return this._connected;
}, JSJaCConnection.prototype.disconnect = function () {
	this._setStatus("disconnecting");
	if (!this.connected()) {
		return;
	}
	this._connected = !1, clearInterval(this._interval), clearInterval(this._inQto), this._timeout && clearTimeout(this._timeout);
	var e = this._getFreeSlot();
	this._req[e] = this._setupRequest(!1, e), request = this._getRequestString(!1, !0), this.oDbg.log("Disconnecting: " + request, 4), this._req[e].r.send(request);
	try {
		JSJaCCookie.read("JSJaC_State").erase();
	}
	catch (t) {
	}
	this.oDbg.log("Disconnected: " + this._req[e].r.responseText, 2), this._handleEvent("ondisconnect", "disconnect:" + this._req[e].r.responseText);
}, JSJaCConnection.prototype.getPollInterval = function () {
	return this._timerval;
}, JSJaCConnection.prototype.registerHandler = function (event) {
	event = event.toLowerCase();
	var eArg = {handler:arguments[arguments.length - 1], childName:"*", childNS:"*", type:"*"};
	arguments.length > 2 && (eArg.childName = arguments[1]), arguments.length > 3 && (eArg.childNS = arguments[2]), arguments.length > 4 && (eArg.type = arguments[3]), this._events[event] ? this._events[event] = this._events[event].concat(eArg) : this._events[event] = new Array(eArg), this._events[event] = this._events[event].sort(function (a, b) {
		var aRank = 0, bRank = 0;
		with (a) {
			type == "*" && aRank++, childNS == "*" && aRank++, childName == "*" && aRank++;
		}
		with (b) {
			type == "*" && bRank++, childNS == "*" && bRank++, childName == "*" && bRank++;
		}
		return aRank > bRank ? 1 : aRank < bRank ? -1 : 0;
	}), this.oDbg.log("registered handler for event '" + event + "'", 2);
}, JSJaCConnection.prototype.unregisterHandler = function (e, t) {
	e = e.toLowerCase();
	if (!this._events[e]) {
		return;
	}
	var n = this._events[e], r = new Array;
	for (var i = 0; i < n.length; i++) {
		n[i].handler != t && r.push(n[i]);
	}
	n.length != r.length && (this._events[e] = r, this.oDbg.log("unregistered handler for event '" + e + "'", 2));
}, JSJaCConnection.prototype.registerIQGet = function (e, t, n) {
	this.registerHandler("iq", e, t, "get", n);
}, JSJaCConnection.prototype.registerIQSet = function (e, t, n) {
	this.registerHandler("iq", e, t, "set", n);
}, JSJaCConnection.prototype.resume = function () {
	try {
		this._setStatus("resuming");
		var e = unescape(JSJaCCookie.read("JSJaC_State").getValue());
		this.oDbg.log("read cookie: " + e, 2);
		var t = JSJaCJSON.parse(e);
		for (var n in t) {
			t.hasOwnProperty(n) && (this[n] = t[n]);
		}
		if (this._keys) {
			this._keys2 = new JSJaCKeys;
			var r = this._keys2._getSuspendVars();
			for (var n = 0; n < r.length; n++) {
				this._keys2[r[n]] = this._keys[r[n]];
			}
			this._keys = this._keys2;
		}
		try {
			JSJaCCookie.read("JSJaC_State").erase();
		}
		catch (i) {
		}
		return this._connected && (this._handleEvent("onresume"), setTimeout(JSJaC.bind(this._resume, this), this.getPollInterval()), this._interval = setInterval(JSJaC.bind(this._checkQueue, this), JSJAC_CHECKQUEUEINTERVAL), this._inQto = setInterval(JSJaC.bind(this._checkInQ, this), JSJAC_CHECKINQUEUEINTERVAL)), this._connected === !0;
	}
	catch (i) {
		return i.message ? this.oDbg.log("Resume failed: " + i.message, 1) : this.oDbg.log("Resume failed: " + i, 1), !1;
	}
}, JSJaCConnection.prototype.send = function (e, t, n) {
	if (!this.connected()) {
		return !1;
	}
	try {
		this._pQueue = this._pQueue.concat(e);
	}
	catch (r) {
		return !1;
	}
	return !0;
}, JSJaCConnection.prototype.setPollInterval = function (e) {
	return e && !isNaN(e) && (this._timerval = e), this._timerval;
}, JSJaCConnection.prototype.status = function () {
	return this._status;
}, JSJaCConnection.prototype.suspend = function () {
	clearTimeout(this._timeout), clearInterval(this._interval), clearInterval(this._inQto), this._suspend();
	var e = "_connected,_keys,_ID,_inQ,_pQueue,_regIDs,_errcnt,_inactivity,domain,username,resource,jid,fulljid,_sid,_httpbase,_timerval,_is_polling".split(",");
	e = e.concat(this._getSuspendVars());
	var t = new Object;
	for (var n = 0; n < e.length; n++) {
		if (!this[e[n]]) {
			continue;
		}
		if (this[e[n]]._getSuspendVars) {
			var r = this[e[n]]._getSuspendVars(), i = new Object;
			for (var s = 0; s < r.length; s++) {
				i[r[s]] = this[e[n]][r[s]];
			}
		} else {
			var i = this[e[n]];
		}
		t[e[n]] = i;
	}
	var o = new JSJaCCookie("JSJaC_State", escape(JSJaCJSON.toString(t)), this._inactivity);
	this.oDbg.log("writing cookie: " + unescape(o.value) + "\n(length:" + unescape(o.value).length + ")", 2), o.write();
	try {
		var u = JSJaCCookie.read("JSJaC_State");
		o.value != u.value && (this.oDbg.log("Suspend failed writing cookie.\nRead: " + unescape(JSJaCCookie.read("JSJaC_State")), 1), o.erase()), this._connected = !1, this._setStatus("suspending");
	}
	catch (a) {
		this.oDbg.log("Failed reading cookie 'JSJaC_State': " + a.message);
	}
}, JSJaCConnection.prototype._abort = function () {
	clearTimeout(this._timeout), clearInterval(this._inQto), clearInterval(this._interval), this._connected = !1, this._setStatus("aborted"), this._handleEvent("ondisconnect", "aborted");
}, JSJaCConnection.prototype._checkInQ = function () {
	for (var e = 0; e < this._inQ.length && e < 10; e++) {
		var t = this._inQ[0];
		this._inQ = this._inQ.slice(1, this._inQ.length);
		var n = t;
		if (!n) {
			return;
		}
		if (n.body && !this._handlePID(n)) {
			if (n.body.pRType) {
				this._handleEvent(n.body.pRType, n.body);
			} else {
				for (var r = 0; r < n.body.length; r++) {
					var i = n.body[r];
					this._handleEvent(i.pRType, i);
				}
			}
		}
	}
}, JSJaCConnection.prototype._checkQueue = function () {
	return this._pQueue.length != 0 && this._process(), !0;
}, JSJaCConnection.prototype._handleEvent = function (e, t) {
	e = e.toLowerCase(), this.oDbg.log("incoming event '" + e + "'", 3);
	if (!this._events[e]) {
		return;
	}
	this.oDbg.log("handling event '" + e + "'", 2);
	for (var n = 0; n < this._events[e].length; n++) {
		var r = this._events[e][n];
		if (r.handler) {
			try {
				if (t) {
					if (r.handler.call(this, t)) {
						break;
					}
				} else {
					if (r.handler.call(this)) {
						break;
					}
				}
			}
			catch (i) {
				this.oDbg.log(r.handler + "\n>>>" + i.name + ": " + i.message, 1);
			}
		}
	}
}, JSJaCConnection.prototype._handlePID = function (e) {
	if (!e.id) {
		return !1;
	}
	for (var t in this._regIDs) {
		if (this._regIDs.hasOwnProperty(t) && this._regIDs[t] && t == e.id) {
			var n = e.id;
			try {
				return this._regIDs[t].cb.call(this, e, this._regIDs[t].arg) === !1 ? !1 : (this._unregisterPID(n), !0);
			}
			catch (r) {
				return this.oDbg.log(r.name + ": " + r.message), this._unregisterPID(n), !0;
			}
		}
	}
	return !1;
}, JSJaCConnection.prototype._handleResponse = function (e) {
	var t = this._parseResponse(e);
	if (!t) {
		return;
	}
	if (this._sendRawCallbacks.length) {
		var n = this._sendRawCallbacks[0];
		this._sendRawCallbacks = this._sendRawCallbacks.slice(1, this._sendRawCallbacks.length), n.fn.call(this, t, n.arg);
		return;
	}
	this._inQ = this._inQ.concat(t);
}, JSJaCConnection.prototype._parseStreamFeatures = function (e) {
	if (!e) {
		return this.oDbg.log("nothing to parse ... aborting", 1), !1;
	}
	var t;
	if (e.getElementsByTagNameNS) {
		t = e.getElementsByTagNameNS("http://etherx.jabber.org/streams", "error").item(0);
	} else {
		var n = e.getElementsByTagName("error");
		for (var r = 0; r < n.length; r++) {
			if (n.item(r).namespaceURI == "http://etherx.jabber.org/streams") {
				t = n.item(r);
				break;
			}
		}
	}
	if (t) {
		return this._setStatus("internal_server_error"), clearTimeout(this._timeout), clearInterval(this._interval), clearInterval(this._inQto), this._handleEvent("onerror", JSJaCError("503", "cancel", "session-terminate")), this._connected = !1, this.oDbg.log("Disconnected.", 1), this._handleEvent("ondisconnect", "error"), !1;
	}
	this.mechs = new Object;
	var i = e.getElementsByTagName("mechanisms");
	this.has_sasl = !1;
	for (var r = 0; r < i.length; r++) {
		if (i.item(r).getAttribute("xmlns") == "urn:ietf:params:xml:ns:xmpp-sasl") {
			this.has_sasl = !0;
			var s = i.item(r).getElementsByTagName("mechanism");
			for (var o = 0; o < s.length; o++) {
				this.mechs[s.item(o).firstChild.nodeValue] = !0;
			}
			break;
		}
	}
	return this.has_sasl ? this.oDbg.log("SASL detected", 2) : (this.authtype = "nonsasl", this.oDbg.log("No support for SASL detected", 2)), !0;
}, JSJaCConnection.prototype._process = function (e) {
	if (!this.connected()) {
		this.oDbg.log("Connection lost ...", 1), this._interval && clearInterval(this._interval);
		return;
	}
	this.setPollInterval(e), this._timeout && clearTimeout(this._timeout);
	var t = this._getFreeSlot();
	if (t < 0) {
		return;
	}
	if (typeof this._req[t] != "undefined" && typeof this._req[t].r != "undefined" && this._req[t].r.status == "starting") {
		this.oDbg.log("Slot " + t + " is not ready");
		return;
	}
	if (!this.isPolling() && this._pQueue.length == 0 && this._req[(t + 1) % 2] && this._req[(t + 1) % 2].r.status == "starting") {
		this.oDbg.log("all slots busy, standby ...", 2);
		return;
	}
	this.isPolling() || this.oDbg.log("Found working slot at " + t, 2), this._req[t] = this._setupRequest(!0, t), this._req[t].r.onreadystatechange = JSJaC.bind(function () {
		if (!this.connected()) {
			return;
		}
		this._req[t].r.status == "success" && (this._setStatus("processing"), this._handleResponse(this._req[t]), this._pQueue.length ? this._timeout = setTimeout(JSJaC.bind(this._process, this), 100) : (this.oDbg.log("scheduling next poll in " + this.getPollInterval() + " msec", 4), this._timeout = setTimeout(JSJaC.bind(this._process, this), this.getPollInterval())));
	}, this);
	try {
		this._req[t].r.onerror = JSJaC.bind(function () {
			if (!this.connected()) {
				return;
			}
			return this._errcnt++, this._errcnt > JSJAC_ERR_COUNT ? (this._abort(), !1) : (this._setStatus("onerror_fallback"), setTimeout(JSJaC.bind(this._resume, this), this.getPollInterval()), !1);
		}, this);
	}
	catch (n) {
	}
	var r = this._getRequestString();
	typeof this._rid != "undefined" && (this._req[t].rid = this._rid), this.oDbg.log("sending: " + r, 4), this._req[t].r.send(r);
}, JSJaCConnection.prototype._registerPID = function (e, t, n) {
	return !e || !t ? !1 : (this._regIDs[e] = new Object, this._regIDs[e].cb = t, n && (this._regIDs[e].arg = n), this.oDbg.log("registered " + e, 3), !0);
}, JSJaCConnection.prototype._sendEmpty = function () {
	var e = this._getFreeSlot();
	this._req[e] = this._setupRequest(!0, e), this._req[e].r.onreadystatechange = JSJaC.bind(function () {
		this._req[e].r.status == "success" && this._getStreamID(e);
	}, this), typeof this._req[e].r.onerror != "undefined" && (this._req[e].r.onerror = JSJaC.bind(function (e) {
		return !1;
	}, this));
	var t = this._getRequestString();
	this.oDbg.log("sending: " + t, 4), this._req[e].r.send(t);
}, JSJaCConnection.prototype._sendRaw = function (e, t, n) {
	return t && this._sendRawCallbacks.push({fn:t, arg:n}), this._pQueue.push(e), this._process(), !0;
}, JSJaCConnection.prototype._setStatus = function (e) {
	if (!e || e == "") {
		return;
	}
	e != this._status && (this._status = e, this._handleEvent("onstatuschanged", e), this._handleEvent("status_changed", e));
}, JSJaCConnection.prototype._unregisterPID = function (e) {
	return this._regIDs[e] ? (this._regIDs[e] = null, this.oDbg.log("unregistered " + e, 3), !0) : !1;
}, JSJaCHttpBindingConnection.prototype = new JSJaCConnection, JSJaCHttpBindingConnection.prototype.inherit = function (e) {
	this.domain = e.domain || "localhost", this.username = e.username, this.resource = e.resource, this._sid = e.sid, this._rid = e.rid, this._custId = e.custId, this._custType = e.custType, this._roomId = e.roomId, this._MD5Pass = e.MD5Pass, this._ettoken = e.ettoken, this._min_polling = e.polling, this._inactivity = e.inactivity, this._setHold(e.requests - 1), this.setPollInterval(this._timerval), e.wait && (this._wait = e.wait), this._connected = !0, this._handleEvent("onconnect"), this._interval = setInterval(JSJaC.bind(this._checkQueue, this), JSJAC_CHECKQUEUEINTERVAL), this._inQto = setInterval(JSJaC.bind(this._checkInQ, this), JSJAC_CHECKINQUEUEINTERVAL), this._timeout = setTimeout(JSJaC.bind(this._process, this), this.getPollInterval());
}, JSJaCHttpBindingConnection.prototype.setPollInterval = function (e) {
	return e && !isNaN(e) && (this.isPolling() ? this._min_polling && e < this._min_polling * 1000 ? this._timerval = this._min_polling * 1000 : this._inactivity && e > this._inactivity * 1000 ? this._timerval = this._inactivity * 1000 : this._timerval = e : this._timerval = 100), this._timerval;
}, JSJaCHttpBindingConnection.prototype.isPolling = function () {
	return this._hold == 0;
}, JSJaCHttpBindingConnection.prototype._getFreeSlot = function () {
	for (var e = 0; e < this._hold + 1; e++) {
		if (typeof this._req[e] == "undefined" || typeof this._req[e].r == "undefined" || this._req[e].r.status != "starting") {
			return e;
		}
	}
	return -1;
}, JSJaCHttpBindingConnection.prototype._getHold = function () {
	return this._hold;
}, JSJaCHttpBindingConnection.prototype._getRequestString = function (e, t) {
	var n = {};
	if (this._rid <= this._last_rid && typeof this._last_requests[this._rid] != "undefined") {
		n = this._last_requests[this._rid].xml;
	} else {
		if (e) {
			n = e;
		} else {
			if (this._pQueue.length) {
				var r = this._pQueue[0];
				n = r, this._pQueue = this._pQueue.slice(1, this._pQueue.length);
			}
		}
		n.rid = this._rid, n.sid = this._sid, t && (n.type = "terminate"), this._last_requests[this._rid] = new Object, this._last_requests[this._rid].xml = n, this._last_rid = this._rid;
		for (var i in this._last_requests) {
			this._last_requests.hasOwnProperty(i) && i < this._rid - this._hold && delete this._last_requests[i];
		}
	}
	return n;
}, JSJaCHttpBindingConnection.prototype._getInitialRequestString = function () {
	var e = {hold:this._hold, wait:this._wait, rid:this._rid, custId:this._custId, custType:this._custType, roomId:this._roomId, MD5Pass:this._MD5Pass, ettoken:this._ettoken};
	return e;
}, JSJaCHttpBindingConnection.prototype._getStreamID = function (e) {
	this._timeout = setTimeout(JSJaC.bind(this._process, this), this.getPollInterval());
	return;
}, JSJaCHttpBindingConnection.prototype._getSuspendVars = function () {
	return "host,port,secure,_rid,_last_rid,_wait,_min_polling,_inactivity,_hold,_last_requests,_pause".split(",");
}, JSJaCHttpBindingConnection.prototype._handleInitialResponse = function (e) {
	var t = this._req[e].r.responseJson;
	if (!t) {
		this._handleEvent("onerror", JSJaCError("500", "wait", "internal-service-error"));
		return;
	}
	if (t.type == "terminate") {
		clearTimeout(this._timeout), this._connected = !1, this._handleEvent("onerror", JSJaCError(t.errorcode, "cancel", "auth-service-fail", t.errorlog)), this.oDbg.log("Disconnected.", 1), this._handleEvent("ondisconnect", "terminate:\n");
		return;
	}
	this._sid = t.sid, t.polling && (this._min_polling = t.polling), t.inactivity && (this._inactivity = t.inactivity), t.requests && this._setHold(t.requests - 1), t.maxpause && (this._pause = Number.max(t.maxpause, JSJACHBC_MAXPAUSE)), this.setPollInterval(this._timerval), this._connected = !0, this._inQto = setInterval(JSJaC.bind(this._checkInQ, this), JSJAC_CHECKINQUEUEINTERVAL), this._interval = setInterval(JSJaC.bind(this._checkQueue, this), JSJAC_CHECKQUEUEINTERVAL), this._getStreamID(null), this._handleEvent("onconnect");
}, JSJaCHttpBindingConnection.prototype._parseResponse = function (e) {
	if (!this.connected() || !e) {
		return null;
	}
	var t = e.r;
	try {
		if (t.status != "success" || !t.responseJson) {
			return this._errcnt++, this._errcnt > JSJAC_ERR_COUNT ? (this._abort(), null) : (this._setStatus("proto_error_fallback"), setTimeout(JSJaC.bind(this._resume, this), this.getPollInterval()), null);
		}
	}
	catch (n) {
		return this._errcnt++, this._errcnt > JSJAC_ERR_COUNT ? this._abort() : (this._setStatus("proto_error_fallback"), setTimeout(JSJaC.bind(this._resume, this), this.getPollInterval())), null;
	}
	var r = t.responseJson;
	if (typeof e.rid != "undefined" && this._last_requests[e.rid]) {
		if (this._last_requests[e.rid].handled) {
			return this.oDbg.log("already handled " + e.rid, 2), null;
		}
		this._last_requests[e.rid].handled = !0;
	}
	return r.type == "terminate" ? (clearTimeout(this._timeout), clearInterval(this._interval), clearInterval(this._inQto), this._connected = !1, this._handleEvent("ondisconnect", "session terminated:\n"), null) : (this._errcnt = 0, t.responseJson);
}, JSJaCHttpBindingConnection.prototype._reInitStream = function (e, t, n) {
	this._reinit = !0, t.call(this, n);
}, JSJaCHttpBindingConnection.prototype._resume = function () {
	this._pause == 0 && this._rid >= this._last_rid && (this._rid = this._last_rid - 1), this._process();
}, JSJaCHttpBindingConnection.prototype._setHold = function (e) {
	return !e || isNaN(e) || e < 0 ? e = 0 : e > JSJACHBC_MAX_HOLD && (e = JSJACHBC_MAX_HOLD), this._hold = e, this._hold;
}, JSJaCHttpBindingConnection.prototype._setupRequest = function (e, t) {
	var n = new Object, r = this;
	return n.r = {url:this._httpbase, dataType:"jsonp", data:"", jsonp:"callback", success:function (e, n) {
		r._req[t].r.finishflags = !0, r._req[t].r.status = "success", r._req[t].r.responseJson = e, this.onreadystatechange();
	}, onreadystatechange:function () {
	}, type:"get", async:e, onerror:function () {
		r._req[t].r.finishflags = !0;
	}, finishflags:!1, status:"starting", error:function (e, n, i) {
		r._req[t].r.finishflags = !0, r._req[t].r.status = n, this.onerror();
	}, timeout:this._wait * 1000 + 10000, send:function (e) {
		this.data = e, jQuery.ajax(this);
		if (this.async == 0 && this.dataType == "jsonp") {
			var t = 0, n = (new Date).getTime();
			for (; t < 5; t++) {
				if (this.finishflags) {
					break;
				}
				jQuery.ajax({type:"GET", url:"htmlsssss.html", async:!1, dataType:"html", success:function () {
				}, error:function () {
				}});
				if (this.finishflags) {
					break;
				}
				if ((new Date).getTime() - n > 1000) {
					break;
				}
			}
		}
	}}, this._rid++, n.rid = this._rid, n;
}, JSJaCHttpBindingConnection.prototype._suspend = function () {
	if (this._pause == 0) {
		return;
	}
	var e = this._getFreeSlot();
	this._req[e] = this._setupRequest(!1, e);
	var t = {};
	if (this._pQueue.length) {
		var n = this._pQueue[0];
		t = n, this._pQueue = this._pQueue.slice(1, this._pQueue.length);
	}
	t.pause = this._pause, t.sid = this._sid, t.rid = this._rid, this._req[e].r.send(t);
};
var JSJaC = {Version:"$Rev: 456 $", require:function (e) {
	document.write("<script type=\"text/javascript\" src=\"" + e + "\"></script>");
}, load:function () {
	var e = ["xmlextras", "jsextras", "crypt", "JSJaCConfig", "JSJaCConstants", "JSJaCCookie", "JSJaCJSON", "JSJaCJID", "JSJaCBuilder", "JSJaCPacket", "JSJaCError", "JSJaCKeys", "JSJaCConnection", "JSJaCHttpPollingConnection", "JSJaCHttpBindingConnection", "JSJaCConsoleLogger"], t = document.getElementsByTagName("script"), n = "./";
	for (var r = 0; r < t.length; r++) {
		if (t.item(r).src && t.item(r).src.match(/JSJaC\.js$/)) {
			n = t.item(r).src.replace(/JSJaC.js$/, "");
			break;
		}
	}
	for (var r = 0; r < e.length; r++) {
		this.require(n + e[r] + ".js");
	}
}, bind:function (e, t, n) {
	return function () {
		n ? e.apply(t, n) : e.apply(t);
	};
}};
typeof JSJaCConnection == "undefined" && JSJaC.load();
var remotecsswebroom = {datetimeFormat:function (e) {
	return ~~e < 10 ? "0" + e : e;
}, getDatetime:function () {
	var e = new Date, t = e.getFullYear() + "-" + e.getMonth() + "-" + e.getDate();
	return t = " " + this.datetimeFormat(e.getHours()) + ":" + this.datetimeFormat(e.getMinutes()) + ":" + this.datetimeFormat(e.getSeconds()), t;
}, sendRoomMsg:function (e, t, n) {
	if (remotecsswebroom.connection && remotecsswebroom.connection.connected()) {
		if (remotecsswebroom.presence == "1") {
			var r = {};
			r.method = "sendRoomMsg", r.subject = e, r.body = t, r.msgType = n, remotecsswebroom.connection.send(r);
		} else {
			remotecsswebroom.handleFunc.handleTipsInfo != undefined && remotecsswebroom.handleFunc.handleTipsInfo("\u5f53\u524d\u76f4\u64ad\u5ba4\u5df2\u5173\u95ed\u72b6\u6001\uff0c\u4e0d\u80fd\u53d1\u9001\u6d88\u606f\uff01");
		}
	} else {
		remotecsswebroom.handleFunc.handleTipsInfo != undefined && remotecsswebroom.handleFunc.handleTipsInfo("\u60a8\u5c1a\u672a\u767b\u9646\u6210\u529f\u6216\u5df2\u6389\u7ebf\uff0c\u4e0d\u80fd\u53d1\u9001\u6d88\u606f\uff01");
	}
}, setRoomPresence:function (e) {
	if (remotecsswebroom.connection && remotecsswebroom.connection.connected()) {
		if (remotecsswebroom.isRoomAdmin == "1") {
			var t = {};
			t.method = "setRoomPresence", t.presence = e, remotecsswebroom.connection.send(t);
		} else {
			remotecsswebroom.handleFunc.handleTipsInfo != undefined && remotecsswebroom.handleFunc.handleTipsInfo("\u60a8\u4e0d\u662f\u8be5\u76f4\u64ad\u5ba4\u4e3b\u64ad\uff0c\u4e0d\u80fd\u4fee\u6539\u72b6\u6001\uff01");
		}
	} else {
		remotecsswebroom.handleFunc.handleTipsInfo != undefined && remotecsswebroom.handleFunc.handleTipsInfo("\u60a8\u5c1a\u672a\u767b\u9646\u6210\u529f\u6216\u5df2\u6389\u7ebf\uff0c\u4e0d\u80fd\u4fee\u6539\u72b6\u6001\uff01");
	}
}, isConnectSuccess:function () {
	return remotecsswebroom.connection && remotecsswebroom.connection.connected() ? !0 : !1;
}, getRoomPresence:function () {
	return remotecsswebroom.presence;
}, handleMessage:function (e) {
	remotecsswebroom.handleFunc.handleMessage != undefined && remotecsswebroom.handleFunc.handleMessage(e);
}, handlePresence:function (e) {
	remotecsswebroom.presence = e.status, e.isRoomAdmin != undefined ? (remotecsswebroom.isRoomAdmin = e.isRoomAdmin, remotecsswebroom.handleFunc.handlePersonInfo != undefined && remotecsswebroom.handleFunc.handlePersonInfo(e.status, e.username, e.isRoomAdmin == "1")) : remotecsswebroom.handleFunc.handlePresence != undefined && remotecsswebroom.handleFunc.handlePresence(e.status, e.username, e.isRoomAdmin == "1");
}, handleFunc:{}, isneedlogout:!1, connectionTimehandle:null, logout:function () {
	remotecsswebroom.connectionTimehandle != undefined && remotecsswebroom.connectionTimehandle != null && (clearTimeout(remotecsswebroom.connectionTimehandle), remotecsswebroom.connectionTimehandle = null), remotecsswebroom.connection && remotecsswebroom.isneedlogout && remotecsswebroom.connection.disconnect();
}, errorHandler:function (e) {
	return remotecsswebroom.connection && remotecsswebroom.connection.connected() && remotecsswebroom.connection.disconnect(), !1;
}, unloadHandler:function () {
	var e = remotecsswebroom.connection;
	typeof e != "undefined" && e && e.connected() && e.suspend && e.suspend();
}, handleConnected:function () {
	remotecsswebroom.handleFunc.handleConnected != undefined && remotecsswebroom.handleFunc.handleConnected();
}, handleDisconnected:function (e) {
	var t = "\u60a8\u79bb\u7ebf\u4e86!";
	e && (~e.indexOf("internal_server_error") ? ~e.indexOf("conflict") ? t = "\u60a8\u5728\u5176\u5b83\u5730\u65b9\u767b\u5f55,\u88ab\u8feb\u79bb\u7ebf\u4e86\uff01" : t = "\u670d\u52a1\u5668\u5173\u95ed\u94fe\u63a5,\u60a8\u79bb\u7ebf\u4e86\uff01" : ~e.indexOf("aborted") ? html = "\u7f51\u7edc\u5f02\u5e38,\u60a8\u79bb\u7ebf\u4e86!" : ~e.indexOf("disconnect") && (html = "\u60a8\u767b\u51fa\u76f4\u64ad\u5ba4")), remotecsswebroom.presence = "0", remotecsswebroom.handleFunc.handleDisconnected != undefined && remotecsswebroom.handleFunc.handleDisconnected(html);
}, handleError:function (e) {
	var t = e || window.event, n = "";
	switch (t.getAttribute("code")) {
	  case "401":
		n = t.getAttribute("content");
		break;
	  case "402":
		n = "\u76f4\u64ad\u5ba4ID\u4e0d\u5b58\u5728";
		break;
	  case "503":
		n = "\u65e0\u6cd5\u8fde\u63a5\u5230IM\u670d\u52a1\u5668\uff0c\u8bf7\u68c0\u67e5\u76f8\u5173\u914d\u7f6e\uff01";
		break;
	  case "500":
		var n = "\u670d\u52a1\u5668\u5185\u90e8\u9519\u8bef\uff01\u8fde\u63a5\u65ad\u5f00\uff01\u91cd\u65b0\u8fde\u63a5";
		break;
	  default:
	}
	remotecsswebroom.handleFunc.handleError != undefined && remotecsswebroom.handleFunc.handleError(t.getAttribute("code"), t.getAttribute("type"), t.firstChild.nodeName, n), remotecsswebroom.connection.connected() && remotecsswebroom.connection.disconnect();
}, loginXmpp:function (e, t, n) {
	try {
		e.httpdomain = e.httpdomain, e.httpbase = e.httpdomain + "/WebIM/roomlogin", e.ettoken = t;
		var r = new JSJaCHttpBindingConnection(e);
		remotecsswebroom.connectionConfig = e, remotecsswebroom.connection = r, r.registerHandler("message", remotecsswebroom.handleMessage), r.registerHandler("presence", remotecsswebroom.handlePresence), r.registerHandler("onconnect", remotecsswebroom.handleConnected), r.registerHandler("ondisconnect", remotecsswebroom.handleDisconnected), r.registerHandler("onerror", remotecsswebroom.handleError), n == undefined && (n = 5000), n < 1000 && (n = 1000), remotecsswebroom.connectionTimehandle = setTimeout(function () {
			remotecsswebroom.isneedlogout = !0, remotecsswebroom.connection.connect(remotecsswebroom.connectionConfig);
		}, n);
	}
	catch (i) {
	}
	finally {
		return !1;
	}
}};
window.onunload = aaa;



