var BASE64 = {
utf16to8:function (str) {
	var out, i, len, c;
	out = "";
	len = str.length;
	for (i = 0; i < len; i++) {
		c = str.charCodeAt(i);
		if ((c >= 1) && (c <= 127)) {
			out += str.charAt(i);
		} else {
			if (c > 2047) {
				out += String.fromCharCode(224 | ((c >> 12) & 15));
				out += String.fromCharCode(128 | ((c >> 6) & 63));
				out += String.fromCharCode(128 | ((c >> 0) & 63));
			} else {
				out += String.fromCharCode(192 | ((c >> 6) & 31));
				out += String.fromCharCode(128 | ((c >> 0) & 63));
			}
		}
	}
	return out;
}, utf8to16:function (str) {
	var out, i, len, c;
	var char2, char3;
	out = "";
	len = str.length;
	i = 0;
	while (i < len) {
		c = str.charCodeAt(i++);
		switch (c >> 4) {
		  case 0:
		  case 1:
		  case 2:
		  case 3:
		  case 4:
		  case 5:
		  case 6:
		  case 7:
			out += str.charAt(i - 1);
			break;
		  case 12:
		  case 13:
			char2 = str.charCodeAt(i++);
			out += String.fromCharCode(((c & 31) << 6) | (char2 & 63));
			break;
		  case 14:
			char2 = str.charCodeAt(i++);
			char3 = str.charCodeAt(i++);
			out += String.fromCharCode(((c & 15) << 12) | ((char2 & 63) << 6) | ((char3 & 63) << 0));
			break;
		}
	}
	return out;
}, enKey:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/", deKey:new Array(-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 62, -1, -1, -1, 63, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, -1, -1, -1, -1, -1, -1, -1, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, -1, -1, -1, -1, -1, -1, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, -1, -1, -1, -1, -1), 
encode:function (src) {
	src = this.utf16to8(src);
	var str = new Array();
	var ch1, ch2, ch3;
	var pos = 0;
	while (pos + 3 <= src.length) {
		ch1 = src.charCodeAt(pos++);
		ch2 = src.charCodeAt(pos++);
		ch3 = src.charCodeAt(pos++);
		str.push(this.enKey.charAt(ch1 >> 2), this.enKey.charAt(((ch1 << 4) + (ch2 >> 4)) & 63));
		str.push(this.enKey.charAt(((ch2 << 2) + (ch3 >> 6)) & 63), this.enKey.charAt(ch3 & 63));
	}
	if (pos < src.length) {
		ch1 = src.charCodeAt(pos++);
		str.push(this.enKey.charAt(ch1 >> 2));
		if (pos < src.length) {
			ch2 = src.charCodeAt(pos);
			str.push(this.enKey.charAt(((ch1 << 4) + (ch2 >> 4)) & 63));
			str.push(this.enKey.charAt(ch2 << 2 & 63), "=");
		} else {
			str.push(this.enKey.charAt(ch1 << 4 & 63), "==");
		}
	}
	return str.join("");
}, decode:function (src) {
	var str = new Array();
	var ch1, ch2, ch3, ch4;
	var pos = 0;
	src = src.replace(/[^A-Za-z0-9\+\/]/g, "");
	while (pos + 4 <= src.length) {
		ch1 = this.deKey[src.charCodeAt(pos++)];
		ch2 = this.deKey[src.charCodeAt(pos++)];
		ch3 = this.deKey[src.charCodeAt(pos++)];
		ch4 = this.deKey[src.charCodeAt(pos++)];
		str.push(String.fromCharCode((ch1 << 2 & 255) + (ch2 >> 4), (ch2 << 4 & 255) + (ch3 >> 2), (ch3 << 6 & 255) + ch4));
	}
	if (pos + 1 < src.length) {
		ch1 = this.deKey[src.charCodeAt(pos++)];
		ch2 = this.deKey[src.charCodeAt(pos++)];
		if (pos < src.length) {
			ch3 = this.deKey[src.charCodeAt(pos)];
			str.push(String.fromCharCode((ch1 << 2 & 255) + (ch2 >> 4), (ch2 << 4 & 255) + (ch3 >> 2)));
		} else {
			str.push(String.fromCharCode((ch1 << 2 & 255) + (ch2 >> 4)));
		}
	}
	return this.utf8to16(str.join(""));
}};

