/*
 * Copyright 2011 Cssweb.
 * @author lipeng
 * Email:lipeng@cssweb.sh.cn
 * 
 */
var OAuth = {
	keyName: "systemuid",
	keyValue: "1001",
	/**	加密串 */
	signKey: "29dlo*%AO+3i16BaweTw.lc!)61K{9^5",
	para: "",
	paraEncode: "",
	/** oauth URL */
	oauthURL: function(url){
		if(url.match("[\=]")){
			url = this.parseURL(url,this.keyName,this.keyValue);
			var sign = this.signatureParameter(url);
			url = this.parseURL(url,'sign',sign);
			url = url.replace(this.para,this.paraEncode);
		}
		return url;
	},
	/** parse URL */
	parseURL: function(url,key,value){
		var pattern = key + "=([^&]*)";
		if(url.match(pattern)){
			url = this.replaceParameter(url,key,value);
		}else{
			url = this.appendParameter(url,key,value);
		}
		return url;
	},
	/** append Parameter **/
	appendParameter: function(url,key,value){
		if(url.match("[\?]")){
			url += "&" + key + "=" + value;
		}else{
			url += "?" + key + "=" + value;
		}
		return url;
	},
	/** parameter To Array **/
	parameterToArray: function(url){
		var sliceURL = url.slice(url.indexOf("?")+1);
		var ary = null;
		if(sliceURL != ""){
			ary = sliceURL.split("&");
		}
		return ary;
	},
	/** replace Parameter **/
	replaceParameter: function(url,key,value){
		var sliceURL = url.slice(url.indexOf("?")+1);
		var ary = this.parameterToArray(url);
		if(ary != null){
			for(var i=0;i<ary.length;i++){
				if(ary[i].match(key)){
					ary[i] = key + "=" + this.encode(value);
					break;
				}
			}
			url = url.replace(sliceURL,ary.join("&"));
		}
		return url;
	},
	/** signature Parameter **/
	signatureParameter: function(url){
		var ary = this.parameterToArray(url);
		if(ary != null){
			var pos, paraName, paraValue;
			var signAry = new Array();
			for(var i=0; i<ary.length; i++){
				pos = ary[i].indexOf('=');         
				if(pos == -1) {
					continue; 
				}         
				paraName = ary[i].substring(0, pos);         
				paraValue = ary[i].substring(pos + 1);
				if(paraName != "method"){
					if(paraValue != null && paraValue != ""){
						var vo = [paraName,paraValue];
						signAry.push(vo);
					}
				}
			}
			var string = this.generateSignature(signAry);
			return string;
		}
	},
	/** get a sign Parameter,use in ext beforerequest event**/
	getSignatureParameter: function(uri, param){
		if('' != param && null != param && undefined != param){
			if(uri.match("[\?]")){
				uri = uri + "&" + param;
			}else{
				uri = uri + "?" + param;
			}
		}		
		var uri = this.oauthURL(uri);
		uri = uri.slice(uri.indexOf("?")+1);
		return uri;		
	},		
	/** generate Parameter **/
	generateSignature: function(ary){
		this.setPara(ary);
		var encodeString = this.sortEncode(ary);
		var fun = Crypto.SHA1;
		var hmac = Crypto.HMAC(fun,encodeString,this.signKey,{asBytes: true}); 
		var res = "";
		for(var i=0;i<hmac.length;i++){
			res = res + hmac[i].toString(16);
		}
		res = BASE64.encode(res);
		return res;
	},
	/** sort and encode */
	sortEncode: function(ary){
		ary.sort();
		var para = "";
		for(var i=0;i<ary.length;i++){
			para += ary[i][0] + "=" + this.encode(ary[i][1]);
			if(i != ary.length -1){
				para += "&";
			}
		}
		para += "&" + this.encode("key");
		para += "=" + this.encode(this.signKey);
		para = this.replaceAll(para,"&","%26");
		para = this.replaceAll(para,"=","%3D");
		return para;
	},
	/** set para */
	setPara: function(ary){
		var para = "";
		var paraEncode = "";
		for(var i=0;i<ary.length;i++){
			para += ary[i][0] + "=" + ary[i][1];
			paraEncode += ary[i][0] + "=" + this.encode(ary[i][1]);
			if(i != ary.length -1){
				para += "&";
				paraEncode += "&";
			}
		}
		this.para = para;
		this.paraEncode = paraEncode;
	},
	encode: function(str){
		var string = ""
		string = encodeURIComponent(str);
		string = string.replace(/!/g,"%21");
		string = string.replace(/\*/g,"%2A");
		string = string.replace(/\(/g,"%28");
		string = string.replace(/\)/g,"%29");
		string = string.replace(/\'/g,"%27");
		return string;
	},
	/** create Script */
	createScript: function(fileName){
		document.write("<script type='text/javascript' src='"+ fileName +"'></script>");
	},
	/** replace All */
	replaceAll: function(text,char1,char2){
	  var re = new RegExp(char1,"g");
	  return text.replace(re,char2)
	}
};
/**
OAuth.createScript("oauth/crypto-sha1.js");
OAuth.createScript("oauth/hmac-min.js");
OAuth.createScript("oauth/Base64.js");
*/
